function CheckATagSpanChildElement(obj)
{
    var node = obj.FindInsertNode();
    var bNotHighLight = false;
    if (node && node.childNodes) {
        for (var i = 0; i < node.childNodes.length; ++i) {
            var aChild = node.childNodes[i];
            if (aChild &&
                aChild.tagName &&
                aChild.tagName.toUpperCase() == 'CITE') {
                bNotHighLight = true;
                break;
            }
        }
    }

    node.NotHighLight = bNotHighLight;
}

function filterbyHref(url)
{
    var ptnLinkedin = [
                'http://www.bing.com/search?'
              ];
    for (var j = 0; j < ptnLinkedin.length; j++)
    {
        ptn = new RegExp(ptnLinkedin[j], 'i');
        if (ptn.test(url))
        {
            return true;
        }
    }
    return false;
}

function TSRMSNModifyCSS(objResult, marginLeft)
{
    // for Yahoo English case, advertisement would blokc whole line
    var objInsertNode = objResult.FindInsertNode();
    if (objInsertNode && objInsertNode.style)
    {
        objResult.spanIcon = document.createElement('SPAN');
        var objTMDom = new TMDOMObj(objResult.spanIcon);
        objTMDom.style.setFloat('left');

        var InsertNodeMarginLeft =
            marginLeft + parseInt(D_GAP_BETWEEN_ICON_TITLE);
        objInsertNode.style.marginLeft = InsertNodeMarginLeft + 'px';
    }
}

/*
 * Callback function, Because MSN would use JS to
 * modity its DOM object so that the parsed node
 * could not exist. We need to find it again
 * when we want to insert rating result.
 */
function TSSRMSNFindInsertNode()
{
    var objNode = this.node;
    if (this.baseNode && this.baseNode.firstChild)
    {
        if (this.baseNode.firstChild.nodeName == 'SPAN')
        {
            var baseNode = this.baseNode.firstChild;
            var objH3Nodes = baseNode.getElementsByTagName('H3');

            if (1 == objH3Nodes.length)
            {
                objNode = objH3Nodes[0];
            }
        }
    }
    return objNode;
}

function TSSRMSNLiveCutPrefixURL(strURL)
{
    var regexTarget = /\s*\-\s+([^\s]+)$/;
    var rgstrMatch = strURL.match(regexTarget);
    return (rgstrMatch && rgstrMatch.length == 2) ? rgstrMatch[1] : strURL;
}

function TSSRMSBingParseNewsResult(rootElement)
{
    // for new url www.bing.com/news/search?.... rating
    var rgobjPath;
    var objSRlNews3 =
        new CreateTSRLocatedObject(null,
                                   null,
                                   'a',
                                   null);
    var objSRlNews2 =
        new CreateTSRLocatedObject(null,
                                   objSRlNews3,
                                   'DIV',
                                   null);
    var objSRNewsResult =
        new CreateTSRLocatedObject(objSRNews,
                                   objSRlNews2,
                                   'DIV',
                                   null);
    var objSRNews =
        new CreateTSRLocatedObject(rootElement,
                                   objSRNewsResult,
                                   'DIV',
                                   'sw_main');
    objSRNewsResult.multiMatches = true;
    objSRNewsResult.appendAttribute('class', 'NewsResultSet');
 objSRlNews2.multiMatches = true;
 objSRlNews2.appendAttribute('class', 'sn_r');
    if ((rgobjPath = objSRNews.findElement()))
    {
        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

function TSSRMSBingParseLatestNews(rootElement)
{
    // for new url www.bing.com/news/search?.... rating
    var rgobjPath;
    var objSRlNews3 = new CreateTSRLocatedObject(null,
                                                 null,
                                                 'a',
                                                 null);
    var objSRlNews2 = new CreateTSRLocatedObject(null,
                                                 objSRlNews3,
                                                 'DIV',
                                                 null);
    var objSRNewsResult = new CreateTSRLocatedObject(objSRNews,
                                                     objSRlNews2,
                                                     'DIV',
                                                     null);
    var objSRNews = new CreateTSRLocatedObject(rootElement,
                                               objSRNewsResult,
                                               'DIV',
                                               'sw_main');
    objSRNewsResult.multiMatches = true;
    objSRNewsResult.appendAttribute('class', 'sn_latest');
 objSRlNews2.multiMatches = true;
 objSRlNews2.appendAttribute('class', 'sn_art');
    if ((rgobjPath = objSRNews.findElement()))
    {
        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}



/*
 * Parse search result
 */
function TSSRMSBingParseResult_H3(rootElement)
{
    var objSRl2 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRl1 = new CreateTSRLocatedObject(null, objSRl2, 'H3', null);
    var objSR = new CreateTSRLocatedObject(rootElement,
                                           objSRl1,
                                           'DIV',
                                           'results');

    objSRl1.multiMatches = true;
    objSRl2.multiMatches = false;

    var rgobjPath;
    if ((rgobjPath = objSR.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

function TSSRMSBingParseResult_H2(rootElement)
{
    var objSRl2 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRl1 = new CreateTSRLocatedObject(null, objSRl2, 'H2', null);
    var objSR = new CreateTSRLocatedObject(rootElement,
                                           objSRl1,
                                           'DIV',
                                           'results');

    objSRl1.multiMatches = true;

    var rgobjPath;
    if ((rgobjPath = objSR.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

/*
 * Parse Sidebar Sponsor
 */
function TSSRMSBingParseSidebarSponsor(rootElement)
{
    var objSRSSl2 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRSSl1 = new CreateTSRLocatedObject(null,
                                               objSRSSl2,
                                               'DIV',
                                               null);
    var objSRSS = new CreateTSRLocatedObject(rootElement,
                                             objSRSSl1,
                                             'DIV',
                                             'sidebar');

    objSRSSl1.appendAttribute('class', '^sb_adsN');

    var rgobjPath;
    if ((rgobjPath = objSRSS.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

/*
 * Parse Top Sponsor
 */
function TSSRMSBingTopSponsor(rootElement)
{
    var objSRTSl4 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTSl3 = new CreateTSRLocatedObject(null,
                                               objSRTSl4,
                                               'li',
                                               null);
    var objSRTSl2 = new CreateTSRLocatedObject(null,
                                               objSRTSl3,
                                               'ul',
                                               null);
    var objSRTSl1 = new CreateTSRLocatedObject(null,
                                               objSRTSl2,
                                               'DIV',
                                               null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSl1,
                                             'DIV',
                                             'results_container');

    objSRTSl1.appendAttribute('class', '^sb_adsW');
    objSRTSl1.multiMatches = true;
    objSRTSl2.multiMatches = true;
    objSRTSl3.multiMatches = true;
    objSRTSl4.multiMatches = false;

    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {
        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

/*
 * Parse Top Sponsor
 */
function TSSRMSBingTopSponsor2(rootElement)
{
    var objSRTSl4 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTSl3 = new CreateTSRLocatedObject(null,
                                               objSRTSl4,
                                               'H3',
                                               null);
    var objSRTSl2 = new CreateTSRLocatedObject(null,
                                               objSRTSl3,
                                               'DIV',
                                               null);
    var objSRTSl1 = new CreateTSRLocatedObject(null,
                                               objSRTSl2,
                                               'DIV',
                                               null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSl1,
                                             'DIV',
                                             'results_container');

    objSRTSl1.appendAttribute('class', 'sb_adsWv2');
    objSRTSl1.multiMatches = true;
    objSRTSl2.appendAttribute('class', 'sb_add sb_adW');
    objSRTSl2.multiMatches = true;
    objSRTSl3.multiMatches = true;
    objSRTSl4.multiMatches = false;

    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {
        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

/*
 * Parse Bing News
 */
function TSSRMSBingBingNews(rootElement)
{
    var objSRTSl2 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTSl1 = new CreateTSRLocatedObject(null,
                                               objSRTSl2,
                                               'DIV',
                                               null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSl1,
                                             'DIV',
                                             'results_area');
    objSRTSl1.appendAttribute('class', 'ans_art');

    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

function TSSRMSBingBingNews2(rootElement)
{
    var objSRTSl2 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTSl1 = new CreateTSRLocatedObject(null,
                                               objSRTSl2,
                                               'h2',
                                               null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSl1,
                                             'OL',
                                             'b_results');
    objSRTSl1.multiMatches = true;
    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

/*
 * Parse Top Ads
 */
function TSSRMSBingTopAds(rootElement)
{
    var objSRTSl2 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTSl1 = new CreateTSRLocatedObject(null,
                                               objSRTSl2,
                                               'span',
                                               null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSl1,
                                             'DIV',
                                             'results_container');
    objSRTSl1.appendAttribute('class', 'sx_b');

    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            if (!filterbyHref(rgNodes[iCount].href))
            {
                CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
            }
        }
    }
}

/*
 * Parse Bottom Ads
 */
function TSSRMSBingBottomAds(rootElement)
{
    var objSRTSl2 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTSl1 = new CreateTSRLocatedObject(null,
                                               objSRTSl2,
                                               'DIV',
                                               null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSl1,
                                             'DIV',
                                             'results_container');

    objSRTSl1.appendAttribute('class', '^sb_adsW sb_adsW2');
    objSRTSl1.multiMatches = true;

    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

/*
 * Parse Result Item Detail
 */
function TSSRMSBingResultItemDetail(rootElement)
{
    var objSRTSl1 = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSl1,
                                             'DIV',
                                             null);

    objSRTS.appendAttribute('class', '^sb_vdl');
    objSRTS.multiMatches = true;

    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
            CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href, null, null, null, true);
        }
    }
}

function TSSRMSBingDeepLinks(rootElement) {
    var objSRTSA = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSA,
                                             'DIV',
                                             null);
    objSRTS.multiMatches = true;
    objSRTSA.multiMatches = true;
    objSRTS.appendAttribute("class", "b_deep");
    
    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {

        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
             CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href);
        }
    }
}

function TSSRMSBingComponents(rootElement) {
    var objSRTSA = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSA,
                                             'DIV',
                                             null);
    objSRTS.multiMatches = true;
    objSRTSA.multiMatches = true;
    objSRTS.appendAttribute("class", "^bm_ctn");
    
    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {
        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
             CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href);
        }
    }
}


function TSSRMSBingHeaderRelated(rootElement) {
    var objSRTSA = new CreateTSRLocatedObject(null, null, 'A', null);
    var objSRTS = new CreateTSRLocatedObject(rootElement,
                                             objSRTSA,
                                             'DIV',
                                             null);
    objSRTSA.multiMatches = true;
    objSRTS.appendAttribute("class", "headerRelated");
    
    var rgobjPath;
    if ((rgobjPath = objSRTS.findElement()))
    {
        var rgNodes = GetAllTSRLocatedNodes(rgobjPath);
        for (var iCount = 0; iCount < rgNodes.length; iCount++)
        {
             CreateTSRResultObject(rgNodes[iCount], rgNodes[iCount].href);
        }
    }
}

g_bIsNeedCheckSPan = true;
TSRTagFlowID();
function TSRParse()
{
    var oldLength = g_oEnv.Parser.iResultNumber;
    if (TrendMicro.TB.DOMIdExist('results')) {
        TSSRMSBingParseResult_H2(document);
        TSSRMSBingParseResult_H3(document);
    }
    if (TrendMicro.TB.DOMIdExist('sw_main')) {
        TSSRMSBingParseNewsResult(document);
        TSSRMSBingParseLatestNews(document);
    }
    if (TrendMicro.TB.DOMIdExist('sidebar'))
    TSSRMSBingParseSidebarSponsor(document);

    if (TrendMicro.TB.DOMIdExist('results'))
    TSSRMSBingBingNews(document);

    if (TrendMicro.TB.DOMIdExist('b_results'))
    TSSRMSBingBingNews2(document);

    if (TrendMicro.TB.DOMIdExist('results_container')) {
        TSSRMSBingTopAds(document);
        TSSRMSBingTopSponsor2(document);
        TSSRMSBingTopSponsor(document);
    }
    
    TSSRMSBingHeaderRelated(document);
    TrendMicro.TB.ReduceNewNode(oldLength + 1);
    
    //TSSRMSBingComponents(document);
    TSSRMSBingDeepLinks(document);
    
    for (var iCount = 1;
     iCount < g_oEnv.Parser.rgobjSearchResult.length;
     iCount++)
    {
        if (g_oEnv.Parser.rgobjSearchResult[iCount]) {
            CheckATagSpanChildElement(g_oEnv.Parser.rgobjSearchResult[iCount]);
        }
    }

    return g_oEnv.Parser.rgobjSearchResult;
}

