(function() {
  let fetchApiArray = [];
  let reasonResult = {};
  var g_show_tooltip = 0;
  var g_iat = 0;
  var g_email = "";

  var i18n = fb_i18n.getMessage;
  var sendMessage = fb_sendMessage;
  var getURL = fb_getURL;
  
  var beta_url = fb_beta_url;
  var dev_url = fb_dev_url;
  var current_url = fb_current_url;

  var gr_link = fb_gr_link

  var g_device_uid = "fake_device_uid";

  var sendCommand = function(email,type,success){
    g_iat = Date.parse(new Date())/1000;
    let data = {type:type,email:email,iat:g_iat};
    //need change
    sendMessage({cmd: 'send_command',params:data}).then(function(rep){
      if(rep && typeof(success) == "function"){
        success(rep);
      }else{
        console.log(`[FraudBuster]sendCommand failure:${chrome.runtime.lastError}`);
      }
    });
  }

  function scanEmail(){
    if(g_email == ""){
      console.log("[FraudBuster]>>wating for user's email.");
      return ;
    }
    let email = g_email;
    sendCommand(email,"fb_setting",function(data){
      console.log("[FraudBuster]>>user config is:"+JSON.stringify(data));
      if(typeof(data.ShowTooltip) != "undefined"){
        g_show_tooltip = data.ShowTooltip;
      }
      if(typeof(data.GUID) != "undefined" 
        && typeof(data.seed)!="undefined"){
        g_device_uid = hex_md5(`${data.GUID}${data.seed}`);
      }

      if(data.EnableFraudBuster){
        if(typeof(data.Secret) != "undefined"){
          autoScanAndGenerateScanBtn(data.Secret);
        }else{
          sendCommand(email,"fb_get_secret",function(secret){
            autoScanAndGenerateScanBtn(secret);
          })
        }
      }else if(!data.EnableFraudBuster){
        if(!data.ShowPromotion){
          let tooltip1 = "";
          let tooltip2 = "";
          if(!isJP()){
            tooltip1 = i18n("fraud_buster_promotion_and_dcn_tooltip1");
            tooltip2 = i18n("fraud_buster_promotion_and_dcn_tooltip2");
          }
          promotion_modal.init({
            getURL:getURL,
            turnOn:function(){
              if(!data.ShowDCN){
                  //fb_sendMessage({cmd:"fb_show_dcn",email:email});
                  show_dcn(email);
              }else{
                sendCommand(email,"fb_enable",function(){
                  console.log("[FraudBuster]>>promotion->enable")
                });
                show_dcn(email,true);
                //fb_sendMessage({cmd:"fb_show_dcn",email:email,showPopUp:true});
              }
            },
            doNotShowAgain:function(){sendCommand(email,"fb_show_promotion")},
            fraud_buster_promotion_title:i18n("fraud_buster_promotion_title"),
            fraud_buster_promotion_description:i18n("fraud_buster_promotion_description"),
            fraud_buster_promotion_btn:i18n("fraud_buster_promotion_btn"),
            fraud_buster_not_now:i18n("fraud_buster_not_now"),
            fraud_buster_promotion_dnsta:i18n("fraud_buster_promotion_dnsta"),
            fraud_buster_promotion_and_dcn_tooltip1:tooltip1,
            fraud_buster_promotion_and_dcn_tooltip2:tooltip2,
            learn_more_link:gr_link,
          });
          promotion_modal.open();
        }
        console.log("[Fraud Buster]not be enable");
      }
    });
  }

  function prepareJWTToken(secret){
    let nbf = g_iat;
    let exp = g_iat + 60;
    let iss = "MCB0"
    let aud = "fma"
    let jwt = window.jwt;
    let payload = {iat:g_iat, nbf: nbf, exp:exp, iss: iss, aud:aud}
    return jwt.sign(payload, secret, {algorithm: 'HS512'});
    //return "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJpYXQiOjE1NTQ5NjUzODMsIm5iZiI6MTU1NDk2NTM4MywiZXhwIjoxNTY3MjYzNjAwLCJpc3MiOiJGSVQwIiwiYXVkIjoiZm1hIn0.5DI1sC-mSpRMHhm6CiMZpoVPZu7qFAYZLdBuMucjbsm0X9yfwOHN5ehxoCNYMz1Pr3Vrh82eXIan1Y1QUPo3sQ";
  }

  function mutationConstructCBK(mutations){
    mutations.some(function(mutation) {
      if(mutation.target.getAttribute("role") == "main" && mutation.target.children.length == 1) {
        var mailId = mutation.target.querySelector("div[data-message-id").getAttribute("data-message-id");
        console.log("[FraudBuster] mail:", mailId , " is opened");
        modal.close();
        scanEmail();
        return true;
      }
    });
  }

  function addObserveIfNodeAvailable() {
    let target = document.querySelector(".AO");
    if(target){
      let config = {childList: true, subtree: true, attributeFilter :["role"] };

      let observer = new MutationObserver(mutationConstructCBK);
      observer.observe(target, config);
    }else{
      console.log("[FraudBuster]Can't find \".AO\"");
    }
  }

  function fetchSecurityScan(secret ,callback, reject) {

    let mailId = document.querySelector("div[data-message-id").getAttribute("data-message-id");

    let emailContent = $("[role='main']").html();

    // 1. compress
    let compressed_content = pakoCompress(emailContent);

    // 2. base 64 encode
    let compressEncode = btoa(compressed_content);

    // 3. encrypt
    let encrypted = AES256Encrypt(compressEncode,secret);

    // TODO: GET API DATA
    
    let data = {
      "message_id": mailId,
      "device_uid": g_device_uid,
      "email_type": location.hostname == 'mail.google.com' ? "0" : "1",
      "email_content": encrypted,
      "email_hash": hex_md5(g_email),
      "encoded":true
    };
    console.log("[FraudBuster]>>post data:"+JSON.stringify(data));

   // let headJwtToken = "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJpYXQiOjE1NTQ5NjUzODMsIm5iZiI6MTU1NDk2NTM4MywiZXhwIjoxNTY3MjYzNjAwLCJpc3MiOiJGSVQwIiwiYXVkIjoiZm1hIn0.5DI1sC-mSpRMHhm6CiMZpoVPZu7qFAYZLdBuMucjbsm0X9yfwOHN5ehxoCNYMz1Pr3Vrh82eXIan1Y1QUPo3sQ";
    let headJwtToken = prepareJWTToken(secret);
    console.log("[FraudBuster]>>jwtToken is :"+headJwtToken);
    
    var url = `${current_url}/api/v1/security_scan`;

    fetch(url, {
      method: 'POST',
      body: JSON.stringify(data),
      headers: new Headers({
        'Content-Type': 'application/json',
        'Authorization': 'Bearer '+headJwtToken
      }),
      mode: 'cors'
    }).then(function(res){
      if (res.status < 400) {
        return res.json();
      }else{
        var error = new Error("Bad response from server");
        error.code = res.status;
        error.response = res;
        throw error;
      }
    })
    .then(function(response){
      console.log("[FraudBuster]>>server response is:"+JSON.stringify(response));
      callback(response);
    })
    .catch(function(error){
      reject(error);
    });
  }

   function autoScanAndGenerateScanBtn(secret) {
    if(location.hash.indexOf("/") <= -1  ){
        return ;
    }
    $(".trendBtn").remove();
    fetchApiArray.push('');
    const length = fetchApiArray.length;
    fetchSecurityScan(secret,function(response) {
      if(length == fetchApiArray.length && location.hash.indexOf("/") > -1) {
        let scanBtn = i18n("fraud_buster_scan_btn");
        let toolTip1 = i18n("fraud_buster_tooltip1");
        let toolTip2 = i18n("fraud_buster_tooltip2");
        $(".amn").append(`<div class="fb_scanContainer">
                              <span role="link" class="ams scanBtn trendBtn">${scanBtn}</span>
                          </div>`);

        if(!g_show_tooltip){
          $(".fb_scanContainer").append(`<div class="fb_msgTooltip ${getCurrentLocale()}">
                             <button class="tooltip-close">&times;</button>
                                    ${toolTip1}
                                    <br/>
                                    ${toolTip2}
                                  </div>`);
          $('.tooltip-close').click(() => {
            $(`.fb_msgTooltip.${getCurrentLocale()}`).remove();
          });
          sendCommand(g_email,"fb_show_tooltip",function(data){});
        }
        let headJwtToken = prepareJWTToken(secret)
        $(".scanBtn").click(function() {
          showSecurityReason(reasonResult,headJwtToken);
        });
         
        if(response.predict_result === 10) {
          generateToast(response,headJwtToken);
        }

        fetchApiArray = [];
        reasonResult = response;
      }
    }, function(error) {
      console.log("[FraudBuster]"+error.response);
      if(error.code == 412){
        let L10n_languageNotSupport = i18n("fraud_buster_language_not_support");
        if(L10n_languageNotSupport != "N/A"){
          $(".amn").append(`<span role="link" tabindex="0" class="ams errorInfoBtn trendBtn">
                              ${L10n_languageNotSupport}
                              <span class="errorInfoClose">
                          </span>`);
          $(".errorInfoClose").click(function() {
              $(".errorInfoBtn").hide();
          });
        }else{
          console.log("[FraudBuster]>>Email's language not english or japaneses");
        }
      }else{
        console.log("[FraudBuster]>>The server responded with a status of "+error.code);
      }
    });
  }

  function showSecurityReason(scanResult,headJwtToken){
      let device_uid = g_device_uid;
      let display_lang = getCurrentLocaleIETF();
      let email_hash = hex_md5(g_email);
      let security_reason_url = `${current_url}/#result?` + `email_hash=${email_hash}&`+
         `token=${headJwtToken}&device_uid=${device_uid}&cache_token=${scanResult.cache_token}` +
         `&display_lang=${display_lang}&detection_category=${scanResult.detection_category}`;
      sendMessage({cmd: 'fb_open_new_tab',params: {url: security_reason_url}});
  }

  function postUserFeedback(payload,headJwtToken){
    fetch(`${current_url}/api/v1/user_feedback`, {
      method: 'POST',
      body: JSON.stringify(payload),
      headers: new Headers({
        'Content-Type': 'application/json',
        'Authorization': `bearer ${headJwtToken}`
      }),
      mode: 'cors'
      }).then(res => {
        if (res.status < 400 || res.status == 429) {
          return res;
        } else {
          var error = new Error("Bad response from server");
          error.code = res.status;
          throw error;
        }
      })
      .then(response => {
        console.log(response);
      })
      .catch(error => {console.log(error);});
  }

  function generateToast(response,headJwtToken) {
    let title, content,picture = '';
    switch (response.detection_category) {
      case 1:
        title =  i18n("fraud_buster_scam_title");
        content = i18n("fraud_buster_scam_content");
        picture = "img_fma_scam@2x.png";
        break;
      case 2:
        title =  i18n("fraud_buster_phishing_title");
        content = i18n("fraud_buster_phishing_content");
        picture = "img_fma_phishing.png@2x.png";
        break;
      case 3:
        title =  i18n("fraud_buster_suspicious_title");
        content = i18n("fraud_buster_suspicious_content");
        picture = "img_fma_suspicious@2x.png";
        break;
      default:
        title =  i18n("fraud_buster_suspicious_title");
        content = i18n("fraud_buster_suspicious_content");
        picture = "img_fma_suspicious@2x.png";
        break;
    }
    modal.init({
        title: title,
        content: content,
        picture:picture,
        toastActionName: i18n("fraud_buster_view_detail"),
        toastUrlName1: i18n("fraud_buster_urlName1"),
        toastUrlName2: i18n("fraud_buster_urlName2"),
        toastUtlFeedbackName: i18n("fraud_buster_feedback"),
        getURL:getURL,
        locale:getCurrentLocale(),
        actionCallback: function() {
          showSecurityReason(response,headJwtToken);
        },
        urlCallback: function() {
          const data = {
            "device_uid": g_device_uid,
            "cache_token": response.cache_token,
            "feedback": "fp"
          };
          postUserFeedback(data,headJwtToken);
        }
    });
    modal.open();
  }
  

  function AES256Encrypt(plainText,key){
    let aes256 = window.aes256;
    let encrypted = aes256.encrypt(key,plainText);
    return encrypted;
  }

  function AES256Decrypt(encrypted){
    let aes256 = window.aes256;
    let key = 'e5d9a7cc4beed8050f488bb1670e64c6dd8200b85dde4c6fbc04976cdb2e1889';
    //let cipher = aes256.createCipher(key);
    let decrypted = aes256.decrypt(key,encrypted);
    //console.log('decrypted =['+decrypted+']');
    return decrypted;
  }

  function pakoCompress(data){
    let pako = window.pako;
    let binString = pako.deflate(data,{to:"string"});
    //console.log('pakoCompress=['+binString+']');
    return binString;
  }

  function pakoDecompressRaw(data){
    let pako = window.pako;
    let result = pako.inflate(data,{to:"string"});
    //console.log('pakoDecompressRaw final=['+result+']');
  }

  function init() {
    var refreshIntervalId = setInterval(function() {
      var target = $("[role='main']")[0];
      if(target) {
        clearInterval(refreshIntervalId);
        getEmailFromDOM(function(email){
          fb_storage.set({curUserEmail:email}).then(function(){
            if(g_email != email){
              g_email = email;
              console.log("[FraudBuster]update the email:" + email);
            }
            scanEmail();
            addObserveIfNodeAvailable();
            console.log("[FraudBuster]user email is:" + email);
          });
        },function(){
          console.log("[FraudBuster]Geting email failed,Please waiting for update...");
       });

      }
    }, 1000);
  }
  init();
})();