(function(){
    
    var doInitPSPromotionResource = function(productName, settings) {
        initPSPromotionResource({
            ResourcePath: browser.extension.getURL('PrivacyScanner/PSPromotion/img') + '/',
            ProductName: productName,
            IsAskLaterChecked: function(website) {
                if (website === 'FACEBOOK') {
                    return settings.ShowFaceBookPromotion;
                
                } else if (website === 'TWITTER') {
                    return settings.ShowTwitterPromotion;

                } else if (website === 'GOOGLEPLUS') {
                    return settings.ShowGooglePlusPromotion;
                    
                } else if (website === 'LINKEDIN') {
                    return settings.ShowLinkedInPromotion;
                }
                return true;
            },
            CheckPrivacyCallback: function(Website) {
                console.log("CheckPrivacyCallback: " + Website);

                browser.runtime.sendMessage({
                    method: 'doCheckPrivacy',
                    scanWebSite: Website
                });
            },
            LearnMoreCallback : function(Website) {
                console.log("LearnMoreCallback: " + Website);

                browser.runtime.sendMessage({
                    method: 'openLearnMorePage'
                });
            },
            SetAskLater : function(website, value) {
                console.log("SetAskLater: " + website + " " + value);

                browser.runtime.sendMessage({
                    method: 'setShowPromotion',
                    website: website,
                    showOrNot: value
                });
            }
        }); 
    };
    
    browser.runtime.sendMessage({method: 'getPSPromotionWordings'}, function(response) {
        
        var wordings = response.wordings;
        var settings = response.settings;

        // export wordings to global, so ugly and so work
        window.g_oPrivacyScannerString = wordings.g_oPrivacyScannerString;
        window.g_oPrivacyScannerString_autoScan = wordings.g_oPrivacyScannerString_autoScan;
        
        doInitPSPromotionResource(wordings.productName, settings);
        
        if (!window.doPromotionInterval) {
            window.doPromotionInterval = setInterval(function(){
                doPromotion();
            }, 5000);
        }
    });

})();