var COMMUNICATOR_WRAPPER_API_TABLE = {

///////////////////////CONTENT////////////////////////////

'PSContentEstablishConnection' : [
    //Chrome
    function(destination) {
        if (PUtil.checkBrowser.IsChrome()){
            COMMUNICATOR_WRAPPER_API_TABLE.port = chrome.extension.connect({name: destination});
            COMMUNICATOR_WRAPPER_API_TABLE.port.onMessage.addListener(PSContentReceiveMessage);
        }
    },
    
    //Firefox
    function(destination) {
        //no need establish
    },
    
    //Firefox Addon (with new Addon SDK)
    function(destination) {
        if (PUtil.checkBrowser.IsFirefox()) {
            COMMUNICATOR_WRAPPER_API_TABLE.port = browser.runtime.connect({name: destination});
            COMMUNICATOR_WRAPPER_API_TABLE.port.onMessage.addListener(PSContentReceiveMessage);
        }
    },
    
    //Safari
    function(destination) {        
        if (typeof (safari) != 'undefined') {
            safari.self.tab.dispatchMessage('PSContentEstablishConnectionSafari', destination);
            safari.self.addEventListener('message', function(messageEvent) {
                if (messageEvent.name == 'PSContentReceiveMessageSafari') {
                    PSContentReceiveMessage(messageEvent.message);
                }
            }, false);
        }
    },
    
    //IE
    function(destination) {
        //no need establish
    }
],

'PSContentSendMessage' : [
    //Chrome
    function(strMsg) {
        if (typeof (COMMUNICATOR_WRAPPER_API_TABLE.port) != 'undefined') {
            COMMUNICATOR_WRAPPER_API_TABLE.port.postMessage({data: strMsg});
        }
    },
    
    //Firefox
    function(strMsg) {
        if (typeof (PSContentSendMessageFirefox) != 'undefined') {
            PSContentSendMessageFirefox(strMsg);
        }
    },
    
    //Firefox Addon (with new Firefox Addon SDK)
    function(strMsg) {
        if (typeof (self) != 'undefined' && typeof (self.port) !== 'undefined') {
            self.port.emit('PSContentSendMessageFirefoxAddon', strMsg);
        }
    },
    
    //Safari
    function(strMsg) {
        if (typeof (safari) != 'undefined') {
            safari.self.tab.dispatchMessage('PSContentSendMessageSafari', strMsg);
        }
    },
    
    //IE
    function(strMsg) {
        var tryTimes = 0;
        var TotalTryTimes = 5;
        var doPSContentSendMessage = function() {
            var oIEObject = null;
            if (typeof (window.PSUseActiveXObject) != 'undefined' && window.PSUseActiveXObject == true) {
                oIEObject = PUtil.GetIEObject(true);
            } else {
                oIEObject = PUtil.GetIEObject(false);
                if (!oIEObject) {
                    if (tryTimes >= TotalTryTimes) {
                        window.PSUseActiveXObject = true;
                        oIEObject = PUtil.GetIEObject(true);
                    } else {
                        tryTimes++;
                    }
                }
            }
            
            if (oIEObject){
                oIEObject.ToolbarInvoke({Action: 13, HTMLDocument: document, data: strMsg});
            } else {
                setTimeout(doPSContentSendMessage, 1500);
            }
        };
        
        if (PUtil.checkBrowser.IsIE()) {
            doPSContentSendMessage();
        }
    }
]
};
