(function() {
    var exports = window;
    var PSLocalCommunicator = {
        PSTimeoutID: {},

        PSLocalEstablishConnection: function() {
            PSLocalCommunicator.DispatchMessage('PSLocalEstablishConnection', null);
        },

        PSLocalSendMessage: function(msg, timeout) {
            var strMsg = TMExt_$.toJSON(msg);
            PSLocalCommunicator.PSSetTimeoutCallback(msg, timeout);
            PSLocalCommunicator.DispatchMessage('PSLocalSendMessage', strMsg);
        },

        PSSetTimeoutCallback: function(msg, timeout) {
            var _sendError = function(msg, type, error_id) {
                var timeout_msg = TMExt_$.parseJSON(TMExt_$.toJSON(msg));
                timeout_msg.type = type;
                timeout_msg.dataOut = {
                    ret_status: false,
                    ret_value: error_id
                };
                var strTimeoutMsg = TMExt_$.toJSON(timeout_msg);
                PSLocalCommunicator.PSLocalReceiveMessage(strTimeoutMsg);
            };
            
            if (typeof (msg.dataIn) != 'undefined' && typeof (msg.function_id) != 'undefined') {
                var id = msg.function_id;
                if (msg.type == 'ajax_request') {
                    //IE cannot timeout ajax, so make this one.
                    PSLocalCommunicator.PSTimeoutID[id] = setTimeout(function() {
                        _sendError(msg, 'ajax_request_result', null);
                    }, TIMEOUT_SEND_REQUEST_TO_BACKGROUND);
                } else if (timeout) {
                    //all other types timeout, default 60 * 1000
                    PSLocalCommunicator.PSTimeoutID[id] = setTimeout(function() {
                        _sendError(msg, 'error', '80000001');
                    }, timeout);
                }
            }
        },

        PSLocalReceiveMessage: function(strMsg) {
            var msg = TMExt_$.parseJSON(strMsg);
            if(msg.type === "get_sns_account_info_result" && typeof (msg.dataIn) != 'undefined')
            {
                DoPSLocalReceiveMessage(msg);
            }
            if (typeof (msg.dataIn) != 'undefined' && typeof (msg.function_id) != 'undefined') {
                var id = msg.function_id;
                if (PSLocalCommunicator.PSTimeoutID[id] != null) {
                    clearTimeout(PSLocalCommunicator.PSTimeoutID[id]);
                    PSLocalCommunicator.PSTimeoutID[id] = null;
                    DoPSLocalReceiveMessage(msg);
                } else {
                    DoPSLocalReceiveMessage(msg);
                }
            }
        },

        DispatchMessage: function(type, strMsg) {
            var localFunArr = COMMUNICATOR_WRAPPER_API_TABLE[type];
            for (var i = 0; i < localFunArr.length; ++i) {
                try {
                    localFunArr[i](strMsg);
                } catch (e) {
                }
            }
        }
    };

    exports.PSLocalEstablishConnection = PSLocalCommunicator.PSLocalEstablishConnection;
    exports.PSLocalSendMessage = PSLocalCommunicator.PSLocalSendMessage;
    exports.PSLocalReceiveMessage = PSLocalCommunicator.PSLocalReceiveMessage;
})();
