var COMMUNICATOR_WRAPPER_API_TABLE = {

///////////////////////LOCAL////////////////////////////

'PSLocalEstablishConnection' : [
    //Chrome
    function() {
        if (PUtil.checkBrowser.IsChrome()) {
            console.log("Chrome connected with background");
            COMMUNICATOR_WRAPPER_API_TABLE.port = chrome.extension.connect({name: 'LocalPage_Background'});
            COMMUNICATOR_WRAPPER_API_TABLE.port.onMessage.addListener(PSLocalReceiveMessage);
        }
    },
    
    //Firefox Extension
    function() {
        if (PUtil.checkBrowser.IsFirefox()) {
            console.log("Firefox connected with background");
            COMMUNICATOR_WRAPPER_API_TABLE.port = browser.runtime.connect({name: 'LocalPage_Background'});
            COMMUNICATOR_WRAPPER_API_TABLE.port.onMessage.addListener(PSLocalReceiveMessage);
        }
    },
    
    //Firefox Addon (with new Addon SDK)
    function() {
        if (typeof (self) !== 'undefined' && typeof (self.port) !== 'undefined') {
            console.log("Firefox Addon connected with background");
            self.port.emit("PSLocalEstablishConnectionFirefoxAddon");
            self.port.on("PSLocalReceiveMessageFirefoxAddon", function(message) {
                PSLocalReceiveMessage(message);
            });
            
            self.port.on('initLocalPage', function(data) {
                 InitL10NFromExtension(data.locale);
            });
        }
    },
    
    //Safari
    function() {
        if (typeof (safari) != 'undefined') {
            console.log("Safari connected with background");

            safari.self.tab.dispatchMessage('PSLocalEstablishConnectionSafari');
            safari.self.addEventListener("message", function(messageEvent) {
                if (messageEvent.name == 'PSLocalReceiveMessageSafari') {
                    PSLocalReceiveMessage(messageEvent.message);
                }
            }, false);
        }
    },
    
    //IE
    function() {
        //no need establish
    }
],

'PSLocalSendMessage' : [
    //Chrome
    function(strMsg) {
        if (PUtil.checkBrowser.IsChrome()) {
            console.log("Chrome send LocalMsg to background");
            COMMUNICATOR_WRAPPER_API_TABLE.port.postMessage({data: strMsg});
        }
    },
    
    //Firefox Extension
    function(strMsg) {
        if (PUtil.checkBrowser.IsFirefox()) {
            console.log("Firefox send LocalMsg to background");
            COMMUNICATOR_WRAPPER_API_TABLE.port.postMessage({data: strMsg});
        }
    },
    
    //Firefox Addon (with new Firefox Addon SDK)
    function(strMsg) {
        // do nothing
    },
    
    //Safari
    function(strMsg) {
        if (typeof (safari) != 'undefined') {
            safari.self.tab.dispatchMessage('PSLocalSendMessageSafari', strMsg);
        }
    },
    
    //IE
    function(strMsg) {
        var tryTimes = 0;
        var TotalTryTimes = 5;
        var doPSContentSendMessage = function() {
            var oIEObject = null;
            if (typeof (window.PSUseActiveXObject) != 'undefined' && window.PSUseActiveXObject == true) {
                oIEObject = PUtil.GetIEObject(true);
            } else {
                oIEObject = PUtil.GetIEObject(false);
                if (!oIEObject) {
                    if (tryTimes >= TotalTryTimes) {
                        window.PSUseActiveXObject = true;
                        oIEObject = PUtil.GetIEObject(true);
                    } else {
                        tryTimes++;
                    }
                }
            }
            
            if (oIEObject){
                oIEObject.ToolbarInvoke({Action: 13, HTMLDocument: document, data: strMsg});
            } else {
                setTimeout(doPSContentSendMessage, 1500);
            }
        };
        
        if (PUtil.checkBrowser.IsIE()) {
            doPSContentSendMessage();
        }
    }
]
};
