(function() {

    window.DoPSContentReceiveMessage = function(msg) {
        if (msg.type == 'privacy_scanner_setting_result') {
            var setting_items = msg.dataOut.setting_items;
            for (var i in setting_items) {
                var item = setting_items[i];
                var key = item.key;
                var value = item.value;
                window.PrivacyScannerGlobalSettings[key] = value;
            }
            return;
        }
        
        if(Scanner.Website != msg.dataIn.Website){
            return;
        }
        PSDebug.log('[receive message] background page -> content page : ');
        PSDebug.log(msg);

        function callback(data) {
            // var msg = {
            // source : "local",
            // type : type,
            // dataIn : {
            // function_id : function_table["count"],
            // params : params
            // // and other params
            // },
            // dataOut : {
            // ret_status : null,
            // ret_value : data
            // }
            // };

            msg.source = 'content';
            msg.dataOut.ret_status = true;
            msg.dataOut.ret_value = data;
            
            if(msg.type === "fix_single_result"){
                /*
                    if it is fix_single_result, remove its original data as:
                    1. the data may be very large, IE sometimes can't handle it and crash
                    2. we do not depend on fix result for what to do next.
                */
                try{
                    msg.dataOut.ret_value[Fixer.responseHeaderFixSingle].Response.data = "";
                }catch(e){
                    
                }
            }
            
            PSDebug.log('[send message] content page -> background page : ');
            PSDebug.log(msg);

            PSContentSendMessage(msg);
        }

        PSDebug.log("[common_helper] msg type: " + msg.type);
        switch (msg.type) {
            case 'scan_all':
                msg.type = 'scan_all_result';
                Scanner.scan(callback);
                break;
            case 'scan_single':
                msg.type = 'scan_single_result';
                Scanner.scanSingle(msg.dataIn.params.id, callback);
                break;
            case 'fix_single':
                msg.type = 'fix_single_result';
                Fixer.fixSingle(msg.dataIn.params, callback);
                break;
            case 'get_sns_account_info':
                msg.type = 'get_sns_account_info_result';
                Scanner.getAccountInfo(msg.target_url, callback);
                break;
        }
    };
    
    window.SyncPrivacyScannerSettings = function(destination){
        /*
         Get settings
         */
        var msg = {
            type: 'privacy_scanner_setting',
            source: 'content',
            function_id: "NotUsed",
            dataIn: {
                destination: destination,
                setting_type: 'get',
                setting_items:[
                    {
                        key: SettingConstants.is_console_log_enabled,
                        value: 0
                    },
                    {
                        key: SettingConstants.is_file_log_enabled,
                        value: 0
                    }
                ]
            },
            dataOut: {
                setting_items: null
            }
        };
        PSContentSendMessage(msg);
    };
})();
