(function() {'use strict';
    var Constants = [{
        ID: 20,
        FixRelated: { 
            type: 'privacy_update',
            id: '0',
            valueSet: [300645083384735, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=false&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&dpr=2',
            render: 'privacy_settings_composer_preview'
        }
        // Description: 'Who can see your future posts?'
    }, {
        ID: 22,
        FixRelated: {
            type: 'privacy_update',
            id: '8787820733',
            valueSet: [300645083384735, 275425949243301, 291667064279714],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=false&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&dpr=2',
            render: 'settings'
        }
        // Description: 'Who can look you up using the email address you provided?'
    }, {
        ID: 23,
        FixRelated: {
            type: 'privacy_update',
            id: '8787815733',
            valueSet: [300645083384735, 275425949243301, 291667064279714],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=false&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&dpr=1',
            render: 'settings'
        }
        // Description: 'Who can look you up using the phone number you provided?'
    }, {
        ID: 24,
        FixRelated: {
            type: 'public_search',
            valueSet: [0, 1],
            url: '/ajax/settings_page/search_filters.php'
        }
        // Description: 'Do you want search engines outside of Facebook to link to your profile?'
    }, {
        ID: 31,
        FixRelated: {
            type: 'timelineReview',
            valueSet: [1, 0],
            url: '/ajax/settings/timeline/review.php'
        }
        // Description: 'Review posts friends tag you in before they appear on your timeline'
    }, {
        ID: 33,
        FixRelated: {
            type: 'privacy_update',
            id: '8787530733',
            valueSet: [300645083384735, 275425949243301, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=false&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&dpr=1',
            render: 'settings'
        }
        // Description: 'Who can see posts you\'ve been tagged in on your timeline'
    }, {
        ID: 34,
        FixRelated: {
            type: 'privacy_update',
            id: '8787370733',
            valueSet: [300645083384735, 275425949243301, 291667064279714, 286958161406148],
            url: '/privacy/selector/update/?is_saved_on_select=true&should_return_tooltip=false&prefix_tooltip_with_app_privacy=false&replace_on_select=false&ent_id=0&dpr=1',
            render: 'settings'
        }
        // Description: 'Who can see what others post on your timeline'
    }, {
        ID: 35,
        FixRelated: {
            type: 'taggingReview',
            valueSet: [1, 0],
            url: '/ajax/settings/tagging/review.php'
        }
        // Description: 'Review tags people add to your own posts before the tags appear on Facebook'
    }, {
        ID: 83,
        FixRelated: {
            type: 'simple_save',
            id: '8787700733',
            valueSet: [80, 50, 40, 10],
            url: '/ajax/privacy/simple_save.php'
        }
        // Description: 'Old versions of Facebook for mobile'
    }, {
        ID: 84,
        FixRelated: {
            type: 'edit_application',
            app_id: 1,
            valueSet: [80, 40, 10],
            
            url: '/settings/applications/edit_app_settings/submit',
            url2: '/ajax/settings/apps/delete_app.php'
        }
        // Description: 'Application can access your personal info'
    }];

    var FixHelper = function() {
        this.PROTOCOL_DOMAIN = PUtil.checkPage.IsFacebook() ? window.location.protocol + '//' + window.location.host : 'https://www.facebook.com';
        this.Constants = Constants;
    };


    function getFirstVisibleElemIndexBySelector(selector){
        var arr = document.querySelectorAll(selector);
        let i = 0;
        for(i=0; i<arr.length; ++i){
            let elem = arr[i];
            if(!(elem.offsetWidth <= 0 && elem.offsetHeight <= 0)){
                break;
            }
        }
        return i!=arr.length?i:-1;
    }

    function checkAttributes(elemt){
        let attris =["role","class","href","style",
                        "aria-haspopup","aria-label","id","aria-expanded","rel",
                        "data-hover","data-tooltip-content","data-tooltip-alignh"];
        for(let i=0; i<attris.length; ++i){
            if(typeof(elemt.attributes[attris[i]]) == "undefined"){
                return false;
            }
        }
        return true;
    }

    function getPublicButtonIndex(){
        var arr = document.querySelectorAll("a[role='button']");
        for(var i=0; i<arr.length; ++i){
            if(checkAttributes(arr[i])){
                console.log("index is "+i);
                return i;
            }        
        }
        return -1;
    }

    function fix(ofs1,ofs2,callback,data){
        setTimeout(function(){

            //click edit button.success rate:100%
            document.querySelectorAll(".fbSettingsListItemContent")[ofs1].click();
            let count = 0;
            let interval1 = setInterval(function(){
                
                //only try three times
                if(count>=6){
                    clearInterval(interval1);
                }

                //click public button.
                let index = getPublicButtonIndex();
                if(index == -1){
                    return ;
                }
                document.querySelectorAll("a[role='button']")[index].click();

                //try to click recommand item.
                setTimeout(function(){
                    let selector = "a[role='menuitemcheckbox']";
                    let ofs = ofs2;
                    let i = getFirstVisibleElemIndexBySelector(selector);
                    if(i>=0){
                        let element = document.querySelectorAll(selector)[i+ofs];
                        console.log(element);
                        //check if enable success
                        if(typeof(element.attributes["aria-checked"])!="undefined"&&
                            element.attributes["aria-checked"].value == "true"){
                            clearInterval(interval1);
                            setTimeout(function(){
                                callback(data);
                                location.reload();
                            },500);
                        }else{
                            element.click();
                        }
                    }else{
                        console.log(selector + "not visible!");
                    }
                },500); //0.5s delay click and check.
                count++;
            }, 1500);//1.5s interval to click public button
        }, 1000);//start fix delay 1s for elemant ready.

    }

    FixHelper.prototype.fixAllById = function(id,value){
        let fake_callback_data = "";
        switch(id){
            case 20:
                fix(0,1,null,null);
                break;
            case 22:
                fix(5,parseInt(value),null,null);
                break;
            case 23:
                fix(6,parseInt(value),null,null);
                break;
            case 24:
                let count = 0;
                document.querySelectorAll(".fbSettingsListItemContent")[7].click();
                let timer = setInterval(function(){
                    if(count > 3){
                        clearInterval(timer);
                        return ;
                    }
                    let elem = document.getElementById("search_filter_public");
                    if(!elem){
                        return ;
                    }
                    if(elem.checked){
                        elem.click();
                        setTimeout(function(){
                            document.getElementsByName("turn_off")[0].click();
                        }, 200);
                    }else{
                        clearInterval(timer);
                    }
                    count += 1;
                },1000);
                break;
        }
    }

    FixHelper.prototype.logHeaderSendData = '[Facebook Fix -> send data]';
    FixHelper.prototype.logHeaderHandleResponseData = '[Facebook Fix -> handle response data]';
    FixHelper.prototype.getSendData = function(id, value, userID, fb_dtsg, appID, bDetele) {
        var params = {
            'type' : 'POST',
            'data' : null,
            'dataType' : 'html',
            'url' : null
        };

        for (var i = 0; i < this.Constants.length; i++) {
            if (this.Constants[i]['ID'] === id) {
                var dataSet = this.Constants[i]['FixRelated'];
                break;
            }
        }

        //2019-6-12
        params.id = id;
        params.value = value;
        
        // set url
        params.url = this.PROTOCOL_DOMAIN;
        params.url += dataSet.url;

        // set form data
        switch (dataSet.type) {
            case 'simple_save':
                params.data = this.postSimpleSave(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'privacy_update':
                this.postPrivacyUpdate(id, value, dataSet, userID, fb_dtsg, params);
                break;
            case 'timelineReview':
                params.data = this.postTimeLineReview(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'taggingReview':
                params.data = this.postTaggingReview(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'tagSuggestion':
                params.data = this.postSuggestionReview(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'public_search':
                params.data = this.postPublicSearch(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'instant_connect':
                params.data = this.postInstantConnect(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'friends_share':
                params.data = this.postFriendsShare(id, value, dataSet, userID, fb_dtsg);
                break;
            case 'edit_application':
                if(bDetele) {
                    PSDebug.log("Trying Delete Application, appID: ",appID);
                    params.url = this.PROTOCOL_DOMAIN;
                    params.url += dataSet.url2;
                    params.data = this.postDeleteApplication(id, value, dataSet, userID, appID, fb_dtsg);
                } else {
                    PSDebug.log("Trying Edit Application, appID: ",appID);
                    params.data = this.postEditApplication(id, value, dataSet, userID, appID, fb_dtsg);
                }
                break;
        }

        new SendDataLogger(FixHelper.logHeaderSendData + ' : ' + id, params).getLog();
        return params;
    };
    FixHelper.prototype.handleResponse = function(id, value, data) {
        new ResponseHandlerLogger(FixHelper.logHeaderHandleResponseData + ', ID : ' + id + ', value : ' + value, data).getLog();
        var fixResult = PUtil.cloneObj(FacebookFixResultsTemplate);

        fixResult['id'] = id;
        fixResult['value'] = value;

        fixResult['data'] = data;
        return fixResult;
    };
    FixHelper.prototype.getValidFixValueByID = function(id) {
        for (var i = 0; i < this.Constants.length; i++) {
            if (this.Constants[i]['ID'] === id) {
                return FacebookScanResultsTemplate[i]['possibleFixValue'];
            }
        }
    };
    FixHelper.prototype.isValidFixValue = function(id, value) {
        var possibleValueList = this.getValidFixValueByID(id);
        for (var i = 0; i < possibleValueList.length; i++) {
            if (parseInt(value) === possibleValueList[i]) {
                return true;
            }
        }
        return false;
    };

    FixHelper.prototype.getQueryString = function(data) {
        var key;
        var result = '';
        for (key in data) {
            result += '&';
            result += key;
            result += '=';
            result += data[key];
        }

        return encodeURI(result).substr(1);
    };

    FixHelper.prototype.getTtstamp = function(fb_dtsg) {
        if(!fb_dtsg) {
            return "";
        }
        var v = "";
        var ttstamp = "";
        for (var w = 0; w < fb_dtsg.length; w++) { 
            v += fb_dtsg.charCodeAt(w);
            ttstamp = "2" + v;
        }
        return ttstamp;
    };

    FixHelper.prototype.postPrivacyUpdate = function(id, value, dataSet, userID, fb_dtsg, params) {
        var data = {
            __a: '1',              //Magic number, as Facebook's post param
            __user: userID,
            fb_dtsg: fb_dtsg,            
            __req: "a",              //Magic number, as Facebook's post param
            ttstamp:this.getTtstamp(fb_dtsg),
            __rev: 1747572           //Magic number, as Facebook's post param
        };
        params.data = data;
        params.url = params.url + "&privacy_fbid=" + dataSet.id + "&post_param=" + dataSet.valueSet[value] + "&render_location_enum=" + dataSet.render;
    };
    
    FixHelper.prototype.postSimpleSave = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            fb_dtsg: fb_dtsg,
            id: dataSet.id,
            source:"privacy_settings_page"
        };

        var audience_value = {
        };

        audience_value[dataSet.id] = {
            'value' : dataSet.valueSet[value]
        };

        data['audience_json'] = JSON.stringify(audience_value);
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);

        return data;
    };

    FixHelper.prototype.postTimeLineReview = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            tag_approval_enabled: dataSet.valueSet[value],
            fb_dtsg: fb_dtsg
        };

        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    FixHelper.prototype.postTaggingReview = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            tag_review_enabled: dataSet.valueSet[value],
            fb_dtsg: fb_dtsg
        };

        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };
    
    FixHelper.prototype.postSuggestionReview = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            tag_suggestion_enabled: dataSet.valueSet[value],
            fb_dtsg: fb_dtsg
        };

        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    FixHelper.prototype.postPublicSearch = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            el: 'search_filter_public',
            fb_dtsg: fb_dtsg,
            'public' : dataSet.valueSet[value],
            __req: '1'
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };

    FixHelper.prototype.postInstantConnect = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            el: 'instant_personalization_checkbox',
            fb_dtsg: fb_dtsg,
            'opt_in' : dataSet.valueSet[value],
            __req: '1'
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };
    FixHelper.prototype.postFriendsShare = function(id, value, dataSet, userID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            fb_dtsg: fb_dtsg,
            __req: '3'
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };
    FixHelper.prototype.postEditApplication = function(id, value, dataSet, userID, appID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            app_id: appID,
            fb_dtsg: fb_dtsg,
            'audience[0][value]': dataSet.valueSet[value],
            'removed_read_scopes':'',
            'removed_write_scopes':'',
            'notification':0
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };
    FixHelper.prototype.postDeleteApplication = function(id, value, dataSet, userID, appID, fb_dtsg) {
        var data = {
            __a: '1',
            __user: userID,
            app_id: appID,
            fb_dtsg: fb_dtsg,
            legacy:false,
            dialog:true,
            confirmed:true,
            ban_user:0
           
        };
        data['ttstamp'] = this.getTtstamp(data, fb_dtsg);
        return data;
    };
    window.FacebookFixHelper = FixHelper;
})();
