(function() {'use strict';

    var Scanner = function() {
        this.PROTOCOL_DOMAIN = PUtil.checkPage.IsFacebook() ? window.location.protocol + '//' + window.location.host : 'https://www.facebook.com';
        this.responseHeaderScanSingle = FPScanSingleResponse;
        this.responseHeaderScan = FPScanResponse;
        
        this.UserInfo = {
            hasUserInfo : false,
            userID : null,
            token: null,
            isUnder18 : null
        }
    };

    function checkIsUnder18(data){
        return (data.indexOf("214189648617074") >= 0);
    }

    Scanner.prototype.getUserInfo = function(notUnder18, isUnder18, notLogIn, whenNetworkError) {
        var that = this;
        
        SendWebRequest({
            'type' : 'GET',
            'data' : null,
            'dataType' : 'html',
            'url' : that.PROTOCOL_DOMAIN + "/settings?tab=privacy"
        }, function(data) {
            SendWebRequest({
                'type' : 'GET',
                'data' : null,
                'dataType' : 'html',
                'url' : that.PROTOCOL_DOMAIN + "/settings?tab=applications"
            }, function(app_settings) {
                var html = TMExt_$(app_settings);
                var title_array = html.find('span[class="_3aiv"]');
                var desc_array = html.find('div[class="_4na2"]');
                var application_3rd_title = html.find('div[class="_685i"]');

                var _unicodeToChar = function unicodeToChar(text)
                {
                    return text.replace(/\\u[\dA-F]{4}/gi,
                        function(match){return String.fromCharCode(parseInt(match.replace(/\\u/g,''),16))});
                };

                // Get User Token
                var ptn_token = /\"async_get_token\"\:\"(.*?)\"/g;
                var matchCur;
                if(matchCur = ptn_token.exec(app_settings)){
                    that.UserInfo.token = encodeURIComponent(matchCur[1])
                }

                var ptn = /\"baseLabel\"\:(.*?)\,/g;     //or   "triggerLabel"
                var matchesArr_83 = [];
		        var matchesArr_84 = [];
                while( matchCur = ptn.exec(app_settings) ){
                    var curMatchUnicode = matchCur[1].substr(1, matchCur[1].length-2);
                    matchesArr_83.push(_unicodeToChar(curMatchUnicode));
		            matchesArr_84.push(_unicodeToChar(curMatchUnicode));
                }
                window.g_app_settings_set_83 = matchesArr_83;

                //id=84, reuse the set of all selectors from id 83,
                // but remove the second selector
                window.g_app_settings_set_84 = matchesArr_84;
                g_app_settings_set_84.splice(1,1);
                
                window.app_settings_title_array = title_array;
                window.app_settings_desc_array = desc_array;
                window.application_3rd_title = application_3rd_title;
                
                that.UserInfo.hasUserInfo = true;
                var parseData = new FacebookScannerHelper().handleResponse_SettingPage(data);
                if (parseData && parseData.user_id) {
                    that.UserInfo.userID = parseData.user_id;
                    that.UserInfo.isUnder18 = checkIsUnder18(data);
                    if(that.UserInfo.isUnder18){
                        return isUnder18();
                    }else{
                        return notUnder18();
                    }   
                } else {
                    // user not logged in
                    return notLogIn();
                }
            });
        }, whenNetworkError);
    };

    Scanner.prototype.scanSingle = function(id, callback) {
        var that = this;
        var scannerHelper = null;
        
        if(that.UserInfo.hasUserInfo){
            if(!that.UserInfo.isUnder18){
                scannerHelper = new FacebookScannerHelper();
                return doScanSingle();
            }else{
                tbc_error("account under 18 years old!");
            }
        }else{
            that.getUserInfo(function(){
                // not under 18
                scannerHelper = new FacebookScannerHelper();
                return doScanSingle();
            },function(){
                // under 18
                tbc_error("no function for account that under 18 years old1");
            },function(){
                // not log in
                var responseData = new APIResponseHelper(that.responseHeaderScanSingle, ReturnCodeEnum.NOT_LOGGED_IN.code, ReturnCodeEnum.NOT_LOGGED_IN.description).getResponse();
                PSDebug.error(responseData);
                return callback(responseData);
            },sendWebRequestFailCallback);
        }
        
        function sendWebRequestFailCallback(data) {
            // network error
            var responseData = new APIResponseHelper(that.responseHeaderScanSingle, ReturnCodeEnum.NETWORK_ERROR.code, ReturnCodeEnum.NETWORK_ERROR.description).getResponse();
            PSDebug.error(responseData);
            return callback(responseData);
        }
        
        function doScanSingle() {
            if (!scannerHelper.isValidID(id)) {

                var responseData = new APIResponseHelper(that.responseHeaderScanSingle, ReturnCodeEnum.INVALID_ID.code, ReturnCodeEnum.INVALID_ID.description, 'wrong ID! : ' + id + ', availableIDS: ' + scannerHelper.getAllvalidID()).getResponse();
                PSDebug.error(responseData);
                return callback(responseData);
            }
            that.sendWebRequestOKCallback = sendWebRequestOKCallback;
            function sendWebRequestOKCallback(data) {
                var parseData = scannerHelper.handleResponse(id, data);
                if ((id == 83) && parseData && parseData.PossibleValue && parseData.PossibleValue['3']) {
                    if (typeof(window.FacebookL10nWording) == "undefined") {
                        window.FacebookL10nWording = parseData.PossibleValue;
                    }
                }
                if(parseData && TMExt_$.trim(parseData["Title"]) == ""){
                    // do not show the setting when we find the title is empty
                    parseData = null;
                }
                // parseData = null;
                if (!parseData) {
                    // web content parse error
                    var responseData = new APIResponseHelper(that.responseHeaderScanSingle, ReturnCodeEnum.WEBRESPONSE_PARSE_ERROR.code, ReturnCodeEnum.WEBRESPONSE_PARSE_ERROR.description, 'Web content parse error! ID: ' + id + ', webData: ' + data).getResponse();
                    PSDebug.error(responseData);
                    return callback(responseData);
                }

                // return correct web content (white list: we only return these items)
                var parseDataFinal = {
                    ID : parseData['ID'],
                    Risk : parseData['Risk'],
                    Title : parseData['Title'],
                    Desc : parseData['Desc'],
                    PossibleValue : parseData['PossibleValue'],
                    possibleFixValue : parseData['possibleFixValue'],
                    Current : parseData['Current'],
                    Suggestion : parseData['Suggestion'],
                    Category : parseData['Category'],
                    Website : parseData['Website'],
                    html : parseData['html'],
                    appIDs : parseData['appIDs'],
                    appsDetail : parseData['appsDetail'],
                    cssNeed : parseData['cssNeed']
                };

                var responseData = new APIResponseHelper(that.responseHeaderScanSingle, ReturnCodeEnum.OK.code, ReturnCodeEnum.OK.description, parseDataFinal).getResponse();
                PSDebug.log(responseData);
                return callback(responseData);
            }
            
            SendWebRequest(scannerHelper.getSendData(id, that.UserInfo.userID, that.UserInfo.token), sendWebRequestOKCallback, sendWebRequestFailCallback);
        }
    };

    Scanner.prototype.scan = function(callback) {
        var that = this;
        var scanResult = {
            'TimeLineAndTagging' : {
                'ID' : 3,
                'Items' : []
            },
            'PrivacySetting' : {
                'ID' : 2,
                'Items' : []
            },
            'AppsAndWebsites' : {
                'ID' : 8,
                'Items' : []
            }
        };

        var SCANSINGLE_COUNT = FacebookScanResultsTemplate.length;

        // scan single callback
        var countAlreadyScan = 0;
        var needStopCallback = false;
        var isWebResponsePartlyError = false;
        function scanSingleCallback(data) {
            if (needStopCallback) {
                return;
            }

            if (data[that.responseHeaderScanSingle]['ReturnCode'] == ReturnCodeEnum.OK.code) {
                // get right single scan result, add it to final result now
                addSingleToScanResult(data[that.responseHeaderScanSingle]['Response']);
            } else if (data[that.responseHeaderScanSingle]['ReturnCode'] == ReturnCodeEnum.WEBRESPONSE_PARSE_ERROR.code) {
                isWebResponsePartlyError = true;
            } else {
                var responseData = new APIResponseHelper(that.responseHeaderScan, data[that.responseHeaderScanSingle].ReturnCode, data[that.responseHeaderScanSingle].Description, data[that.responseHeaderScanSingle].Response).getResponse();

                PSDebug.error(responseData);

                needStopCallback = true;
                return callback(responseData);
            }

            function addSingleToScanResult(data) {
                switch (parseInt(data['ID'])) {
                    case 20:
                    case 22:
                    case 23:
                    case 24:
                        scanResult.PrivacySetting.Items.push(data);
                        break;
                    case 31:
                    case 33:
                    case 34:
                    case 35:
                    case 36:
                        scanResult.TimeLineAndTagging.Items.push(data);
                        break;
                    case 83:
                    case 84:
                        scanResult.AppsAndWebsites.Items.push(data);
                        break;
                }
            }

            countAlreadyScan++;
            if (countAlreadyScan == SCANSINGLE_COUNT) {
                // finish all single scan
                if (!isWebResponsePartlyError) {
                    var responseData = new APIResponseHelper(that.responseHeaderScan, ReturnCodeEnum.OK.code, ReturnCodeEnum.OK.description, scanResult).getResponse();
                } else {
                    var responseData = new APIResponseHelper(that.responseHeaderScan, ReturnCodeEnum.WEBRESPONSE_PARSE_ERROR_COULD_USE_PARTLY.code, ReturnCodeEnum.WEBRESPONSE_PARSE_ERROR_COULD_USE_PARTLY.description, scanResult).getResponse();
                }
                PSDebug.log(responseData);
                return callback(responseData);
            }
        }
        
        function sendWebRequestFailCallback(data) {
            // network error
            var responseData = new APIResponseHelper(that.responseHeaderScan, ReturnCodeEnum.NETWORK_ERROR.code, ReturnCodeEnum.NETWORK_ERROR.description).getResponse();
            PSDebug.error(responseData);
            return callback(responseData);
        }
        
        function doScan(){
            // scan every single setting
            for (var i = 0; i < SCANSINGLE_COUNT; i++) {
                that.scanSingle(FacebookScanResultsTemplate[i]['ID'], scanSingleCallback);
            }   
            PSDebug.log("do scan finish");
        }
        
        that.getUserInfo(function(){
            // not under 18
            return doScan();
        },function(){
            // under 18
            return doScan();
        },function(){
            // not log in
            var responseData = new APIResponseHelper(that.responseHeaderScan, ReturnCodeEnum.NOT_LOGGED_IN.code, ReturnCodeEnum.NOT_LOGGED_IN.description).getResponse();
            PSDebug.error(responseData);
            return callback(responseData);
        },sendWebRequestFailCallback);
    };

    Scanner.prototype.Website = "FACEBOOK";

    window.FacebookPScanner = Scanner;

    // for android old interface
    var PSScan = {};
    PSScan.scanSingle = function(id, callback) {
        new Scanner().scanSingle(id, function(data) {
            return callback(data['FPScanSingleResponse']['Response']);
        });
    };

    PSScan.scan = function(callback) {
        new Scanner().scan(function(data) {
            return callback(data['FPScanResponse']['Response']);
        });
    };
    window.PSScan = PSScan;
})();
