(function () {
    'use strict';

    var Constants = [
        {
            ID: 11,
            FixRelated: {}
            // Description: 'Data sharing with third-party applications'
        }, {
            ID: 12,
            FixRelated: {}
            // Description: 'Advertising Pref'
        }];

    var FixHelper = function () {
        this.PROTOCOL_DOMAIN = PUtil.checkPage.IsLinkedIn() ? window.location.protocol + '//' + window.location.host : 'https://www.linkedin.com';
    };

    FixHelper.prototype.getValidFixValueByID = function (id) {
        for (var i = 0; i < Constants.length; i++) {
            if (Constants[i]['ID'] == id) {
                return LinkedinScanResultsTemplate[i]['possibleFixValue'];
            }
        }
    };
    FixHelper.prototype.isValidFixValue = function (id, value) {
        var possibleValueList = this.getValidFixValueByID(id);
        for (var i = 0; i < possibleValueList.length; i++) {
            if (value == possibleValueList[i]) {
                return true;
            }
        }
        return false;
    };

    FixHelper.prototype.logHeaderSendData = '[Linkedin Fix -> send data]';
    FixHelper.prototype.logHeaderHandleResponseData = '[Linkedin Fix -> handle response data]';

    FixHelper.prototype.performFix = function(id, value) {
        var params = null;
        var check_box = null;

        function clickCheckBox(check_box) {
            var current_value = check_box[0].checked ? 1 : 0;
            if (value != current_value) {
                check_box.click();
            }
        }

        try {
            switch (String(id)) {
                case '11':
                    params = 'Sharing data with third parties';
                    check_box = TMExt_$('#option-block-services');
                    clickCheckBox(check_box);
                    break;
                case '12':
                    params = 'Advertising preferences';
                    check_box = TMExt_$('#ads-beyond-li-option');
                    clickCheckBox(check_box);
                    break;
            }


            new SendDataLogger(this.logHeaderSendData + ' : ' + id, params).getLog();
            return true;
        }catch (e) {
            PSDebug.error(e);
            return false;
        }
    };

    FixHelper.prototype.handleResponse = function(id, value, data) {
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + id + ', value : ' + value, data).getLog();

        if (!data) {
            // when click fail
            return null;
        }
        
        var fixResult = PUtil.cloneObj(LinkedinFixResultsTemplate);

        fixResult['id'] = id;
        fixResult['value'] = value;

        fixResult['data'] = data;
        return fixResult;
    };
    
    window.LinkedinFixHelper = FixHelper;
    window.LinkedinFixHelper_Constants = Constants;
})();