(function() {'use strict';

    // ================================================
    // ScannerHelper
    // ================================================
    var ScannerHelper = function() {
        this.PROTOCOL_DOMAIN = PUtil.checkPage.IsLinkedIn() ? window.location.protocol + '//' + window.location.host : 'https://www.linkedin.com';
        this.ScanResultsTemplate = LinkedinScanResultsTemplate;
    };
    ScannerHelper.prototype.logHeaderSendData = '[Linkedin Scan -> send data]';
    ScannerHelper.prototype.logHeaderHandleResponseData = '[Linkedin Scan -> handle response data]';
    
    ScannerHelper.prototype.getAllvalidID = function() {
        var allValidID = [];
        for (var i = 0; i < this.ScanResultsTemplate.length; i++) {
            allValidID.push(this.ScanResultsTemplate[i]['ID']);
        }
        return allValidID;
    };
    ScannerHelper.prototype.isValidID = function(id) {
        var allValidID = this.getAllvalidID();
        for (var i = 0; i < allValidID.length; i++) {
            if (id == allValidID[i]) {
                return true;
            }
        }
        return false;
    };

    ScannerHelper.prototype.getScanResultSampleByID = function(id) {
        for (var i = 0; i < this.ScanResultsTemplate.length; i++) {
            if (this.ScanResultsTemplate[i]['ID'] == id) {
                return PUtil.cloneObj(this.ScanResultsTemplate[i]);
            }
        }
    };

    ScannerHelper.prototype.getSendData_wording = function(id) {
        var id_url = {
            "11" : "/psettings/data-sharing",
            "12" : "/psettings/advertising/ads-beyond-linkedin"
        };
        var params = {
            'type' : 'GET',
            'data' : null,
            'dataType' : 'html',
            'url' : this.PROTOCOL_DOMAIN + id_url[id]
        };

        new SendDataLogger(this.logHeaderSendData + ' : ' + id, params).getLog();
        return params;
    };

    ScannerHelper.prototype.handleResponse = function(id, htmlContent) {
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + id, htmlContent).getLog();
        var scanResult = this.getScanResultSampleByID(id);
        // parse html page to render "Title", "Desc", "Current"
        switch (String(id)) {
            case '11':
                try {
                    var data_$ = TMExt_$(htmlContent);

                    var title = data_$.find("a[href='/psettings/data-sharing'] h3.heading").text();
                    scanResult.Title = TMExt_$.trim(title);
                    scanResult.Desc = data_$.find("a[href='/psettings/data-sharing'] p.sub-heading").text()?data_$.find("a[href='/psettings/data-sharing'] p.sub-heading").text():TMExt_$.trim(title);

                    scanResult.Current = (data_$.find("input[id = 'option-block-services']")[0].checked === false) ? 0 : 1;
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '12':
                try {
                    var data_$ = TMExt_$(htmlContent);

                    var title = data_$.find("a[href='/psettings/advertising/ads-beyond-linkedin'] h3.heading").text();
                    scanResult.Title = TMExt_$.trim(title);
                    scanResult.Desc = data_$.find("a[href='/psettings/advertising/ads-beyond-linkedin'] p.sub-heading").text()?data_$.find("a[href='/psettings/advertising/ads-beyond-linkedin'] p.sub-heading").text():TMExt_$.trim(title);
                    scanResult.Current = (data_$.find("input[id = 'ads-beyond-li-option']")[0].checked === false) ? 0 : 1;
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
        }

        return null;
    };
    window.LinkedinScannerHelper = ScannerHelper;
})();