(function() {
    'use strict';

    var Constants = [
        {
            ID: 11,
            FixRelated: {
            }
            // Description: 'Protect my Tweets'
        }, {
            ID: 12,
            FixRelated: {
            }
            // Description: 'Let others find me by my email address'
        }, {
            ID: 13,
            FixRelated: {
            }
            // Description: 'Tailor Twitter based on my recent website visits'
        }, {
            ID: 14,
            FixRelated: {
            }
            // Description: 'Add a location to my Tweets'
        }, {
            ID: 15,
            FixRelated: {
            }
            // Description: 'Tailor ads based on information shared by ad partners.'
        }, {
            ID: 16,
            FixRelated: {
            }
            // Description: 'Photo tagging'
        }];


    var FixHelper = function() {
    };

    FixHelper.prototype.logHeaderSendData = '[Twitter Fix -> click data]';
    FixHelper.prototype.logHeaderHandleResponseData = '[Twitter Fix -> handle response data]';    
    

    FixHelper.prototype.fixPhotoTag = function(value){
        let tagObjTimes = 0;
        let getTagObjTimer = setInterval(function(){
            let tagObj = document.querySelector("a[href='/settings/tagging']");
            if(tagObj!=null){
                clearInterval(getTagObjTimer);
                tagObj.click();
                let clickTimes = 0;
                let clickCheckTimer = setInterval(function(){
                    let labelObj = null;
                    switch( value ){
                        case "1":
                        {
                            let tmpDiv = document.querySelector("div[aria-labelledby='RADIO_GROUP_1_LABEL']");
                            if( tmpDiv!=null ){
                                labelObj = tmpDiv.querySelectorAll("label")[2];
                            }
                            if( labelObj && labelObj.querySelector("input").checked ){
                                clearInterval(clickCheckTimer);
                                if(typeof(success)=="function"){
                                    success();
                                }
                            }
                            else if( labelObj && !labelObj.querySelector("input").checked){
                                labelObj.click();
                            }
                        }
                        break;

                        case "2":
                        {
                            labelObj = document.querySelector("#RADIO_GROUP_1_LABEL");
                            if( labelObj && !labelObj.querySelector("input").checked ){
                                clearInterval(clickCheckTimer);
                                if(typeof(success)=="function"){
                                    success();
                                }
                            }
                            else if( labelObj && labelObj.querySelector("input").checked){
                                labelObj.click();
                            }
                        }
                        break;
                    }
                    if(clickTimes>=5){
                        clearInterval(clickCheckTimer);
                    }
                    clickTimes++;
                },200);
            }
            else if( tagObjTimes>=5 ){
                clearInterval(getTagObjTimer);
            }
            tagObjTimes++;
        }, 500);
    }




    FixHelper.prototype.performFix = function(id, value,success,failure) {
        var params = null;
        var check_box = null;
        var that = this;
        function clickCheckBox(check_box) {
            var current_value = check_box[0].checked ? 1 : 0;
            if (value != current_value) {
                check_box.click();
            }
        }
        
        function clickRatio(ratio_index){
            TMExt_$("#allow_media_tagging_fieldset input").eq(ratio_index).click();
        }
        
        try {
            let count = 0;
            let timer = setInterval(function(){
                if(++count > 6){
                    clearInterval(timer);
                    if(typeof(failure)=="function"){
                        failure();
                    }
                    return ;
                }
                switch (String(id)) {
                    case '11':
                        params = 'Protect my Tweets';
                        //new version
                        let obj = document.querySelectorAll("input")[0];
                        if(!obj){
                            return ;
                        }
                        if(!obj.checked){
                            obj.click();
                            setTimeout(function(){
                                document.querySelector("div[data-testid='confirmationSheetConfirm']").click()
                            },50);
                        }
                        if(obj.checked){
                            clearInterval(timer);
                            if(typeof(success)=="function"){
                                success();
                                return ;
                            }
                        }
                        break;
                    case '12':
                        params = 'Let others find me by my email address';
                        //document.querySelectorAll("span")[38].click();
                        document.querySelector("a[href='/settings/contacts']").click();

                        //location.href = "https://twitter.com/settings/contacts";
                        setTimeout(function(){
                            let emailCheckBox = document.querySelectorAll("input[type='checkbox']")[0];
                            if(!emailCheckBox){
                                return ;
                            }

                            if(emailCheckBox.checked){
                                emailCheckBox.click();
                            }

                            if(!emailCheckBox.checked){
                                clearInterval(timer);
                                document.querySelector("section div[role='button']").click();
                                if(typeof(success)=="function"){
                                    success();
                                }
                                return ;
                            }
                        }, 100);
                        break;
                    case '13':
                        params = 'Tailor Twitter based on my recent website visits';
                        //document.querySelectorAll("span")[38].click();
                        document.querySelector("a[href='/settings/contacts']").click();
                        setTimeout(function(){
                            let phoneCheckBox = document.querySelectorAll("input[type='checkbox']")[1];
                            if(!phoneCheckBox){
                                return ;
                            }

                            if(phoneCheckBox.checked){
                                phoneCheckBox.click();
                            }

                            if(!phoneCheckBox.checked){
                                clearInterval(timer);
                                document.querySelector("section div[role='button']").click();
                                if(typeof(success)=="function"){
                                    success();
                                }
                                return ;
                            }

                        }, 100);
                        break;
                    case '14':
                        params = 'Add a location to my Tweets';
                        let a = document.querySelector("a[href='/settings/location']");
                        if(a){
                            a.click();
                        }
                        setTimeout(function(){
                            let checkBoxObj = document.querySelector("input[type='checkbox']");
                            if(!checkBoxObj){
                                return ;
                            }

                            if(checkBoxObj.checked){
                                checkBoxObj.click();
                            }

                            if(!checkBoxObj.checked){
                                clearInterval(timer);
                                document.querySelector("section div[role='button']").click();
                                if(typeof(success)=="function"){
                                    success();
                                }
                                return ;
                            }

                        },200);
                        break;
                    case '15':
                        params = 'Tailor ads based on information shared by ad partners.';
                        check_box = TMExt_$('#allow_ads_personalization');
                        clickCheckBox(check_box);
                        break;
                    case '16':
                        params = 'Photo tagging';
                        that.fixPhotoTag(value);
                        break;
                }
            },500);

            new SendDataLogger(this.logHeaderSendData + ' : ' + id, params).getLog();
            return true;
        }catch (e) {
            PSDebug.error(e);
            return false;
        }
    };

    FixHelper.prototype.performSave = function() {
        var params = 'Save button';
        var button_save = TMExt_$('#settings_save');
        
        var input_password = TMExt_$('#auth_password');
        if (input_password.is(':visible')) {
            return true;
        }

        function clickSave() {
            button_save.click();
        }

        try {
            clickSave()
            new SendDataLogger(this.logHeaderSendData + ' : ' + 'save button', params).getLog();
            return true;
        }catch (e) {
            PSDebug.error(e);
            return false;
        }
    };

    FixHelper.prototype.handleResponse = function(id, value, data) {
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + id + ', value : ' + value, data).getLog();

        if (!data) {
            // when click fail
            return null;
        }

        var fixResult = PUtil.cloneObj(TwitterFixResultsTemplate);

        fixResult['id'] = id;
        fixResult['value'] = value;

        if (typeof data === 'string') {
            // this is a string
            fixResult['data'] = data.substring(0, 100);
        }else {
            fixResult['data'] = data;
        }

        return fixResult;
    };

    FixHelper.prototype.getValidFixValueByID = function(id) {
        for (var i = 0; i < Constants.length; i++) {
            if (Constants[i]['ID'] == id) {
                return TwitterScanResultsTemplate[i]['possibleFixValue'];
            }
        }
    };
    FixHelper.prototype.isValidFixValue = function(id, value) {
        var possibleValueList = this.getValidFixValueByID(id);
        for (var i = 0; i < possibleValueList.length; i++) {
            if (value == possibleValueList[i]) {
                return true;
            }
        }
        return false;
    };

    window.TwitterFixHelper = FixHelper;
    window.TwitterFixHelper_Constants = Constants;
})();
