var TMExt_$ = window.TMExt_$;
var PSBackground = {
    PageList : {
        "LocalPage_Background" : {
            port : null,
            tabID: null
        }
    },
    
    SendMessageToLocalPage : function(strMsg) {
        try {
            PSBackground.PageList["LocalPage_Background"].port.postMessage(strMsg);
        }catch(e){
        }
    },
    
    SendMessageToContentPage : function(destination, strMsg) {
        try {
            PSBackground.PageList[destination].port.postMessage(strMsg);
        }catch(e){
        }
    },
    
    UpdateUBM : function() {
        if (typeof (PSBGWrapper.PrivacyScannerUpdateUBM) != 'undefined') {
            PSBGWrapper.PrivacyScannerUpdateUBM();
        }
    },
    
    OpenHelpPage : function(msg) {
        var help_type = msg.dataIn.help_type;
        switch (help_type) {
            case "privacy_scanner_help":
                if (typeof (PSBGWrapper.ShowPSHelpPage) != 'undefined') {
                    PSBGWrapper.ShowPSHelpPage();
                }
                break;
            case "privacy_scanner_faq_help":
                if (typeof (PSBGWrapper.ShowPSFAQHelpPage) != 'undefined') {
                    var help_website = msg.dataIn.help_website;
                    var help_id = msg.dataIn.help_id;
                    PSBGWrapper.ShowPSFAQHelpPage(help_website, help_id);
                }
                break;
            default:
                //
        }
    },
    
    PSSettingSyncUp: function(msg) {
        if (typeof (PSBGWrapper.PrivacyScannerSetting) != 'undefined'){
            var setting_type = msg.dataIn.setting_type;
            var items = msg.dataIn.setting_items;
            if (setting_type == 'get'){
                //@input : [{key:'key1', value:'value1'}, {key:'key2', value:'value2}]
                var ret_items = PSBGWrapper.PrivacyScannerSetting(items, setting_type);
                //@output: [{key:'key1', value:'value1'}, {key:'key2', value:'value2}]
                var retMsg = TMExt_$.parseJSON(TMExt_$.toJSON(msg));
                retMsg.type = "privacy_scanner_setting_result";
                retMsg.dataOut = {
                    setting_items: ret_items
                };
                var strRetMsg = TMExt_$.toJSON(retMsg);
                if (msg.source == 'local') {
                    PSBackground.SendMessageToLocalPage(strRetMsg);
                } else {
                    PSBackground.SendMessageToContentPage(msg.dataIn.destination, strRetMsg);
                }
            } else {
                PSBGWrapper.PrivacyScannerSetting(items, setting_type);
            }
        }
    },
    
    PSCollectData: function(strMsg){
        if (typeof (PSBGWrapper.PrivacyScannerCollectData) != 'undefined') {
            PSBGWrapper.PrivacyScannerCollectData(strMsg);
        }
    },
    
    DoAJAX : function(msg) {
        var SendAjaxResultToLocalPage = function(msg) {
            msg.type = "ajax_request_result";
            var strMsg = TMExt_$.toJSON(msg);
            PSBackground.SendMessageToLocalPage(strMsg);
        };

        var params = msg.dataIn.params;
        var tryTimes = 0;
        var totalTryTimes = 3;
        var totalTryTimeout = 45 * 1000;
        var trigger = function(){
            TMExt_$.ajax({
                type     : params.type,
                url      : params.url,
                dataType : params.dataType,
                data     : params.data || '',
                timeout  : totalTryTimeout / totalTryTimes,
                success  : function(callback_data) {
                    msg.dataOut = {
                        ret_status : true,
                        ret_value : callback_data
                    };
                    SendAjaxResultToLocalPage(msg);
                },
                error    : function(xhr, ajaxOptions, thrownError) {
                    if (++tryTimes <= totalTryTimes) {
                        console.log('try' + tryTimes + '/' + totalTryTimes + ' times');
                        setTimeout(trigger, 100);
                    } else {
                        msg.dataOut = {
                            ret_status : false,
                            ret_value : null
                        };
                        SendAjaxResultToLocalPage(msg);
                    }
                }
            });
        };
        trigger();
    },
    
    RequestForBrowsers: function(strMsg) {
        if (typeof (PSBGWrapper.PrivacyScannerRequestForBrowsers) != 'undefined') {
            PSBGWrapper.PrivacyScannerRequestForBrowsers(strMsg);
        }
    },

    triggerScan: function(browserLocale) {
        var from = ['ITIS', 'BROWSER_TOOLBAR'].join(',');
        var url = browser.extension.getURL('PrivacyScanner/local_page/index.html?locale='
            + browserLocale + '&from=' + from);
        var urlRegExp = new RegExp('PrivacyScanner/local_page/index.html', 'i');

        browser.tabs.query({}, function(tabList) {
            var hasTab = false;
            for (var i in tabList) {
                var tab = tabList[i];
                if (urlRegExp.test(tab.url)) {
                    browser.tabs.update(tab.id, {
                        active: true
                    });
                    hasTab = true;
                }
            }

            if (!hasTab) {
                browser.tabs.create({url: url});
            }
        });

        return true;
    },
    
    init : function() {  
        browser.runtime.onConnect.addListener(function(port) {
            console.log(port.name);
            if (port.name == "LocalPage_Background") {
                if (PSBackground.PageList[port.name].tabID == null) {
                    PSBackground.PageList[port.name].tabID = port.sender.tab.id;
                } else {
                    browser.tabs.remove(port.sender.tab.id, function(){});
                    browser.tabs.update(PSBackground.PageList[port.name].tabID, {active:true});
                    return;
                }

                PSBackground.PageList[port.name].port = port;
                port.onDisconnect.addListener(function(msg) {
                    PSBackground.PageList[msg.name].tabID = null;
                });
                port.onMessage.addListener(function(MSG) {
                    var strMsg = MSG.data;
                    console.log('strMsg=' + strMsg + '\n');
                    var msg = TMExt_$.parseJSON(strMsg);
                    
                    //Common Request
                    if (msg.type == "update_ubm") {
                        PSBackground.UpdateUBM();
                        return;
                    }
                    
                    if (msg.type == "open_help_page") {
                        PSBackground.OpenHelpPage(msg);
                        return;
                    }
                    
                    if (msg.type == "write_file_log") {
                        if (typeof (PSBGWrapper.PrivacyScannerLog) != 'undefined') {
                            PSBGWrapper.PrivacyScannerLog(msg.dataIn.data);
                        }
                        return;
                    }
                    
                    if (msg.type == "privacy_scanner_setting") {
                        PSBackground.PSSettingSyncUp(msg);
                        return;
                    }
                    
                    if (msg.type == "data_collection") {
                        PSBackground.PSCollectData(strMsg);
                        return;
                    }
                    
                    //Privacy Scanner
                    if (msg.isBrowser) {
                        //Scan Browser
                        PSBackground.RequestForBrowsers(strMsg);
                    } else {
                        //Scan SNS
                        if (msg.type == "ajax_request") {
                            PSBackground.DoAJAX(msg);
                            return;
                        }

                        if (msg.type == "login") {
	                        browser.tabs.create({
		                        url: msg.target_url,
		                        active: msg.active
	                        }, function (tab) {
	                        });

	                        return;
                        }
                        
                        if (msg.target_url != "") {
                            if (!PSBackground.PageList[msg.destination]) {
                                PSBackground.PageList[msg.destination] = {};
                            }
                        
                            if (msg.needForceNewTab == true){
                                PSBackground.PageList[msg.destination].connected = false;
                            }
                            
                            var needOpenTab = false;
	                        if (msg.type == "get_sns_account_info") {
		                        browser.tabs.query({}, function (tabList) {
			                        var hasTab = false;
			                        for (var i = 0; i < tabList.length; i++) {
				                        var urlRegx = new RegExp(msg.target_url, 'i');
				                        if (urlRegx.test(tabList[i].url)) {
					                        hasTab = true;
					                        browser.tabs.update(tabList[i].id, {'active': msg.active});
					                        break;
				                        }
			                        }
			                        if (hasTab === false) {
				                        browser.tabs.create({url: msg.target_url, active: false});
			                        }
		                        });
	                        } else {
		                        if (!PSBackground.PageList[msg.destination].connected) {
			                        needOpenTab = true;
			                        browser.tabs.create({
				                        url: msg.target_url,
				                        active: msg.active
			                        }, function (tab) {
				                        PSBackground.PageList[msg.destination].tabID = tab.id;
			                        });
		                        } else {
			                        if(msg.dataIn.Website == 'TWITTER') {
				                        browser.tabs.query({}, function (tabList) {
					                        var hasTab = false;
					                        for (var i = 0; i < tabList.length; i++) {
						                        var urlRegx = new RegExp(msg.target_url, 'i');
						                        if (urlRegx.test(tabList[i].url)) {
							                        hasTab = true;
							                        browser.tabs.update(tabList[i].id, {'active': msg.active});
							                        break;
						                        }
					                        }
					                        if (hasTab === false) {
						                        browser.tabs.create({url: msg.target_url, active: false});
					                        }
				                        });
			                        }
		                        }
	                        }
        
                            var TotalWaitTime = 30 * 1000;
                            var EachWaitTime = 2 * 1000;
                            var tryTimes = 0;
                            var NumberOfTryTimes = TotalWaitTime / EachWaitTime;
                            var TryToSendMessageToDestination = function() {
                                tryTimes++;
                                var ReturnError = function() {
                                    console.log(msg.destination +
                                        "is not connected, return error:80000000");
                                    var retMsg = TMExt_$.parseJSON(TMExt_$.toJSON(msg));
                                    retMsg.type = "error";
                                    retMsg.dataOut = {
                                        ret_status : false,
                                        ret_value : "80000000"
                                    };
                                    var strRetMsg = TMExt_$.toJSON(retMsg);
                                    PSBackground.SendMessageToLocalPage(strRetMsg);
                                };
                                console.log('Try ' + tryTimes + ' times');
                                if (PSBackground.PageList[msg.destination].connected) {
                                    PSBackground.SendMessageToContentPage(msg.destination, strMsg);
                                } else {
                                    if (tryTimes < NumberOfTryTimes) {
                                        setTimeout(TryToSendMessageToDestination, EachWaitTime);
                                    } else {
                                        ReturnError();
                                    }
                                }
                            };
                            
                            if (needOpenTab) {
                                setTimeout(TryToSendMessageToDestination, 2000);
                            } else {
                                TryToSendMessageToDestination();
                            }
                        } 
                    }
                });
            } else {
                //opened from local page so that handle content page connection
                if (PSBackground.PageList[port.name]) {
                    PSBackground.PageList[port.name].connected = true;
                    PSBackground.PageList[port.name].port = port;
                    port.onDisconnect.addListener(function(msg) {
                        PSBackground.PageList[msg.name].connected = false;
                    });
                    port.onMessage.addListener(function(MSG) {
                        var strMsg = MSG.data;
                        console.log('strMsg=' + strMsg + '\n');
                        
                        var msg = TMExt_$.parseJSON(strMsg);
                        if (msg.type == "privacy_scanner_setting") {
                            PSBackground.PSSettingSyncUp(msg);
                            return;
                        }
                        
                        if (msg.type == "data_collection") {
                            PSBackground.PSCollectData(strMsg);
                            return;
                        }
                        
                        PSBackground.SendMessageToLocalPage(strMsg);
                    });
                }
            }
        });
    }
};

window.addEventListener("load", PSBackground.init, false);
