(function() {
    var server = window.server;
    TMExt_$.extend(server, window.ITISBrowserExtServer);
    
    var PSLocalPageConfig = {
        getValue: function(key) {
            if (key === 'IsFirstSaveChanges') {
                return localStorage.IsFirstSaveChanges !== undefined ?
                    localStorage.IsFirstSaveChanges === 'true' : true;
                
            } else if (key === 'IsFirstFixTwitter') {
                return localStorage.IsFirstFixTwitter !== undefined ?
                    localStorage.IsFirstFixTwitter === 'true' : true;
            
            } else if (key === 'IsFirstFixLinkedIn') {
                return localStorage.IsFirstFixLinkedIn !== undefined ?
                    localStorage.IsFirstFixLinkedIn === 'true' : true;
            
            } else if (key === 'IsConsoleLogEnabled') {
                return localStorage.IsConsoleLogEnabled !== undefined ?
                    localStorage.IsConsoleLogEnabled === 'true' : true;

            } else if (key === 'IsFileLogEnabled') {
                return false;
            }
        },
        
        setValue: function(key, value) {
            localStorage[key] = value;
        }
    };
    
    //@input : [{key:'key1', value:'value1'}, {key:'key2', value:'value2}]
    var PrivacyScannerSetting = function(items, setting_type){
        if (setting_type === 'get') {
            //@output: [{key:'key1', value:'value1'}, {key:'key2', value:'value2}]
            var ret_items = TMExt_$.parseJSON(TMExt_$.toJSON(items));
            for (var i in ret_items) {
                var item = ret_items[i];
                item.value = PSLocalPageConfig.getValue(item.key);
            }
            return ret_items;
            
        } else if (setting_type === 'set') {
            for (var i in items) {
                var item = items[i];
                PSLocalPageConfig.setValue(item.key, item.value);
            }

            return null;
        }
    };
    
    var PrivacyScannerLog = function(data) {
        //Write data to log file
        // do nothing
    };
    
    var ShowPSHelpPage = function() {
        console.log('==> ShowPSHelpPage');
        //TODO ask server to open PS help
        server.showPrivacyScannerHelp();
    };
    
    var ShowPSFAQHelpPage = function(website, helpId) {
        if (helpId === undefined) {
            // do nothing
        
        } else {
            console.log('==> ShowPSErrorHelpPage, helpId=' + helpId);
            server.showPrivacyScannerErrorPage(helpId);
        }
    };
    
    window.PSBGWrapper = {
        PrivacyScannerSetting:              PrivacyScannerSetting,
        PrivacyScannerLog:                  PrivacyScannerLog,
        ShowPSHelpPage:                     ShowPSHelpPage,
        ShowPSFAQHelpPage:                  ShowPSFAQHelpPage
        // PrivacyScannerUpdateUBM:            PrivacyScannerUpdateUBM,
        // PrivacyScannerRequestForBrowsers:   PrivacyScannerRequestForBrowsers
    };
})();