describe("test wtp block page rule", function() {
	var utility;
	beforeEach(function() {
		;
	});

	let inputs = [
		{ wtp_level:__LOW__, level:__SAFE__				},
		{ wtp_level:__LOW__, level:__NEUTRAL__			},
		{ wtp_level:__LOW__, level:__DANGEROUS__		},
		{ wtp_level:__LOW__, level:__SUSPICIOUS__ 		},
		{ wtp_level:__LOW__, level:__UNTESTED__ 		},
		{ wtp_level:__LOW__, level:__TRUSTED__ 			},
		{ wtp_level:__LOW__, level:__BLOCKED__ 			},
		{ wtp_level:__LOW__, level:__PC_BLOCKED__ 		},
		{ wtp_level:__LOW__, level:__HIGH_SUSPICIOUS__ 	},

		{ wtp_level:__NORMAL__, level:__SAFE__				},
		{ wtp_level:__NORMAL__, level:__NEUTRAL__			},
		{ wtp_level:__NORMAL__, level:__DANGEROUS__			},
		{ wtp_level:__NORMAL__, level:__SUSPICIOUS__ 		},
		{ wtp_level:__NORMAL__, level:__UNTESTED__ 			},
		{ wtp_level:__NORMAL__, level:__TRUSTED__ 			},
		{ wtp_level:__NORMAL__, level:__BLOCKED__ 			},
		{ wtp_level:__NORMAL__, level:__PC_BLOCKED__ 		},
		{ wtp_level:__NORMAL__, level:__HIGH_SUSPICIOUS__ 	},

		{ wtp_level:__HIGH__, level:__SAFE__				},
		{ wtp_level:__HIGH__, level:__NEUTRAL__				},
		{ wtp_level:__HIGH__, level:__DANGEROUS__			},
		{ wtp_level:__HIGH__, level:__SUSPICIOUS__ 			},
		{ wtp_level:__HIGH__, level:__UNTESTED__ 			},
		{ wtp_level:__HIGH__, level:__TRUSTED__ 			},
		{ wtp_level:__HIGH__, level:__BLOCKED__ 			},
		{ wtp_level:__HIGH__, level:__PC_BLOCKED__ 			},
		{ wtp_level:__HIGH__, level:__HIGH_SUSPICIOUS__ 	},

	];
	let describes = [
		"wtp level is low, level is safe,    		 result is null",
		"wtp level is low, level is neutral, 		 result is null",
		"wtp level is low, level is dangerous, 		 result is UrlfWTP.htm",
		"wtp level is low, level is suspicious, 	 result is null",
		"wtp level is low, level is untested, 		 result is null",
		"wtp level is low, level is trusted, 		 result is null",
		"wtp level is low, level is blocked, 		 result is UrlfUD.htm",
		"wtp level is low, level is pc_blocked, 	 result is UrlfCat.htm",
		"wtp level is low, level is high_suspicious, result is null",

		"wtp level is normal, level is safe,    		result is null",
		"wtp level is normal, level is neutral, 		result is null",
		"wtp level is normal, level is dangerous, 		result is UrlfWTP.htm",
		"wtp level is normal, level is suspicious, 	 	result is null",
		"wtp level is normal, level is untested, 		result is null",
		"wtp level is normal, level is trusted, 		result is null",
		"wtp level is normal, level is blocked, 		result is UrlfUD.htm",
		"wtp level is normal, level is pc_blocked, 	 	result is UrlfCat.htm",
		"wtp level is normal, level is high_suspicious, result is UrlfWTP.htm",

		"wtp level is high, level is safe,    		  result is null",
		"wtp level is high, level is neutral, 		  result is null",
		"wtp level is high, level is dangerous, 	  result is UrlfWTP.htm",
		"wtp level is high, level is suspicious, 	  result is UrlfWTP.htm",
		"wtp level is high, level is untested, 		  result is null",
		"wtp level is high, level is trusted, 		  result is null",
		"wtp level is high, level is blocked, 		  result is UrlfUD.htm",
		"wtp level is high, level is pc_blocked, 	  result is UrlfCat.htm",
		"wtp level is high, level is high_suspicious, result is UrlfWTP.htm",
	];
	let outputs = [
	null,null,"UrlfWTP.htm",null,null,null,"UrlfUD.htm","UrlfCat.htm",null,
	null,null,"UrlfWTP.htm",null,null,null,"UrlfUD.htm","UrlfCat.htm","UrlfWTP.htm",
	null,null,"UrlfWTP.htm","UrlfWTP.htm",null,null,"UrlfUD.htm","UrlfCat.htm","UrlfWTP.htm",
	];
	for(let i=0; i<inputs.length; ++i){
		it(describes[i],function(){
			let response 	= 	inputs[i];
			let wtp_level 	= 	response.wtp_level;
			let level 		= 	response.level;
			let url = wpt_getUrl(wtp_level,level);
			if(url!=null){
				if(wtp_level == __NORMAL__ && level == __SUSPICIOUS__){
					let a = 0;
				}
				let substring = outputs[i];
				expect(url.indexOf(substring)).not.toEqual(-1);
			}else{
				if(wtp_level == __NORMAL__ && level == __SUSPICIOUS__){
					let a = 0;
				}
				expect(url).toEqual(outputs[i]);
			}
			// console.log(`wtp_level is ${wtp_level}, level is ${level}, url is ${url}`);
		});
	}
});