//for WTP rating Only https.
(function() {
    let protocol = document.location.protocol;
    let port = document.location.port;

    let wtp_response_handler = function(response){
        let path = wtp_dealRatingResponse(response);

        if( typeof(response.url)!="undefined" && 
            response.url != document.location.href){
            return ;
        }

        if(path == null){
            return ;
        }
        //send PUM Data
        let browserType = wtp_getBrowserType();
        let event = wtp_getPUMEvent(protocol,path);
        let value = `${response.level}|${response.categoryGroup}|${response.category}`;
        switch(browserType){
            case __CHROME__:
                chrome.extension.sendMessage({cmd:'send_data',params:{type:event,value:value}});
                break;
            case __FIREFOX__:
                browser.runtime.sendMessage({cmd:'send_data',params:{type:event,value:value}});
                break;
            case __SAFARI__:
                safari.extension.dispatchMessage('send_data',{type:event,value:value});
                break;
        }
        if( wtp_currentIsBlockPage() ){
            return ;
        }
        //jump to block page
        document.location.replace(path);
    };


    let curUrl = document.location.href;
    let item   = {"id": 1, url: curUrl};
    
    let browserType = wtp_getBrowserType();
    if(browserType != __SAFARI__){
        var sendMessage = chrome.extension.sendMessage;
        if(browserType == __FIREFOX__){
            sendMessage = browser.runtime.sendMessage;
        }
        sendMessage({cmd: 'wtp_rating',params: {urls: [item]}}, function (response) {wtp_response_handler(response);});
        return ;
    }

    //current browser is safari
    safari.self.addEventListener("message", function(event) {
        if (event.name == 'wtp_rating') {
            var response = event.message.results;
            response.wtp_level = event.message.wtp_level;
            wtp_response_handler(response);
        }
    });
    safari.extension.dispatchMessage('wtp_rating', {urls: [item]});
})();
