var TMExt_$ = window.TMExt_$;
var L10NHelper = window.L10NHelper;

var Debug = window.log;
var TAG = 'background';

var Setting = window.Setting;
var setting = new Setting();

var ITISBrowserExtServer = window.ITISBrowserExtServer;
var server = new ITISBrowserExtServer(setting);

var PSBackground = window.PSBackground;

var urlPattern = {};

server.loadURLPattern(function (data) {
	Debug.logDebug(TAG, 'callback of loadURLPattern, data.status=' + data.status);
	if (data.status === 'success') {
		urlPattern = data.pattern;
	}
});

L10NHelper.loadWordings();

var loadPopupWordings = function () {
	var popupWordings = {};
	var menu_titles = ['automaticscan', 'manualscanner','fraud_buster', 'setting', 'help', 'privacyscanner'];
	for (var idx in menu_titles) {
		popupWordings[menu_titles[idx]] = browser.i18n.getMessage(menu_titles[idx]);
	}
	TMExt_$.extend(window.setting, {'popupWordings': popupWordings});
	// window.setting['popupWordings'] = popupWordings;
};

loadPopupWordings();

var getPSPromotionLocaleUrl = function (resourcePath) {
	var promotionURL = browser.extension.getURL('PrivacyScanner/PSPromotion/locale/' + L10NHelper.getBrowserLanguage() + '/' + resourcePath);
	return promotionURL;
};


function initBackgroundListener() {
	browser.runtime.onMessage.addListener(function (request, sender, sendResponse) {

		var message = request;
		if (message) {
			Debug.logDebug(TAG, 'on popupClick, data=' + JSON.stringify(message));
		}

		if (message.event === 'popupItemClick') {
			if (message.item === 'automaticscan') {
				server.enableAutomaticScan();

			} else if (message.item === 'manualscanner') {
				server.enableManualScanner();

			} else if (message.item === 'privacyscanner') {
				var browserLocale = L10NHelper.getBrowserLanguage();
				PSBackground.triggerScan(browserLocale);

			} else if (message.item === 'setting') {
				server.showToolbarUI();

			} else if (message.item === 'help') {
				ITISBrowserExtServer.showHelp();
			}
		}

		if (!message || !message.cmd || !message.params) {
			Debug.logError('background', 'onMessage: data format is invalid.');
		}

		if (message.cmd === 'loadPagePattern') {

			var that = this;
			var _loadPagePattern = function () {
				that.id = findContentPattern(message.params, urlPattern);

				// // 构建队列
				// function queue(arr) {
				// 	var sequence = Promise.resolve();
				// 	arr.forEach(function (item) {
				// 		sequence = sequence.then(item);
				// 	});
				// 	return sequence;
				// }

				if (that.id) {
					// let p1 = browser.tabs.executeScript(sender.tab.id, { file: "/_locales/" + L10NHelper.getBrowserLanguage() + "/TISProToolbarLocalization.js" });
					// let p2 = browser.tabs.executeScript(sender.tab.id, { file: "/content_lib.js" });
					// let p3 = browser.tabs.executeScript(sender.tab.id, { file: "/manualscan.js" });
					// let p4 = browser.tabs.executeScript(sender.tab.id, { file: "/patternRate.js" });
					// let p5 = browser.tabs.executeScript(sender.tab.id, { file: "/CRPattern/TISPro" + id + ".js" });
					//
					// // 执行队列
					// queue([p1, p2, p3, p4, p5]).then(data => {
					// 	onScriptsLoaded();
					// });

					browser.tabs.executeScript(sender.tab.id, { file: "/_locales/" + L10NHelper.getBrowserLanguage() + "/TISProToolbarLocalization.js" }, function() {
						browser.tabs.executeScript(sender.tab.id, { file: "/content_lib.js" }, function() {
							browser.tabs.executeScript(sender.tab.id, { file: "/manualscan.js" }, function() {
								browser.tabs.executeScript(sender.tab.id, { file: "/patternRate.js" }, function() {
									browser.tabs.executeScript(sender.tab.id, { file: "/CRPattern/TISPro" + id + ".js" }, function() {
										onScriptsLoaded();
									});
								});
							});
						});
					});
				}
				else {
					onScriptsLoaded();
				}
			};

			var onScriptsLoaded = function () {
				var retData = {};
				Debug.logDebug('loadPagePattern', 'pattern loaded, id=' + that.id);
				if (!setting.EnableAutomaticScan || setting.LicenseExpired
						|| setting.serverStopped) {
					Debug.logWarning('auto rate is disabled, setting=', TMExt_$.toJSON(setting));
				}
				// load patternPage code here
				TMExt_$.extend(retData, {
					setting: setting
				});
				Debug.logDebug('background', 'loadPagePattern successfully');
				sendResponse(retData);
			};

			if(JSON.stringify(urlPattern)==="{}"){
				setting.urlpatternLoaded = false;
			}else{
				setting.urlpatternLoaded = true;
			}

			//check server status
			// if serverStopped , reload urlPattern here
			if (setting.serverStopped ||
				setting.LicenseExpired ||
				!setting.ToolbarEnableStatus ||
				!setting.urlpatternLoaded) {
				server.loadURLPattern(function (textStatus) {
					Debug.logDebug('background', 'reload urlPattern after server stopped,' +
						' textStatus=' + JSON.stringify(textStatus));
					if (textStatus.status === 'success') {
						urlPattern = textStatus.pattern;
					}
					_loadPagePattern();
				});

			} else {
				_loadPagePattern();
			}
		}

		if (message.cmd === 'rateItems') {
			var that = this;
			rateItems(message.params.urls, function (results) {
				if (setting['Enable' + message.params.type] &&
					!setting.serverStopped &&
					!setting.LicenseExpired &&
					setting.ToolbarEnableStatus) {

					that.rateResults = results;

					if (that.rateResults) {
						sendResponse(that.rateResults);
					}
				}
			}, false);
		}

		if(message.cmd == "wtp_rating"){
			var that = this;
			server._loadSetting(function(){
				if(!setting.serverStopped &&
					!setting.LicenseExpired &&
					setting.ToolbarEnableStatus){
					rateWTPItem(message.params.urls, function (results) {
						response = results.results[0];
						response.wtp_level = results.wtp_level;
						sendResponse(response);
					}, false);
				}
			});
		}

		if(message.cmd == "open_new_tab"){
			browser.tabs.create({
				url:message.params.url
			});
		}

		if(message.cmd == "send_command"){
			if(!setting.serverStopped &&
				!setting.LicenseExpired &&
				setting.ToolbarEnableStatus){
				let settingUrl = "http://127.0.0.1:37848/BrowserExt/command";
			    let data = message.params;//{type:type,email:email,iat:Date.parse(new Date())/1000};
			    let type = data.type=="fb_get_secret"?"html":"json";
			    TMExt_$.ajax({
			      url:settingUrl,
			      dataType:type,
			      data:data,
			      success:function(data){
			      	sendResponse(data);
			      }
			    });
				
			}
		}

		else if(message.cmd == "send_data"){
			if(!setting.serverStopped &&
				!setting.LicenseExpired &&
				setting.ToolbarEnableStatus){
				let settingUrl = "http://127.0.0.1:37848/BrowserExt/sendData";
				let param = Object.assign(message.params,{browser:"firefox"});
				TMExt_$.ajax({url:settingUrl,type:"POST",dataType:"html",data:param,success:function(data){}});
			}
		}


		// PSPromotionBackgroundFirefox
		Debug.logDebug(sender.tab ? "from a content script:" + sender.tab.url : "from the extension");
		if (request.method === 'getPSPromotionWordings') {

			TMExt_$.getJSON(getPSPromotionLocaleUrl('PSPromotionLocalization.json'),
				function (data) {
					Debug.logDebug(data);
					var g_oPrivacyScannerString = data.g_oPrivacyScannerString;
					var g_oPrivacyScannerString_autoScan = data.g_oPrivacyScannerString_autoScan;

					ITISBrowserExtServer.getPSPromotionSetting(function (PSPromotionSetting) {
						Debug.logDebug(PSPromotionSetting);

						ITISBrowserExtServer.getProductName(L10NHelper.getBrowserLanguage(),
							function (productName) {

								sendResponse({
									wordings: {
										g_oPrivacyScannerString: g_oPrivacyScannerString,
										g_oPrivacyScannerString_autoScan: g_oPrivacyScannerString_autoScan,
										productName: productName
									},
									settings: PSPromotionSetting
								});
							});
					});
				});
		}

		if (request.method === 'doCheckPrivacy') {
			var from = ['ITIS', 'SNS_' + request.scanWebSite].join(',');
			var url = browser.extension.getURL('PrivacyScanner/local_page/index.html?locale=' + L10NHelper.getBrowserLanguage() + '&from=' + from);

			browser.tabs.query({}, function (tabList) {
				var hasTab = false;
				for (var i in tabList) {
					var tab = tabList[i];
					var urlRegExp = new RegExp("PrivacyScanner/local_page/index.html", "i");
					if (urlRegExp.test(tab.url)) {

						hasTab = true;
						// workaround for multiple open issue from SNS promotion
						browser.tabs.remove(tab.id).then(function () {
							browser.tabs.create({
								url: url
							});
						});

						// browser.tabs.update(tab.id, {
						// 	url: url,
						// 	active: true
						// });
					}
				}

				if (!hasTab) {
					browser.tabs.create({
						url: url
					});
				}
			});

		} else if (request.method === 'openLearnMorePage') {
			server.showPrivacyScannerHelp();

		} else if (request.method === 'setShowPromotion') {
			var website = request.website;
			var showOrNot = request.showOrNot;

			var key;
			if (website === 'FACEBOOK') {
				key = 'ShowFaceBookPromotion';

			} else if (website === 'TWITTER') {
				key = 'ShowTwitterPromotion';

			} else if (website === 'GOOGLEPLUS') {
				key = 'ShowGooglePlusPromotion';

			} else if (website === 'LINKEDIN') {
				key = 'ShowLinkedInPromotion';
			}

			if (key) {
				ITISBrowserExtServer.setPSPromotionSetting(key, showOrNot);
			}
		}
		return true;
	});
}

initBackgroundListener();

var findContentPattern = function (pageInfo, urlPatterns) {
	Debug.logDebug('loadPagePattern', 'page href=' + pageInfo.href);
	for (var id in urlPatterns) {
		var urlPattern = urlPatterns[id];
		if (!urlPattern.reg) {
			urlPattern.reg = new RegExp(urlPattern.URLPattern, 'i');
		}
		if (urlPattern.reg.test(pageInfo.href)) {
			Debug.logDebug('loadPagePattern', 'matched patternid =' + id);
			return id;
		}
	}
	return undefined;
};

var getLocaleURL = function (url) {
	return browser.extension.getURL('_locales/' + L10NHelper.getBrowserLanguage() + '/' + url);
};

var matchShortURL = (function () {
	var shortURLPattern = {
		tCo: 'https?://t\\.co',
		bitLy: 'https?://bit\\.ly',
		isGd: 'https?://is\\.gd',
		gooGl: 'https?://goo\\.gl',
		owLy: 'https?://ow\\.ly',
		lnkdIn: 'https://lnkd\\.in',
		tinyurlCOM: 'https?://tinyurl\\.com',
		lnkMs: 'https?://lnk\\.ms',
		msplinksCom: 'https?://www\\.msplinks\\.com',
		tCn: 'https?://t\\.cn',
		urlCn: 'https?://url\\.cn',
		linkedinCom: 'https?://www\\.linkedin\\.com',
		baidu: 'https?://www\\.baidu\\.com/link\\?url=',
		myspace: 'https?://mysp\\.ac'
	};
	for (var p in shortURLPattern) {
		shortURLPattern[p] = new RegExp(shortURLPattern[p], 'i');
	}
	return function (url) {
		for (var p in shortURLPattern) {
			if (shortURLPattern[p].test(url)) {
				return p;
			}
		}
		return null;
	};
})();


var rateItems = function (urls, onResult, _encodeURL) {
	TMExt_$.each(urls, function (i, item) {
		if (_encodeURL) {
			item.url = encodeURI(item.url);
		}
		var shortURLID = matchShortURL(item.url);
		item.needResolving = shortURLID ? true : false;
	});

	server.rateURL(urls, onResult);
};

var rateWTPItem = function (urls, onResult, _encodeURL) {
	TMExt_$.each(urls, function (i, item) {
		if (_encodeURL) {
			item.url = encodeURI(item.url);
		}
		var shortURLID = matchShortURL(item.url);
		item.needResolving = shortURLID ? true : false;
	});

	server.rateWTPURL(urls, onResult);
};

// TMExt_$.ajaxSetup({
// 	async: false,
// 	beforeSend: function (jqXHR, settings) {
// 		jqXHR.setRequestHeader('TMEExtSetting_ModifiedTime',
// 			setting.getLastModifyTime());
// 	}
// });

TMExt_$(document).ajaxSuccess(function (event, jqXHR, settings) {
});

TMExt_$(document).ajaxError(function (event, jqXHR, ajaxSettings, thrownError) {
	Debug.logError('background', 'ajaxError, ' + 'errorThrown=' + thrownError);
	let url = ajaxSettings.url;
	if( url.indexOf("type=fb")==-1 && 
		url.indexOf("toolbarAlive")==-1 ){
		setting.update({serverStopped: true});
	}
});

Debug.logDebug('background', 'load pattern and setting');
setting.serverStopped = false;
urlPattern = {};
setting.urlpatternLoaded = false;
server.loadURLPattern();
Debug.logDebug('background', 'background loaded');

// setup server setting listener
var retryTime = 0;
var timer = setInterval(function () {
	TMExt_$.ajax({
		url:"http://127.0.0.1:37848/BrowserExt/toolbarAlive",
		error:function(xhr, textStatus, errorThrown){
			retryTime++;
			if(retryTime>=5){
				clearInterval(timer);
				timer = null;
			}
		}
	});
}, 2000);
