var Debug = window.log;
var TMExt_$ = window.TMExt_$;

/********************************************************************
 ** MAYBE NEED L10N this section, If not, Don't modify above code  **
 ********************************************************************/
var g_oImgDefine = {
    Nolink: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_nolink.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.Nolink,
            HelpString: g_oRatingLevelToolTipString.HelpString.Nolink
        },
        WebIcon: '/images/webicon_nolink.png',
        Highlight: '#BDBDBD'
    },
    Safe: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_green.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.Safe,
            HelpString: g_oRatingLevelToolTipString.HelpString.Safe
        },
        WebIcon: '/images/webicon_green.png',
        Highlight: '#b8eab8'
    },
    Neutral: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_green.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.Neutral,
            HelpString: g_oRatingLevelToolTipString.HelpString.Neutral
        },
        WebIcon: '/images/webicon_green.png',
        Highlight: '#b8eab8'
    },
    Dangerous: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_red.png',
            TextColor: '#333',
            SiteUrlColor: '#ed1c24',
            LevelString: g_oRatingLevelToolTipString.LevelString.Dangerous,
            HelpString: g_oRatingLevelToolTipString.HelpString.Dangerous
        },
        WebIcon: '/images/webicon_red.png',
        Highlight: '#FA8F8F'
    },
    Suspicious: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_yellow.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.Suspicious,
            HelpString: g_oRatingLevelToolTipString.HelpString.Suspicious
        },
        WebIcon: '/images/webicon_yellow.png',
        Highlight: '#FCC465'
    },
    Untested: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_gray.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.Untested,
            HelpString: g_oRatingLevelToolTipString.HelpString.Untested
        },
        WebIcon: '/images/webicon_gray.png',
        Highlight: '#BDBDBD'
    },
    Trusted: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_green.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.Trusted,
            HelpString: g_oRatingLevelToolTipString.HelpString.Trusted
        },
        WebIcon: '/images/webicon_green.png',
        Highlight: '#b8eab8'
    },
    Blocked: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_red.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.Blocked,
            HelpString: g_oRatingLevelToolTipString.HelpString.Blocked
        },
        WebIcon: '/images/webicon_red.png',
        Highlight: '#FA8F8F'
    }, PCBlocked: {
        Tail: {
            TopRight: '/images/red_bottom_left.png',
            TopLeft: '/images/red_bottom_right.png',
            BottomRight: '/images/red_top_left.png',
            BottomLeft: '/images/red_top_right.png'
        },
        Content: {
            Icon: '/images/icon_red.png',
            TextColor: '#333',
            SiteUrlColor: '#999',
            LevelString: g_oRatingLevelToolTipString.LevelString.PCBlocked,
            HelpString: g_oRatingLevelToolTipString.HelpString.PCBlocked
        },
        WebIcon: '/images/webicon_red.png',
        Highlight: '#FA8F8F'
    },
    ImgSize: {
        WebIcon: {
            width: 16,
            height: 16
        },
        Icon: {
            width: 46,
            height: 46
        },
        Tail: {
            width: 30,
            height: 60
        },
        PopupBodySize: {
            width: 300,
            height: 250 // max height
        },
        WarningIcon: {
            width: 16,
            height: 16
        }
    },
    LinkIcon: '/images/arrow_blue.gif',
    CloseIcon: '/images/close_pop.png',
    DotLine: '/images/dotline.gif',
    ShareIcon: '/images/trendlogo.png',
    LogoIcon: '/images/PC_Icon_Guide_16.png'
};

/*****************************************
 ** ATTENTION!! Don't modify above code **
 *****************************************/

/*
 * Define common constant
 */
var D_TSRSpanIDPrefix = 'TSRSpan_';
var D_TSRToolTipID = 'TSRToolTipLayer';
var D_TSRToolTipTailID = 'TSRToolTipTail';
var D_TSRToolTipBodyID = 'TSRToolTipBody';
var D_TSRToolTipTitleID = 'TSRToolTipTitle';
var D_TSRToolTipCloseSpanID = 'TSRToolTipCloseSpan';
var D_TSRToolTipLogoSpanID = 'TSRToolTipLogoSpan';
var D_TSRToolTipCloseID = 'TSRToolTipClose';
var D_TSRToolTipIconID = 'TSRToolTipIcon';
var D_TSRToolTipRLStringID = 'TSRToolTipRLString';
var D_TSRToolTipRLDetailedID = 'TSRToolTipRLDetailed';
var D_TSRToolTipRLDetailedShareID = 'TSRToolTipRLDetailedShare';
var D_TSRToolTipCheckUrlID = 'TSRCheckUrl';
var D_TSRToolTipSiteNameID = 'TSRToolTipSiteName';
var D_TSRToolTipSiteUrlID = 'TSRToolTipSiteUrl';
var D_TSRToolTipPhishingID = 'TSRToolTipPhishing';
var D_TSRToolTipTrustPageID = 'TSRToolTipTrustPage';
var D_TSRToolTipTrustPageLinkID = 'TSRToolTipTrustPageLink';

var D_TSRToolTipReviewPageID = 'TSRToolTipReviewPage';
var D_TSRToolTipReviewPageLinkID = 'TSRToolTipReviewPageLink';

var D_TSRToolTipShowClass = 'TSRshow';
var D_TSRToolTipHideClass = 'TSRhide';

var D_TSRHIGHLIGHT_COLOR_OFF = 'transparent';

var D_HTTP_PREFIX = 'http://';
var D_PIXEL_UNIT = 'px';

var D_SITE_MSG_TRUNCATE_LIMIT = 35;
var D_SITE_MSG_TRUNCATE_SUFFIC = '...';
var D_GAP_BETWEEN_ICON_TITLE = '2px';

var D_TOOLBAR_CALLBACK_ACTIVEX_PROG_ID = 'ProToolbarIMRatingActiveX.ToolbarCB';

/*
 * Define Rating Level mapping to Image Information Array
 * Don't feel free to modify this. It must map to plugin definition
 */
var g_oRatingLevel = {
    0: g_oImgDefine.Nolink,
    1: g_oImgDefine.Safe,
    2: g_oImgDefine.Neutral,
    3: g_oImgDefine.Dangerous,
    4: g_oImgDefine.Suspicious,
    5: g_oImgDefine.Untested,
    6: g_oImgDefine.Trusted,
    7: g_oImgDefine.Blocked,
    8: g_oImgDefine.PCBlocked,
    9: g_oImgDefine.Suspicious
};

///End   Import [import/PrivacyCommonComponent/CommonEngine/CheckRating/CREngine/TISProToolbarDefine.js]
///End   Import [src/lib/TISProToolbarDefine.js]


///Begin Import [src/lib/TISProToolbarLib.js]

// disable these two features, TISProToolbarLib.js will read these configure
window.ProductFeatureConfig = {
    EnableUntestedFeedbackFeature: false,
    EnableFacebookAlertYourFriend: false,
    EnableSafeSearching: false
};


///Begin Import [import/PrivacyCommonComponent/CommonEngine/CheckRating/CREngine/TISProToolbarLib.js]

var exports = window;
var imports = window;

/*
 * Product Feature Configuration Area
 */
var TitaniumFeatureConfig = {
    EnableUntestedFeedbackFeature: true,
    EnableFacebookAlertYourFriend: true,
    EnableSafeSearching: true
};

if (typeof (imports.ProductFeatureConfig) != 'undefined') {
    if (typeof (imports.ProductFeatureConfig.EnableUntestedFeedbackFeature) != 'undefined') {
        TitaniumFeatureConfig.EnableUntestedFeedbackFeature = imports.ProductFeatureConfig.EnableUntestedFeedbackFeature;
    }
    if (typeof (imports.ProductFeatureConfig.EnableFacebookAlertYourFriend) != 'undefined') {
        TitaniumFeatureConfig.EnableFacebookAlertYourFriend = imports.ProductFeatureConfig.EnableFacebookAlertYourFriend;
    }
    if (typeof (imports.ProductFeatureConfig.EnableSafeSearching) != 'undefined') {
        TitaniumFeatureConfig.EnableSafeSearching = imports.ProductFeatureConfig.EnableSafeSearching;
    }
}

/*
 * Configuration Area
 */

var C_TSRToolTipOffsetX = 7;
var C_TSRToolTipOffsetY = -3;

var C_TSRToolTipOverlapX = 0;
var C_TSRToolTipOverlapY = 40;

var C_TSRTotalToolTipWidthArea = g_oImgDefine.ImgSize.PopupBodySize.width + g_oImgDefine.ImgSize.Tail.width - C_TSRToolTipOverlapX;
var C_TSRTotalToolTipHeightArea = g_oImgDefine.ImgSize.PopupBodySize.height + g_oImgDefine.ImgSize.Tail.height - C_TSRToolTipOverlapY;

/*
 * Define global variable object
 */
var g_oEnv = {
    // Judge which browser been used by user
    Browser: {
        isIE: false,
        isFF: false,
        oBHOActiveX: null
    },
    Parser: {
        iResultNumber: 0,
        iRatingNumber: 0,
        rgobjSearchResult: [],
        iParserFlowID: 1
    },
    Tooltip: {
        isToolTipMove: false,
        iTSRTimerID: null,
        posTooltip: {
            posX: 0,
            posY: 0
        }
    },
    UMSTooltip: {
        iUMSHideTimerID: null,
        iUMSShowTimerID: null
    },
    BaseResourceUrl: ''
};
exports.g_oEnv = g_oEnv;

/*
 * Configuration variable using for Browser plugin
 */
var g_bisMouseOverShowToolTip = false;
var g_bisHighLight = true;
var g_iTSRToolTipTimeout = 300;
exports.g_iUMSToolTipTimeout = 1000;
exports.g_bEnableImageSafeSearch = false;

//fix Google Firefox re-icon issue;
var g_bIsNeedCheckSPan = true;

//Firefox 3.6.x don't show Alert Your Friend Feature
var g_bIsFirefoxLargerThan3_6_x = true;
exports.g_bIsFirefoxLargerThan3_6_x = g_bIsFirefoxLargerThan3_6_x;

/*
 * =========================
 * Browser Compatible Object
 * =========================
 */
var TMDOMObj = function (objDom) {
    if (document.all) {
        this.isIE = true;
        this.style.isIE = true;
    }
    this.objDom = objDom;
    this.style.objDom = objDom;
};

TMDOMObj.prototype.innerText = function () {
    return this.objDom.innerText || this.objDom.textContent || '';
};

TMDOMObj.prototype.getAttribute = function (strAttKey) {
    var objNodeSpecAtt = null;
    if (this.isIE) {
        if (this.objDom.attributes[strAttKey]) {
            objNodeSpecAtt = this.objDom.attributes[strAttKey].value;
        }
    } else {
        objNodeSpecAtt = this.objDom.getAttribute(strAttKey);
    }
    return objNodeSpecAtt;
};

TMDOMObj.prototype.style = {
    setFloat: function (strValue) {
        if (this.isIE) {
            this.objDom.style.styleFloat = strValue;
        } else {
            this.objDom.style.cssFloat = strValue;
        }
    },
    setMargin: function (strValue) {
        this.objDom.style.margin = strValue;
    }
};
exports.TMDOMObj = TMDOMObj;

function TMDOMEvent(objEvent) {
    if (document.all) {
        this.isIE = true;
    }
    this.objEvent = objEvent;
}

TMDOMEvent.prototype.target = function () {
    return this.objEvent.srcElement || this.objEvent.target;
};

TMDOMEvent.prototype.LeftButton = function () {
    var bIsLeft = false;
    if (this.isIE) {
        bIsLeft = (1 === this.objEvent.button);
    } else {
        bIsLeft = (0 === this.objEvent.button);
    }
    return bIsLeft;
};

function TSRHideToolTip() {
    /*
     * Hide ToolTip
     */
    var divToolTip = document.getElementById(D_TSRToolTipID);

    if (divToolTip) {
        //divToolTip.className = D_TSRToolTipHideClass;
        divToolTip.style.top = '-100000px';
        divToolTip.style.left = '-100000px';
    }
}

function TSRClearParseObjs() {
    var objParser = g_oEnv.Parser;
    /*
     * Hide tooltip
     */
    TSRHideToolTip();
    objParser.iResultNumber = 0;
    objParser.iRatingNumber = 0;
    objParser.rgobjSearchResult.length = 1;
}

function TSRappendAttribute(strKey, strValue) {
    var objAtt = {};

    objAtt.key = strKey;
    objAtt.value = strValue;
    this.attributes.push(objAtt);

    return objAtt;
}

function TSRcompareAttributes(objNode) {
    if (!objNode) {
        return false;
    }

    if (0 === this.attributes.length) {
        return true;
    }

    var objTMDom = new TMDOMObj(objNode);
    var iMatchCount = 0;
    for (var iAttCount = 0; iAttCount < this.attributes.length; iAttCount++) {
        var objAtt = this.attributes[iAttCount];
        var objNodeSpecAtt = objTMDom.getAttribute(objAtt.key);

        if (objNodeSpecAtt && objAtt.value) {
            var regexAttValue = new RegExp(objAtt.value, '');
            if (regexAttValue.test(objNodeSpecAtt)) {
                iMatchCount++;
            }
        } else if ((!objNodeSpecAtt || objNodeSpecAtt == 'null') && !objAtt.value) {
            iMatchCount++;
        } else {
            break;
        }
    }

    return (iMatchCount === this.attributes.length) ? true : false;
}

/*
 * Create a TSR located object
 * objDOMRoot           the root node of the tree which is searched
 * objTSRLocatedChild   the child LocatedObject for current Node
 * strTagName           the TagName of the specified tag
 * strObjID             the ID of the specified tag
 */
function CreateTSRLocatedObject(objDOMRoot, objTSRLocatedChild, strTagName, strObjID) {
    //Member variables for location dom object
    if (strTagName) {
        //TagName of the specified dobj
        this.tagName = strTagName.toUpperCase();
    }

    //ID of the specified dobj
    this.tagID = strObjID;

    //indexSource of parent.getElementsByTagName
    this.indexSource = -1;

    //Attributes array of the specified dobj
    this.attributes = [];

    this.tagIDregexFirst = false;
    this.multiMatches = (objTSRLocatedChild) ? false : true;

    this.rootElement = objDOMRoot;
    this.childLocated = objTSRLocatedChild;
}

exports.CreateTSRLocatedObject = CreateTSRLocatedObject;

function TSRFilterInvalidNode(nodes) {
    if (!nodes || !nodes.length) {
        return [];
    }
    var newNodes = [];
    var len = nodes.length;
    for (var i = 0; i < len; ++i) {
        var n = nodes[i];
        if ('href' in n) {
            try {
                var href = TSTrim(n.href);
                // omit the NULL href node
                if (href !== '') {
                    newNodes.push(n);
                }
                // only rating the http|https node
            } catch (e) {
                // omit node that raises the invalid argument
            }
        } else {
            if (n) {
                newNodes.push(n);
            }
        }
    }
    return newNodes;
}

/*
 * find the specified DOM node
 */
CreateTSRLocatedObject.prototype.findElement = function (rootElement) {
    if (rootElement) {
        this.rootElement = rootElement;
    }
    var rgTSRPath = (this.tagID) ? this.findElementByID() : this.findElementByTagName();

    var tempTSRPath = rgTSRPath;
    if (tempTSRPath) {
        rgTSRPath = [];
        for (var i = 0; i < tempTSRPath.length; i++) {
            var objTMDom = new TMDOMObj(tempTSRPath[i]);
            var objNodeStyle = objTMDom.getAttribute('style');
            var regexAttValue = new RegExp('display\\s*:\\s*none', 'i');
            if (!regexAttValue.test(objNodeStyle)) {
                rgTSRPath.push(tempTSRPath[i]);
            }
        }
    }

    if (rgTSRPath) {
        for (var iCount = 0; iCount < rgTSRPath.length; iCount++) {
            if (this.childLocated) {
                rgTSRPath[iCount].TSRChild = true;
                rgTSRPath[iCount].TSRLocatedSet = this.childLocated.findElement(rgTSRPath[iCount]);
            } else {
                rgTSRPath[iCount].TSRChild = false;
            }
        }
    }
    return rgTSRPath;
};

/*
 * find the specified DOM node by ID
 */
CreateTSRLocatedObject.prototype.findElementByID = function () {
    if (!this.tagID) {
        return null;
    }
    var rgTSRPath = [];
    var objNode = null;

    /*
     * If ID attribute has been descripted,
     * we will directly use it to locate object.
     */
    if (this.tagIDregexFirst && this.tagName) {
        var objNodes = this.rootElement.getElementsByTagName(this.tagName);
        var regexID = new RegExp(this.tagID, '');

        for (var iCount = 0; iCount < objNodes.length; iCount++) {
            objNode = objNodes[iCount];
            if (regexID.test(objNode.id)) {
                rgTSRPath.push(objNode);
                if (!this.multiMatches) {
                    break;
                }
            }
        }
        return (rgTSRPath.length > 0) ? rgTSRPath : null;
    } else {
        objNode = this.rootElement.getElementById(this.tagID);

        if (objNode) {
            rgTSRPath.push(objNode);
            this.tagName = objNode.tagName;
            return rgTSRPath;
        }
    }
    return null;
};

/*
 * find the specified DOM node by tagName and attributes
 */
CreateTSRLocatedObject.prototype.findElementByTagName = function () {
    if (!this.tagName) {
        return null;
    }

    /*
     * According to tagName, We get a object array of the same tagName
     * under rootElement
     */
    var iCount = 0;
    var rgobjNode = this.rootElement.getElementsByTagName(this.tagName);
    if (0 === rgobjNode.length) {
        return null;
    }

    var rgTSRPath = [];
    if (this.indexSource > -1 && rgobjNode[this.indexSource]) {
        rgTSRPath.push(rgobjNode[this.indexSource]);
        return rgTSRPath;
    }

    if (0 === this.attributes.length) {
        if (this.multiMatches) {
            for (iCount = 0; iCount < rgobjNode.length; iCount++) {
                rgTSRPath.push(rgobjNode[iCount]);
            }
        } else {
            rgTSRPath.push(rgobjNode[0]);
        }
        return rgTSRPath;
    }

    /*
     * Compare all attributes
     */
    for (iCount = 0; iCount < rgobjNode.length; iCount++) {
        var objNode = rgobjNode[iCount];

        /*
         * if this node is not leaf of the tree,
         * we just get the first element.
         */
        if (this.compareAttributes(objNode)) {
            rgTSRPath.push(objNode);

            if (!this.multiMatches) {
                break;
            }
        }
    }
    return (rgTSRPath.length > 0) ? rgTSRPath : null;
};

CreateTSRLocatedObject.prototype.appendAttribute = TSRappendAttribute;
CreateTSRLocatedObject.prototype.compareAttributes = TSRcompareAttributes;

/*
 * Create a TSR Sibling object
 */
function CreateTSRSiblingObject(strTagName) {
    //Member variables for location dom object
    //TagName of the specified dobj
    this.tagName = strTagName.toUpperCase();

    //Attributes array of the specified dobj
    this.attributes = [];

    //indexSource of parent.getElementsByTagName
    this.indexSource = -1;

    this.nodeElement = null;
}

CreateTSRSiblingObject.prototype.findSibling = function (objParent) {
    var iSkipCount = this.indexSource;
    var objNode = objParent;
    while (objNode) {
        if (this.tagName === objNode.tagName && this.compareAttributes(objNode)) {
            if (iSkipCount < 1) {
                this.nodeElement = objNode;
                return true;
            } else {
                iSkipCount--;
            }
        }

        objNode = objNode.nextSibling;
    }
    return false;
};

CreateTSRSiblingObject.prototype.appendAttribute = TSRappendAttribute;
CreateTSRSiblingObject.prototype.compareAttributes = TSRcompareAttributes;
exports.CreateTSRSiblingObject = CreateTSRSiblingObject;

/*
 * Create a TSR Result object
 */
function CreateTSRResultObject(objNode, strUrl, fnFindInsertNode, fnShowRatingResultUI, fnAdjustNodeStyle, noFilterImg, imageCallback, isImageNeedReRating) {
    if (!objNode || !strUrl) {
        return null;
    }

    var protocol = strUrl.indexOf('http://') == 0 ? 'http://' : (strUrl.indexOf('https://') == 0 ? 'https://' : null);
    if (protocol) {
        strUrl = protocol + punycode.toASCII(strUrl.slice(protocol.length));
    }

    if (imageCallback && isImageNeedReRating) {
        var imgRatedNode = TrendMicro.TB.GetImgRatedObject(objNode, g_oEnv.Parser.iResultNumber);
        if (imgRatedNode) {
            if (isImageNeedReRating(imgRatedNode) == false) {
                Debug.logDebug('imgRatedNode=' + imgRatedNode + ' in image rating queue, return');
                return null;
            }
            else {
                Debug.logDebug('Add to re-rating objNode=' + objNode);
                imgRatedNode.resulted = false;
            }
        }
        else {
            Debug.logDebug('Do not find ojNode=' + objNode + ' , need to rating.');
        }
    }
    else {
        if (TrendMicro.TB.InRatingQueue(objNode, g_oEnv.Parser.iResultNumber) || TrendMicro.TB.isRated(objNode)) {
            Debug.logDebug('objNode=' + objNode + ' InRatingQueue or isRated, return');
            return null;
        }
    }

    var objResult = {
        id: ++g_oEnv.Parser.iResultNumber,
        node: objNode,
        FindInsertNode: function () {
            return this.node;
        },
        AdjustNodeStyle: undefined,
        imageCallback: undefined
    };

    if (fnFindInsertNode) {
        objResult.FindInsertNode = fnFindInsertNode;
    }

    if (fnShowRatingResultUI) {
        objResult.ShowRatingResultUI = fnShowRatingResultUI;
    }

    if (fnAdjustNodeStyle) {
        objResult.AdjustNodeStyle = fnAdjustNodeStyle;
    }

    if (TitaniumFeatureConfig.EnableSafeSearching && imageCallback) {
        objResult.imageCallback = imageCallback;
    }

    var objTMDom = new TMDOMObj(objResult.node);
    objResult.text = objTMDom.innerText();

    try {
        objResult.link = decodeURI(strUrl);
    } catch (nErr) {
        objResult.link = strUrl;
    }

    var url_match_regex = /^(https?|ftps?):\/\/([\w%\-]+\.)+[\w%\-]+(\/[\w\- .\/?%&=]*)?/i;
    var url_to_test = encodeURI(objResult.link);
    if (!url_to_test.match(url_match_regex)) {
        return;
    }

    //not rating any image containing in the node
    var objElement = objResult.FindInsertNode();
    if (!noFilterImg && HasImageTag(objElement) && (!TitaniumFeatureConfig.EnableSafeSearching || !g_bEnableImageSafeSearch || !imageCallback)) {
        //do not support image
    } else {
        g_oEnv.Parser.rgobjSearchResult[objResult.id] = objResult;
    }

    return objResult;
}

exports.CreateTSRResultObject = CreateTSRResultObject;

/*
 * Common Util Function
 */

function HasImageTag(objElement) {
    var bIsImage = false;
    if (objElement && objElement.childNodes) {
        for (var i = 0; i < objElement.childNodes.length; ++i) {
            var aChild = objElement.childNodes[i];
            if (aChild && aChild.tagName && aChild.tagName.toUpperCase() === 'IMG') {
                bIsImage = true;
                break;
            }

            if (HasImageTag(aChild)) {
                return true;
            }
        }
    }

    return bIsImage;
}

function TSTrim(strText) {
    return strText.replace(/^\s+|\s+$/g, '');
}

exports.TSTrim = TSTrim;

function InsertURLProtocolString(strURL) {
    var strURL2 = TSTrim(strURL);
    return D_HTTP_PREFIX + strURL2 + '/';
}

exports.InsertURLProtocolString = InsertURLProtocolString;

function GetAllTSRLocatedNodes(rgDomRoot) {
    if (!rgDomRoot) {
        return null;
    }
    var rgNodes = [];
    for (var iCount = 0; iCount < rgDomRoot.length; iCount++) {
        if (rgDomRoot[iCount].TSRChild) {
            if (rgDomRoot[iCount].TSRLocatedSet) {
                var rgSubNodes = GetAllTSRLocatedNodes(rgDomRoot[iCount].TSRLocatedSet);
                rgNodes = rgNodes.concat(rgSubNodes);
            }
        } else {
            rgNodes.push(rgDomRoot[iCount]);
        }
    }
    rgNodes = TSRFilterInvalidNode(rgNodes);
    return rgNodes;
}

exports.GetAllTSRLocatedNodes = GetAllTSRLocatedNodes;

function TSRTagFlowID() {
    g_oEnv.Parser.rgobjSearchResult.FlowID = ++g_oEnv.Parser.iParserFlowID;
}

exports.TSRTagFlowID = TSRTagFlowID;


function TSRGetOffset(element) {
    if ('getBoundingClientRect' in document.documentElement) {
        //TrendMicro.TB.console.info('there is getBoundingClientRect');
        var elem = element;
        if (!elem || !elem.ownerDocument) {
            return null;
        }
        var box = null;
        try {
            box = elem.getBoundingClientRect();
        } catch (e) {
            return null;
        }

        var doc = elem.ownerDocument, docElem = doc.documentElement;

        // Make sure we're not dealing with a disconnected DOM node

        var body = doc.body,
            win = window,
            clientTop = docElem.clientTop || body.clientTop || 0,
            clientLeft = docElem.clientLeft || body.clientLeft || 0,
            scrollTop = win.pageYOffset || docElem.scrollTop || body.scrollTop,
            scrollLeft = win.pageXOffset || docElem.scrollLeft || body.scrollLeft,
            top = box.top + scrollTop - clientTop,
            left = box.left + scrollLeft - clientLeft;
        //TrendMicro.TB.console.info("top="+top+','+'left='+left);
        return {
            top: top,
            left: left
        };
    } else {
        var iOffsetX = 0, iOffsetY = 0;
        var objElement = element;
        var strDOMTagName = null;
        while (objElement) {
            iOffsetX += objElement.offsetLeft;
            iOffsetY += objElement.offsetTop;
            if (document.body === objElement || 'HTML' === objElement.nodeName) {
                break;
            }

            if (objElement.scrollTop) {
                iOffsetX -= objElement.scrollLeft;
                iOffsetY -= objElement.scrollTop;
            }
            strDOMTagName = objElement.nodeName;
            objElement = objElement.offsetParent;
        }
        //Default: Tooltip will be displayed at the right and top of ICON
        var iScrollTop;
        var iScrollLeft;
        var strTailXBG;
        var strTailYBG;

        iScrollTop = (document.documentElement.scrollTop > 0) ? document.documentElement.scrollTop : document.body.scrollTop;
        iScrollLeft = (document.documentElement.scrollLeft > 0) ? document.documentElement.scrollLeft : document.body.scrollLeft;
        if ('TD' === strDOMTagName || 'TH' === strDOMTagName) {
            // For IE8, those case,
            // they cannot correctly find offsetParent object.
            iOffsetX += iScrollLeft;
            iOffsetY += iScrollTop;
        }
        return {
            top: iOffsetY,
            left: iOffsetX
        };
    }
}

function TSRCalculateOffset(objSrcElement) {
    var posToolTip = {
        PosX: 0,
        BodyX: 0,
        TailX: 0,
        PosY: 0,
        BodyY: 0,
        TailY: 0,
        TailBG: null
    };
    var iOffsetX = 0;
    var iOffsetY = 0;

    if (!objSrcElement) {
        return posToolTip;
    }

    /*
     * Calculate top and left offset and the tooltip position
     * TOP:
     *      Distance is from documentElement.top to srcElement.top.
     *      We need to plus all offset of srcElement and its offsetParent.
     *      Finally, the top of position is that this distance subtract
     *      scrollTop of document.body.
     * LEFT:
     *      Distance is from documentElement.left to srcElement.left.
     *      We need to plus all offset of srcElement and its offsetParent.
     *
     */
    var pos = TSRGetOffset(objSrcElement);
    iOffsetX = pos.left;
    iOffsetY = pos.top;
    //TrendMicro.TB.console.info('iOffsetX='+iOffsetX);
    var iScrollTop;
    var iScrollLeft;
    var strTailXBG;
    var strTailYBG;

    iScrollTop = (document.documentElement.scrollTop > 0) ? document.documentElement.scrollTop : document.body.scrollTop;
    iScrollLeft = (document.documentElement.scrollLeft > 0) ? document.documentElement.scrollLeft : document.body.scrollLeft;

    posToolTip.PosX = iOffsetX + C_TSRToolTipOffsetX;
    posToolTip.BodyX = g_oImgDefine.ImgSize.Tail.width;
    posToolTip.TailX = 0;
    strTailXBG = 'Right';
    if (posToolTip.PosX + C_TSRTotalToolTipWidthArea >= document.body.clientWidth) {
        var iX = iOffsetX + C_TSRToolTipOffsetX - C_TSRTotalToolTipWidthArea;

        if (iX > iScrollLeft) {
            posToolTip.PosX = iX;
            posToolTip.BodyX = 0;
            posToolTip.TailX = g_oImgDefine.ImgSize.PopupBodySize.width;
            strTailXBG = 'Left';
        }
    }

    posToolTip.PosY = iOffsetY - C_TSRTotalToolTipHeightArea - C_TSRToolTipOffsetY;
    posToolTip.BodyY = 0;
    posToolTip.TailY = C_TSRTotalToolTipHeightArea - g_oImgDefine.ImgSize.Tail.height;
    strTailYBG = 'Top';
    if (posToolTip.PosY < iScrollTop) {
        posToolTip.PosY = iOffsetY + objSrcElement.offsetHeight + C_TSRToolTipOffsetY;
        posToolTip.BodyY = g_oImgDefine.ImgSize.Tail.height - C_TSRToolTipOverlapY;
        posToolTip.TailY = 0;
        strTailYBG = 'Bottom';
    }
    posToolTip.TailBG = strTailYBG + strTailXBG;

    return posToolTip;
}

/*
 * Get the rating result from Browser plugin about this URL link
 */
function TSREscapeURL(strURL) {
    // return g_oEnv.BaseResourceUrl + encodeURIComponent(strURL);
    return browser.extension.getURL(strURL);
}

exports.TSREscapeURL = TSREscapeURL;

/*
 * Show Untested URL report lightbox
 */
function TSRConstructUntestURLWindow(link) {
    var truncated_link = TSRTruncateText(link, false);
    var wordingList = g_oRatingLevelToolTipString['SiteSafetyReportString'];
    var strContent =

        '<div id="ID_TSRUntestURLWindow_Wrapper" class="TSRUntestURLWindow_Wrapper">' +
        '<div id="ID_TSRUntestURLWindow_Wrapper_closeButton" class="closeButton"></div>' +
        '<div class="titleArea">' + wordingList['Title'] + '</div>' +
        '<div class="addressArea">' +
        '<span class="title">' + wordingList['Address'] + '</span>' +
        '<span id="ID_TSRUntestURLWindow_Wrapper_webURL" class="webURL">' + truncated_link + '</span>' +
        '</div>' +
        '<div class="addressBelowSeperator">' +
        '</div>' +
        '<div class="siteOwnAndemailArea">' +
        '<div id="ID_TSRUntestURLWindow_Wrapper_siteOwner" class="siteOwner">' +
        '<div id="ID_TSRUntestURLWindow_Wrapper_siteOwner_input" class="siteOwner_input_notChecked"></div>' +
        '<div id="ID_TSRUntestURLWindow_Wrapper_siteOwner_inputWording" class="siteOwner_inputWording">' +
        wordingList['SiteOwnerCheckBox'] +
        '</div>' +
        '</div>' +
        '<input id="ID_TSRUntestURLWindow_Wrapper_emailAddress" class="emailAddress" type="text"></input>' +
        '<div id="ID_TSRUntestURLWindow_Wrapper_emailAddress_disabled" class="emailAddress TSRInputDisabled">' + wordingList['EmailAddressDefault'] + '</div>' +
        '</div>' +
        '<div class="descriptionArea">' +
        '<textarea id="ID_TSRUntestURLWindow_Wrapper_description" class="description" type="text"></textarea>' +
        '</div>' +
        '<div class="textAreaBelowSeperator">' +
        '</div>' +
        '<div class="footArea">' +
        '<div id="ID_TSRUntestURLWindow_Wrapper_logo" class="logo"></div>' +
        '<button id="ID_TSRUntestURLWindow_Wrapper_send" class="TSRUntestURLWindow_Wrapper_btn_red send">' + wordingList['SendButton'] + '</button>' +
        '</div>' +
        '</div>';

    return strContent;
}

function removeUntestURLOverlay() {
    var untestURLOverlay = document.getElementById("ID_TSRUntestURLWindow");
    document.body.removeChild(untestURLOverlay)
}

function TISProShowReport(objResult) {
    if (!'SiteSafetyReportString' in g_oRatingLevelToolTipString) {
        return null;
    }

    var wordingList = g_oRatingLevelToolTipString['SiteSafetyReportString'];

    var link = objResult.link;
    var divUntestURLWindow = document.createElement('DIV');

    divUntestURLWindow.id = "ID_TSRUntestURLWindow";
    divUntestURLWindow.className = "TSRUntestURLWindow";
    divUntestURLWindow.style.backgroundImage = 'url(' + TSREscapeURL("/images/overlay_background.png") + ')';

    var untestURLWindow = TSRConstructUntestURLWindow(link);
    if (!untestURLWindow) {
        Debug.logDebug.log("missing L10n files");
        return;
    }
    divUntestURLWindow.innerHTML = TSRConstructUntestURLWindow(link);

    document.body.appendChild(divUntestURLWindow);

    /*
        variable
    */
    var close_button = document.getElementById("ID_TSRUntestURLWindow_Wrapper_closeButton");
    var logo = document.getElementById("ID_TSRUntestURLWindow_Wrapper_logo");
    var send_button = document.getElementById("ID_TSRUntestURLWindow_Wrapper_send");
    var siteOwner = document.getElementById("ID_TSRUntestURLWindow_Wrapper_siteOwner");
    var siteOwnerInput = document.getElementById("ID_TSRUntestURLWindow_Wrapper_siteOwner_input");
    var webURL = document.getElementById("ID_TSRUntestURLWindow_Wrapper_webURL");
    var emailAddress = document.getElementById("ID_TSRUntestURLWindow_Wrapper_emailAddress");
    var emailAddress_disabled = document.getElementById("ID_TSRUntestURLWindow_Wrapper_emailAddress_disabled");
    var description = document.getElementById("ID_TSRUntestURLWindow_Wrapper_description");

    webURL.title = link;

    siteOwnerInput.style.backgroundImage = 'url(' + TSREscapeURL("/images/ic_checkbox.png") + ')';

    /*
        set email address status
    */
    emailAddress.style.display = "none";
    emailAddress.style.padding = '7px 0px 7px 10px';
    emailAddress.style.position = "absolute";
    emailAddress.style.top = "30px";
    emailAddress.style.left = "0px";
    emailAddress.style.border = "solid 1px"; // to fix windows xp firefox 29 bug. It will ignore this rule in css.
    emailAddress_disabled.style.display = "block";


    function hasClass(el, name) {
        return new RegExp('(\\s|^)' + name + '(\\s|$)').test(el.className);
    }

    function addClass(el, name) {
        if (!hasClass(el, name)) {
            el.className += (el.className ? ' ' : '') + name;
        }
    }

    function removeClass(el, name) {
        if (hasClass(el, name)) {
            el.className = el.className.replace(new RegExp('(\\s|^)' + name + '(\\s|$)'), ' ').replace(/^\s+|\s+$/g, '');
        }
    }

    var siteOwnerClass_checked = "siteOwner_input_checked";
    var siteOwnerClass_notChecked = "siteOwner_input_notChecked";
    siteOwner.onclick = function () {
        if (hasClass(siteOwnerInput, siteOwnerClass_checked)) {
            removeClass(siteOwnerInput, siteOwnerClass_checked);
            addClass(siteOwnerInput, siteOwnerClass_notChecked);
            emailAddress.style.display = "none";
            emailAddress_disabled.style.display = "block";
        } else {
            removeClass(siteOwnerInput, siteOwnerClass_notChecked);
            addClass(siteOwnerInput, siteOwnerClass_checked);
            emailAddress.style.display = "block";
            emailAddress_disabled.style.display = "none";
        }
    };

    description.style.padding = '10px 0px 0px 10px';

    /*
        set placeholder
    */

    function InitializeInputDom(dom, placeholder) {
        dom.value = placeholder;
        dom.onfocus = function () {
            if (this.value == placeholder) {
                this.value = '';
                addClass(this, "TSRUntestURLWindow_noPlaceHolder");
            }
        };
        dom.onblur = function () {
            if (this.value == '') {
                this.value = placeholder;
                removeClass(this, "TSRUntestURLWindow_noPlaceHolder");
            }
        };
    }

    var email_wording = wordingList['EmailAddressDefault'];
    var description_wording = wordingList['AddDescriptionDefault'];

    InitializeInputDom(emailAddress, email_wording);
    InitializeInputDom(description, description_wording);

    /*
        close button
    */
    close_button.style.backgroundImage = 'url(' + TSREscapeURL("/images/icon_close.png") + ')';
    close_button.onmouseover = function () {
        this.style.backgroundPosition = "0px 120px";
    };
    close_button.onmouseout = function () {
        this.style.backgroundPosition = "0px 0px";
    };
    close_button.onmousedown = function () {
        this.style.backgroundPosition = "0px 80px";
    };
    close_button.onclick = function () {
        removeUntestURLOverlay();
    };

    /*
        logo
    */
    logo.style.backgroundImage = 'url(' + TSREscapeURL("/images/ic_tmlogo_web.png") + ')';

    /*
        send
    */

    function setBackgroundColor(element, startColor, endColor) {
        try {
            element.style['filter'] = 'progid:DXImageTransform.Microsoft.gradient(startColorstr=\'' + startColor + '\', endColorstr=\'' + endColor + '\')';
        } catch (e) {

        }

        try {
            element.style['-ms-filter'] = 'progid:DXImageTransform.Microsoft.gradient(startColorstr=\'' + startColor + '\', endColorstr=\'' + endColor + '\')';
        } catch (e) {

        }

        try {
            element.style['background'] = 'linear-gradient(' + startColor + ', ' + endColor + ')';
        } catch (e) {

        }

        try {
            element.style['background'] = '-webkit-gradient(linear, 0 0, 0 100%, from(' + startColor + '), to(' + endColor + '))';
        } catch (e) {

        }

        try {
            element.style['background'] = '-moz-linear-gradient(top,  ' + startColor + ',  ' + endColor + ')';
        } catch (e) {

        }
    }

    setBackgroundColor(send_button, '#e44e56', '#db3d44');

    send_button.onmouseover = function () {
        setBackgroundColor(send_button, '#ee5e64', '#db3d44');
    };

    send_button.onmouseout = function () {
        setBackgroundColor(send_button, '#e44e56', '#db3d44');
    };

    send_button.onmousedown = function () {
        setBackgroundColor(send_button, '#db3d44', '#db3d44');
    };

    send_button.onclick = function () {
        var params = {
            url: link,
            site_owner: siteOwner.checked ? "1" : "0",
            email: email_wording == emailAddress.value ? "" : encodeURIComponent(emailAddress.value),
            description: description_wording == description.value ? "" : encodeURIComponent(description.value),
            score: "71"
        };

        if (typeof (Feedback2SiteSafety) != 'undefined') {
            Feedback2SiteSafety(params);
        } else if (TrendMicro.TB.IsIE()) {
            params["Action"] = 15;
            var oIEObject = TrendMicro.TB.GetIEObject(true);
            if (!oIEObject) {
                oIEObject = TrendMicro.TB.GetIEObject(false);
            }
            if (oIEObject) {
                oIEObject.ToolbarInvoke(params);
            }
        }
        removeUntestURLOverlay();
    }
}

/*
 * Change background and icon of tooltip to show detailed information
 */
function TSRChangeTooltip(objResult, posToolTip) {
    if (!objResult || objResult.level === undefined) {
        Debug.logDebug('objResult is undefined, objResult=' + objResult);
        return;
    }

    var divToolTipTail = document.getElementById(D_TSRToolTipTailID);
    var divToolTipBody = document.getElementById(D_TSRToolTipBodyID);
    var imgRatingIcon = document.getElementById(D_TSRToolTipIconID);
    var spanRatingString = document.getElementById(D_TSRToolTipRLStringID);
    var siteUrlString = document.getElementById(D_TSRToolTipSiteUrlID);

    var checkUrl = document.getElementById(D_TSRToolTipCheckUrlID);
    if (!divToolTipTail || !divToolTipBody || !imgRatingIcon || !spanRatingString) {
        return;
    }

    /*
     * Change background, Icon image, and Rating Level String
     */
    divToolTipBody.style.left = posToolTip.BodyX + D_PIXEL_UNIT;
    divToolTipBody.style.top = posToolTip.BodyY + D_PIXEL_UNIT;
    var strBgImg = 'url(' + TSREscapeURL(g_oRatingLevel[objResult.level].Tail[posToolTip.TailBG]) + ')';
    divToolTipTail.style.backgroundImage = strBgImg;
    divToolTipTail.style.left = posToolTip.TailX + D_PIXEL_UNIT;
    divToolTipTail.style.top = posToolTip.TailY + D_PIXEL_UNIT;
    divToolTipTail.style.visibility = 'visible';

    imgRatingIcon.src = TSREscapeURL(g_oRatingLevel[objResult.level].Content.Icon);
    spanRatingString.innerHTML = g_oRatingLevel[objResult.level].Content.LevelString;

    spanRatingString.style.color = g_oRatingLevel[objResult.level].Content.TextColor;
    siteUrlString.style.color = g_oRatingLevel[objResult.level].Content.SiteUrlColor;

    if (checkUrl) {
        checkUrl.onclick = function () {
            if (TitaniumFeatureConfig.EnableUntestedFeedbackFeature) {
                TSRHideToolTip();
                TISProShowReport(objResult);
            } else {
                window.open('http://sitesafety.trendmicro.com');
            }
        };
    }
    var divRLDetailed = document.getElementById(D_TSRToolTipRLDetailedID);
    var divRLDetailedShare = document.getElementById(D_TSRToolTipRLDetailedShareID);
    var divSiteName = document.getElementById(D_TSRToolTipSiteNameID);
    var divSiteUrl = document.getElementById(D_TSRToolTipSiteUrlID);
    if (!divRLDetailed || !divRLDetailedShare || !divSiteName || !divSiteUrl) {
        return;
    }

    /*
     * Change site name, site url, and detailed information
     * If status is no connection, we don't show site name and url.
     */
    var strSiteName = objResult.text;
    var strSiteUrl = objResult.link;

    divSiteName.innerHTML = htmlEncode(TSRTruncateText(strSiteName, true));
    divSiteName.title = strSiteName;
    divSiteUrl.innerHTML = htmlEncode(TSRTruncateText(strSiteUrl, false));
    divSiteUrl.title = strSiteUrl;

    divRLDetailed.innerHTML = g_oRatingLevel[objResult.level].Content.HelpString;

    if (objResult.level !== 5) {
        divRLDetailedShare.style.display = 'none';
    } else {
        divRLDetailedShare.style.display = 'block';
    }
    /*
        as the height will be different when show/not_show untest popup, need to re-assign it's top area.
    */
    if (posToolTip.BodyY == 0) {
        divToolTipBody.style.top = posToolTip.BodyY + (g_oImgDefine["ImgSize"]["PopupBodySize"]["height"] - divToolTipBody.offsetHeight) + D_PIXEL_UNIT;
    }
}

function TSRClearToolTipTimer() {
    if (g_oEnv.Tooltip.iTSRTimerID) {
        clearTimeout(g_oEnv.Tooltip.iTSRTimerID);
        g_oEnv.Tooltip.iTSRTimerID = null;
    }
}

function TSRSetToolTipTimer() {
    TSRClearToolTipTimer();
    g_oEnv.Tooltip.iTSRTimerID = setTimeout(TSRHideToolTip, g_iTSRToolTipTimeout);
}

function TSRConstructToolTipWindow() {
    var strContent =

        '<div id="' + D_TSRToolTipTailID + '" ></div>' +
        '<div id="' + D_TSRToolTipBodyID + '" >' +
        '<div id="TSRToolTipBodyContent" >' +
        '<img id="' + D_TSRToolTipIconID + '" >' +
        '<span id="' + D_TSRToolTipRLStringID + '" ></span>' +
        '<br style="clear:both;"/>' +
        '<p id="' + D_TSRToolTipSiteNameID + '" ></p>' +
        '<p id="' + D_TSRToolTipSiteUrlID + '" ></p>' +
        '<p id="' + D_TSRToolTipRLDetailedID + '" ></p>' +
        '<p id="' + D_TSRToolTipRLDetailedShareID + '" style="display:none;">' + g_oRatingLevelToolTipString.CheckUrlString + '</p>' +
        '</div>' +
        '<div id="' + D_TSRToolTipCloseSpanID + '" >' +
        '<div style="background-image:url(' + TSREscapeURL(g_oImgDefine.CloseIcon) + ')" id="' + D_TSRToolTipCloseID + '" >' +
        '</div>' +
        '</div>' +
        '<div id="' + D_TSRToolTipTitleID + '">' +
        '<img src="' + TSREscapeURL(g_oImgDefine.LogoIcon) + '" class="TSRLogoIcon">' +
        '<span class="TSRProductTitle">' +
        D_TSRToolTipTitleString +
        '</span>' +
        '</div>' +
        '</div>';

    return strContent;
}

function TSRInitToolTip(strBaseUrl, bMouseOver, bHighlight, iToolTipTimeout, bEnableImageSafeSearch, iUMSToolTipTimeout) {
    /*
     * Setting environment
     */
    g_oEnv.BaseResourceUrl = strBaseUrl;
    g_bisMouseOverShowToolTip = bMouseOver;
    g_bisHighLight = bHighlight;
    g_iTSRToolTipTimeout = iToolTipTimeout;
    if (typeof (bEnableImageSafeSearch) !== 'undefined') {
        exports.g_bEnableImageSafeSearch = bEnableImageSafeSearch;
        if (TrendMicro.TB.IsIE() &&
            typeof (TMExt_$) !== 'undefined' &&
            typeof (TMExt_$.browser) !== 'undefined' &&
            typeof (TMExt_$.browser.version) !== 'undefined' &&
            parseFloat(TMExt_$.browser.version) < 8) {
            //Image Filter don't support IE7 or lower
            exports.g_bEnableImageSafeSearch = false;
        }
    }
    if (typeof (iUMSToolTipTimeout) !== 'undefined') {
        exports.g_iUMSToolTipTimeout = iUMSToolTipTimeout;
    }
}

exports.TSRInitToolTip = TSRInitToolTip;

function TSRCreateTooltip() {
    var divToolTip = document.getElementById(D_TSRToolTipID);
    if (divToolTip) {
        return divToolTip;
    }

    divToolTip = document.createElement('DIV');

    var iToolTipWidth = C_TSRTotalToolTipWidthArea;
    var iToolTipHeight = C_TSRTotalToolTipHeightArea;

    divToolTip.id = D_TSRToolTipID;
    divToolTip.className = D_TSRToolTipShowClass;
    divToolTip.style.width = iToolTipWidth;
    divToolTip.style.height = iToolTipHeight;

    divToolTip.innerHTML = TSRConstructToolTipWindow();

    document.body.insertBefore(divToolTip, null);

    /*
     * Setting event handler
     */
    var divToolTipTail = document.getElementById(D_TSRToolTipTailID);
    var divToolTipBody = document.getElementById(D_TSRToolTipBodyID);
    divToolTipTail.onmouseout = TSRSetToolTipTimer;
    divToolTipTail.onmousemove = TSRClearToolTipTimer;
    divToolTipTail.onmouseover = TSRClearToolTipTimer;
    divToolTipBody.onmouseout = TSRSetToolTipTimer;
    divToolTipBody.onmousemove = TSRClearToolTipTimer;
    divToolTipBody.onmouseover = TSRClearToolTipTimer;

    /*
     * Setting event handler for closing tooltip
     */
    var imgCloseIcon = document.getElementById(D_TSRToolTipCloseID);

    imgCloseIcon.onclick = TSRHideToolTip;

    return divToolTip;
}

function TSRShowToolTip(event) {
    /*
     * Show ToolTip
     */
    event = event || window.event;
    var objDOMEvent = new TMDOMEvent(event);
    var bClickEvent = (event.type === 'click' || g_bisMouseOverShowToolTip);

    if (bClickEvent) {
        var divToolTip = TSRCreateTooltip();
        var iOffsetTop;
        var iOffsetLeft;

        /*
         * Depend on different browser to get which element to toggle event
         * IE uses srcElement, others use target
         */
        var objSrcElement = objDOMEvent.target();

        /*
         * Firefox 3.6.24- will use wrappedJSObject
         */
        var objResult = objSrcElement.TSRResult || objSrcElement.parentNode.TSRResult || objSrcElement.wrappedJSObject.TSRResult;

        /*
         * Disable timer to hide ToolTip
         */
        TSRClearToolTipTimer();

        /*
         * calculate top and left position of tooltip div and show it
         */
        var posToolTip = TSRCalculateOffset(objSrcElement);
        /*
         * Change background and content
         */
        TSRChangeTooltip(objResult, posToolTip);

        divToolTip.style.left = posToolTip.PosX + D_PIXEL_UNIT;
        divToolTip.style.top = posToolTip.PosY + D_PIXEL_UNIT;
        divToolTip.className = D_TSRToolTipShowClass;
    }
    event.cancelBubble = true;
    return false;
}

function TSRHightlightById(iResultID, bHighLight) {
    var objResult = g_oEnv.Parser.rgobjSearchResult[iResultID];
    if (objResult) {
        var strColor = D_TSRHIGHLIGHT_COLOR_OFF;

        if (bHighLight && g_oRatingLevel[objResult.level]) {
            strColor = g_oRatingLevel[objResult.level].Highlight;
        }

        var objElement = objResult.FindInsertNode();
        var bIsHighLight = true;
        if (objElement && objElement.childNodes) {
            for (var i = 0; i < objElement.childNodes.length; ++i) {
                var aChild = objElement.childNodes[i];
                if (aChild && aChild.tagName && aChild.tagName.toUpperCase() === 'DIV') {
                    bIsHighLight = false;
                    break;
                }
            }
        }

        //by default is undefined
        var bHighLightFromPattern = !objElement.NotHighLight;
        if (bHighLightFromPattern && bIsHighLight && objElement && objElement.style) {
            if(objElement.className === 'opr-recommends-merge-mask' ||
                objElement.className === 'opr-recommends-mask') {
                var r = parseInt(strColor.slice(1, 3), 16);
                var g = parseInt(strColor.slice(3, 5), 16);
                var b = parseInt(strColor.slice(5, 7), 16);
                strColor = 'rgba(' + r + ',' + g + ',' + b + ',' + '0.5)';
            }
            objElement.style.backgroundColor = strColor;
        }
    }
}

function TSRHighlight(bHighLight) {
    g_bisHighLight = bHighLight;
    for (var iCount = 1; iCount < g_oEnv.Parser.rgobjSearchResult.length; iCount++) {
        TSRHightlightById(iCount, bHighLight);
    }
}

function TSRMouseOverShowTips(bMouseOverShow) {
    g_bisMouseOverShowToolTip = bMouseOverShow;
}

function TSRInsertResultICON(iResultID, iRatedLevel, bPhishing) {
    if (!g_oEnv.Parser.rgobjSearchResult[iResultID] || !g_oRatingLevel[iRatedLevel] || TrendMicro.TB.isDocumentEditable()) {
        return;
    }
    var objResult = g_oEnv.Parser.rgobjSearchResult[iResultID];
    
    var url = arguments[3];
    if( url!=undefined && url!=objResult.link ){
        //log for AFM-2844;
        console.warn(`url = ${url}, objResult.link = ${objResult.link}`);
    }
    
    if (objResult.resulted) {
        // This URL has been rated.
        return;
    }
    objResult.resulted = true;
    g_oEnv.Parser.iRatingNumber++;

    objResult.level = iRatedLevel;
    objResult.phishing = bPhishing;

    if (objResult.imageCallback) {
        return objResult.imageCallback(objResult);
    }

    /*if (objResult.ShowRatingResultUI && !objResult.ShowRatingResultUI())
     {
     // At this level, don't show icon and high light on this URL.
     g_oEnv.Parser.rgobjSearchResult[iResultID] = null;
     return;
     }*/

    var spanIcon = null;
    if (objResult.spanIcon && objResult.spanIcon.nodeName === 'SPAN') {
        spanIcon = objResult.spanIcon;
    } else {
        spanIcon = document.createElement('SPAN');
    }

    objResult.spanIcon = spanIcon;

    spanIcon.className = 'TSRSpan';

    var objInsertNode = objResult.FindInsertNode();

    // Inserting Node didn't exist, Abort.
    if (!objInsertNode || !objInsertNode.parentNode) {
        //tbc_log('can not find insert node');
        return;
    }
    //tbc_log('can find insert node,node='+objInsertNode.innerHTML);
    //seems it has been done!! so skip, to fix the TT for firefox forward issue;

    if (g_bIsNeedCheckSPan) {
        if (objInsertNode.parentNode.childNodes && objInsertNode.parentNode.childNodes.length >= 2) {
            var childObj = objInsertNode.previousSibling;
            if (childObj && childObj.tagName === 'SPAN' && childObj.className === 'TSRSpan') {

                //If it has been rated, just return
                //Old way is to replace the new rating result
                //When under bad network, rating result will change
                //between True result and no response
                /*
                 childObj.id = D_TSRSpanIDPrefix +
                 parseInt(iResultID, 10);
                 childObj.onmouseout = TSRSetToolTipTimer;
                 childObj.onmouseover = TSRShowToolTip;
                 childObj.onclick = TSRShowToolTip;
                 childObj.TSRID = parseInt(iResultID, 10);
                 childObj.TSRResult = objResult;
                 if (childObj.childNodes)
                 {
                 var imgIcon = childObj.childNodes[0];
                 imgIcon.className = 'TSRWebRatingIcon';
                 imgIcon.src =
                 TSREscapeURL(g_oRatingLevel[iRatedLevel].
                 WebIcon);

                 }

                 if (g_bisHighLight)
                 {
                 TSRHightlightById(iResultID, g_bisHighLight);
                 }
                 */
                return;
            }

        }
    }

    objInsertNode.parentNode.insertBefore(spanIcon, objInsertNode);

    /*
     * Setting event handler
     */
    spanIcon.id = D_TSRSpanIDPrefix + parseInt(iResultID, 10);
    spanIcon.onmouseout = TSRSetToolTipTimer;
    spanIcon.onmouseover = TSRShowToolTip;
    spanIcon.onclick = TSRShowToolTip;
    spanIcon.TSRID = parseInt(iResultID, 10);
    spanIcon.TSRResult = objResult;
    var imgIcon = document.createElement('IMG');

    imgIcon.className = 'TSRWebRatingIcon';
    imgIcon.src = TSREscapeURL(g_oRatingLevel[iRatedLevel].WebIcon);

    imgIcon.style.width = g_oImgDefine.ImgSize.WarningIcon.width + 'px';
    imgIcon.style.height = g_oImgDefine.ImgSize.WarningIcon.height + 'px';
    imgIcon.style.border = '0px';
    spanIcon.appendChild(imgIcon);

    if (g_bisHighLight) {
        TSRHightlightById(iResultID, g_bisHighLight);
    }
    if (objResult.AdjustNodeStyle) {
        objResult.AdjustNodeStyle(objInsertNode);
    }

    //Insert Alert Friend Icon to supported SNS
    if (TitaniumFeatureConfig.EnableFacebookAlertYourFriend) {
        if (g_bIsFirefoxLargerThan3_6_x && typeof (TSNSInsertAlertICON) != 'undefined') {
            TSNSInsertAlertICON(objResult);
        }
    }
    if (true && typeof (TSNSFeedbackUnsafeURL) != 'undefined') {//TitaniumFeatureConfig.EnableFacebookAlertYourFriend
        TSNSFeedbackUnsafeURL(objResult);
    }
}


exports.TSRInsertResultICON = TSRInsertResultICON;

function UMSCreateTooltip() {
    if (TMExt_$('#UMS_TOOLTIP').length === 0) {
        var tooltip = TMExt_$('<div id="UMS_TOOLTIP"></div>');
        tooltip.css({
            'position': 'absolute',
            'cursor': 'pointer',
            'z-index': 2147483647,
            'background': 'transparent',
            'top': '-100000px',
            'left': '-100000px'
        });
        tooltip.appendTo(TMExt_$('body'));
    }

    return TMExt_$('#UMS_TOOLTIP');
}

exports.UMSCreateTooltip = UMSCreateTooltip;

function UMSClearToolHideTipTimer() {
    if (g_oEnv.UMSTooltip.iUMSHideTimerID) {
        clearTimeout(g_oEnv.UMSTooltip.iUMSHideTimerID);
        g_oEnv.UMSTooltip.iUMSHideTimerID = null;
    }
}

function TUMSCalculateOffset(objSrcElement) {
    var pos = TSRGetOffset(objSrcElement);
    var offsetLeft = pos.left - g_oImgDefine.ImgSize.WarningIcon.width;

    if (offsetLeft > 0) {
        pos.left = offsetLeft;
    }

    return pos;
}

function UMSShowToolTip() {
    var umsToolTip = UMSCreateTooltip();

    var objSrcElement = g_manual_rating.gCurrentEvent;
    /*
     * Disable timer to hide ToolTip
     */
    UMSClearToolHideTipTimer();

    /*
    * calculate top and left position of tooltip div and show it
    */
    //var posToolTip = TSRCalculateOffset(objSrcElement);
    var pos = TUMSCalculateOffset(objSrcElement);
    //(event.pageX + 12) (event.pageY + 12)
    umsToolTip[0].style.left = pos.left + D_PIXEL_UNIT;
    umsToolTip[0].style.top = pos.top + D_PIXEL_UNIT;

    return false;
}

function UMSHideToolTip() {
    var umsToolTip = TMExt_$('#UMS_TOOLTIP');
    // document.getElementById(D_TSRToolTipID);
    // need to move to TISProToolbarDefine.js

    if (umsToolTip.length !== 0) {
        umsToolTip[0].style.left = '-100000px';
        umsToolTip[0].style.top = '-100000px';

        var imgIcon = TMExt_$('#ums_img_tooltip');
        imgIcon.hide();
    }
}

function UMSSetToolTipShowTimer(global_manual_rating, url) {
    if (global_manual_rating.gMouseLeaveFlag === 1 && global_manual_rating.getCurrentNode() === url) {
        //last check if it's mouse is still on the node before show it.
        UMSShowToolTip();
    }
}

function UMSSetToolTipHideTimer() {
    UMSClearToolHideTipTimer();
    g_oEnv.UMSTooltip.iUMSHideTimerID = setTimeout(UMSHideToolTip, 500);
}

exports.UMSSetToolTipHideTimer = UMSSetToolTipHideTimer;

function UMSInsertResultICON(global_manual_rating, iRatedLevel, url) {
    if (global_manual_rating.gMouseLeaveFlag === 0 || global_manual_rating.getCurrentNode() !== url) {
        Debug.logDebug('Mouse is not in the node');
        //first check if it's mouse is still on the node
        return;
    }

    var target = global_manual_rating.getCurrentTarget();

    var objResult = {
        id: -1, //not used
        node: target[0],
        FindInsertNode: function () {
            return this.node;
        },
        AdjustNodeStyle: undefined
    };
    objResult.level = iRatedLevel;
    var strURL = objResult.node.href;
    try {
        objResult.link = decodeURIComponent(strURL);
    } catch (e) {
        objResult.link = strURL;
    }

    var objTMDom = new TMDOMObj(objResult.node);
    objResult.text = objTMDom.innerText() || strURL;

    UMSCreateTooltip();

    if (TMExt_$('#ums_img_tooltip').length === 0) {
        var umsTooltipImgIcon = TMExt_$("<img id='ums_img_tooltip' class='UMSRatingIcon' src=''/>");
        umsTooltipImgIcon.appendTo(TMExt_$('#UMS_TOOLTIP'));
    }

    var imgIcon = TMExt_$('#ums_img_tooltip');
    var imgIconTag = imgIcon[0];

    imgIconTag.src = TSREscapeURL(g_oRatingLevel[iRatedLevel].WebIcon);
    imgIconTag.style.width = g_oImgDefine.ImgSize.WarningIcon.width + 'px';
    imgIconTag.style.height = g_oImgDefine.ImgSize.WarningIcon.height + 'px';
    imgIconTag.style.border = '0px';

    imgIconTag.TSRID = -1;
    imgIconTag.TSRResult = objResult;

    UMSSetToolTipShowTimer(global_manual_rating, url);

    imgIcon.unbind();
    imgIcon.mouseout(function (event) {
        global_manual_rating.gMouseLeaveFlag = 0;
        TSRSetToolTipTimer();
        UMSSetToolTipHideTimer(event);
    });

    imgIcon.mouseover(function (event) {
        global_manual_rating.gMouseLeaveFlag = 1;
        TSRShowToolTip(event);
        UMSClearToolHideTipTimer();
    });

    imgIcon.click(function (event) {
        global_manual_rating.gMouseLeaveFlag = 1;
        TSRShowToolTip(event);
        UMSClearToolHideTipTimer();
    });

    imgIcon.show();
}

exports.UMSInsertResultICON = UMSInsertResultICON;

function TSRChangeResultICON(iResultID, iRatedLevel) {
    if (!g_oEnv.Parser.rgobjSearchResult[iResultID] || !g_oRatingLevel[iRatedLevel]) {
        return;
    }
    var objResult = g_oEnv.Parser.rgobjSearchResult[iResultID];

    if (!objResult.resulted) {
        // This URL has not been rated.
        return;
    }

    if (!objResult.orglevel) {
        objResult.orglevel = objResult.level;
    }
    objResult.level = iRatedLevel;

    var spanIcon = document.getElementById(D_TSRSpanIDPrefix + parseInt(iResultID, 10));
    if (!spanIcon) {
        return;
    }

    /*
     * Get Rating Icon
     */
    var imgIcon = spanIcon.firstChild;
    imgIcon.src = TSREscapeURL(g_oRatingLevel[iRatedLevel].WebIcon);
    TSRHightlightById(iResultID, g_bisHighLight);
}

function TSRIsFinishedSRRating() {
    return (g_oEnv.Parser.iRatingNumber === g_oEnv.Parser.iResultNumber);
}

function TSRGetRatingFlowID() {
    return g_oEnv.Parser.iParserFlowID;
}

exports.TSRGetRatingFlowID = TSRGetRatingFlowID;

/*************************************************
 * Utility Function                              *
 *************************************************/
function htmlEncode(strText) {
    var divNode = document.createElement('div');
    var textNode = document.createTextNode(strText);
    divNode.appendChild(textNode);
    return divNode.innerHTML;
}

function htmlDecode(strText) {
    var divNode = document.createElement('div');
    divNode.innerHTML = strText;
    return divNode.innerHTML;
}

function TSRTruncateText(strText, bWordBound) {
    var nStrIndex = TSRByteLength(strText, D_SITE_MSG_TRUNCATE_LIMIT - D_SITE_MSG_TRUNCATE_SUFFIC.length);
    if (nStrIndex > 0) {
        var strTruncatedText = strText.substr(0, nStrIndex);

        if (bWordBound) {
            var iPos = TSRFindSeparator(strTruncatedText);
            if (iPos > 0) {
                strTruncatedText = strTruncatedText.substr(0, iPos + 1);
            }
        }

        strTruncatedText += D_SITE_MSG_TRUNCATE_SUFFIC;
        return strTruncatedText;
    }
    return strText;
}

function TSRByteLength(strText, lLimitLength) {
    var byteSize = 255;
    var lCalcLen = 0;
    var nWideCount = 0;
    var nCapCount = 0;
    var nCutIndex = 0;

    for (var iIndex = 0; iIndex < strText.length; iIndex++, lCalcLen++) {
        var iCodeChar = strText.charCodeAt(iIndex);
        var cChar = strText.charAt(iIndex);

        // WideChar, each widechar supports that
        // it may be need two byte spaces
        if (byteSize < iCodeChar) {
            //lCalcLen += 1;
            nWideCount++;
            if (0 === nWideCount % 2) {
                lCalcLen += 3;
            }
        }

        // Upper Case Letter, three etters support
        // that it may be need four byte spaces
        else if (cChar >= 'A' && cChar <= 'Z') {
            nCapCount++;
            if (0 === nCapCount % 4) {
                lCalcLen++;
            }
        }

        if (lCalcLen > lLimitLength && nCutIndex <= 0) {
            nCutIndex = iIndex - 1;
            break;
        }
    }

    if (0 !== nWideCount % 2) {
        lCalcLen++;
    }
    return nCutIndex;
}

function TSRFindSeparator(strText) {
    var iIndex = 0;
    var strSeparators = ' -.:/|';

    for (iIndex = strText.length - 1; iIndex >= 0; iIndex--) {
        var iCodeChar = strText.charCodeAt(iIndex);
        var cChar = strText.charAt(iIndex);

        if (strSeparators.indexOf(cChar) > -1 || iCodeChar > 255) {
            return iIndex;
        }
    }

    return iIndex;
}

var TrendMicro = {};
TrendMicro.TB = {};
TrendMicro.TB = {};
TrendMicro.TB.console = {};
TrendMicro.TB.console.info = function (msg) {
    return;
};

TrendMicro.TB.extend = function (a, b) {
    for (var p in b) {
        a[p] = b[p];
    }
};
TrendMicro.TB.$ = function (id) {
    return document.getElementById(id);
};
TrendMicro.TB.Each = function (values, handler) {
    for (var i = 0, j = 0; j = values[i]; i++) {
        handler(j);
    }
};
TrendMicro.TB.reduce = function (elems, judgeFunction) {
    var results = [];
    for (var i = 0; i < elems.length; i++) {
        var j = elems[i];
        if (j && judgeFunction(j)) {
            results.push(j);
        }
    }
    return results;
};

TrendMicro.TB.TrimSpace = function (s) {
    return s.replace(/^\s*|\s*$/g, '');
};
TrendMicro.TB.FindChar = function (s, chars) {
    var i = 0;
    while (s.charAt(i) && -1 === chars.indexOf(s.charAt(i))) {
        ++i;
    }
    return s.charAt(i) ? {
        c: s.charAt(i),
        i: i
    } : {
        c: null,
        i: -1
    };
};
TrendMicro.TB.NodeListToArray = function (nodelist) {
    var results = [];
    for (var i = 0; i < nodelist.length && nodelist[i]; i++) {
        results.push(nodelist[i]);
    }
    return results;
};

TrendMicro.TB.hasClass = function (node, matchRule) {
    return ((' ' + node.className + ' ').indexOf(' ' + matchRule + ' ') !== -1);
};

TrendMicro.TB.$S = function (selector) {
    var selectorF = function (key, parent) {
        var results = [];
        if (key.substr(0, 1) === '#') {
            var elem = TrendMicro.TB.$(key.substr(1));
            results.push(elem);
        } else {
            if (key.substr(0, 1) === '.') {
                key = '*' + key;
            }
            var index = TrendMicro.TB.FindChar(key, '[');
            TrendMicro.TB.console.info('key=' + key + 'i=' + index.i + ',c=' + index.c);
            if (index.i === -1) {
                TrendMicro.TB.console.info('tag=' + key + ',parent=' + parent.innerHTML);
                results = TrendMicro.TB.NodeListToArray(parent.getElementsByTagName(key));
            } else if (index.c === '[') {
                var tag = key.substr(0, index.i);
                TrendMicro.TB.console.info('tag=' + tag + ',parent=' + parent + ',parent.getElementsByTagName(tag),' + parent.getElementsByTagName(tag).length);
                results = TrendMicro.TB.NodeListToArray(parent.getElementsByTagName(tag));
                var rightBracket = key.indexOf(']');
                if (-1 === rightBracket) {
                    throw 'can not find right bracket';
                }
                var sExtendRule = key.substring(index.i + 1, rightBracket);
                TrendMicro.TB.console.info('sExtendRule=' + sExtendRule);
                var sKV = sExtendRule.split('=');

                var name = sKV[0];
                var value = sKV[1];
                TrendMicro.TB.console.info('name=' + name + ',value=' + value);
                if (name && value) {
                    if (name === 'hasClass') {
                        TrendMicro.TB.console.info('results of get tag=' + results.length);
                        results = TrendMicro.TB.reduce(results, function (node) {
                            //TrendMicro.TB.console.info('TrendMicro.TB.hasClass(node,value)='+TrendMicro.TB.hasClass(node,value));
                            return TrendMicro.TB.hasClass(node, value);
                        });
                    } else if (name === 'custom') {
                        results = TrendMicro.TB.reduce(results, function (node) {
                            //return eval(value + '(node)');
                            console.error(`${value}(node) can't run!`);
                            return [];
                        });
                    }
                }
            }
        }
        return results;
    };

    var keys = selector.split(' ');
    var results = [];
    for (var i = 0; i < keys.length && keys[i]; i++) {
        var parents = results.length ? results : [document];
        results = [];
        var k = TrendMicro.TB.TrimSpace(keys[i]);
        for (var j = 0; j < parents.length && parents[j]; j++) {
            results = results.concat(selectorF(k, parents[j]));
        }
        if (!results.length) {
            break;
        }
    }

    return results;
};
TrendMicro.TB.isRated = function (node) {
    var _isRated = false;
    if (node && node.parentNode) {
        if (node.parentNode.childNodes && node.parentNode.childNodes.length >= 2) {
            var spanE = node.previousSibling;
            if (spanE && spanE.tagName === 'SPAN' && spanE.className === 'TSRSpan') {
                _isRated = true;
            }
        }
    }
    TrendMicro.TB.console.info('node=' + node + '_isRated=' + _isRated);
    return _isRated;
};

TrendMicro.TB.InRatingQueue = function (node, oldend) {
    var objs = g_oEnv.Parser.rgobjSearchResult;
    // error in here
    for (var i = oldend - 1; i >= 1; i--) {
        if (objs[i] && objs[i].node === node) {
            return true;
        }
        // in queue
    }
    return false;
};

TrendMicro.TB.InImageRatingQueue = function (node, oldend) {
    var objs = g_oEnv.Parser.rgobjSearchResult;
    // error in here
    for (var i = oldend - 1; i >= 1; i--) {
        if (objs[i] && objs[i].node === node && objs[i].resulted == true) {
            return true;
        }
        // in queue
    }
    return false;
};

TrendMicro.TB.GetImgRatedObject = function (node, oldend) {
    var objs = g_oEnv.Parser.rgobjSearchResult;
    // error in here
    for (var i = oldend - 1; i >= 1; i--) {
        if (objs[i] && objs[i].node === node && objs[i].resulted == true) {
            return objs[i];
        }
        // in queue
    }
    return null;
};

TrendMicro.TB.ReduceNewNode = function (start) {
    var objs = g_oEnv.Parser.rgobjSearchResult;
    var end = g_oEnv.Parser.rgobjSearchResult.length;
    for (var i = end - 1; i >= start; i--) {
        var n = objs[i] ? objs[i].node : undefined;
        if (n && TrendMicro.TB.isRated(n) || TrendMicro.TB.InRatingQueue(n, start)) {
            delete objs[i];
        }
    }

    var lastNode = end - 1;
    for (; lastNode >= start; lastNode--) {
        if (objs[lastNode] != undefined) {
            break;
        }
    }
    objs.length = lastNode + 1;

    g_oEnv.Parser.iResultNumber = objs.length <= 0 ? 0 : objs.length - 1;
};

TrendMicro.TB.ReduceImageNewNode = function (start) {
    var objs = g_oEnv.Parser.rgobjSearchResult;
    var end = g_oEnv.Parser.rgobjSearchResult.length;
    for (var i = end - 1; i >= start; i--) {
        var n = objs[i] ? objs[i].node : undefined;
        if (n && TrendMicro.TB.InImageRatingQueue(n, start)) {
            delete objs[i];
        }
    }

    var lastNode = end - 1;
    for (; lastNode >= start; lastNode--) {
        if (objs[lastNode] != undefined) {
            break;
        }
    }
    objs.length = lastNode + 1;

    g_oEnv.Parser.iResultNumber = objs.length <= 0 ? 0 : objs.length - 1;
};

TrendMicro.TB.FindTargetLinks = function (uriPattern, ratedLinkPath, options) {
    var options_ = {
        isRated: TrendMicro.TB.isRated,
        blacklist: []
    };
    if (options) {
        TrendMicro.TB.extend(options_, options);
    }
    var elems = TrendMicro.TB.$S(ratedLinkPath);

    //remove rated elements
    if (options_.blacklist.length) {
        var blackListReg = [];
        for (var i = options_.blacklist.length - 1; i >= 0; --i) {
            blackListReg.push(new RegExp(options_.blacklist[i], 'i'));
        }

        elems = TrendMicro.TB.reduce(elems, function (node) {
            try {
                var url = node && node.href;
                if (url) {
                    for (var i = options.blacklist.length - 1; i >= 0; --i) {
                        if (blackListReg[i].test(url)) {
                            return false;
                        }
                    }
                }
            } catch (e) {
                return false;
            }

            return true;
        });
    }
    elems = TrendMicro.TB.reduce(elems, function (node) {
        if (options_.isRated(node)) {
            return false;
        } else {
            var objs = g_oEnv.Parser.rgobjSearchResult;
            // error in here
            for (var i = 1, j = 0; j = objs[i]; ++i) {
                if (j && j.node === node) {
                    return false;
                }
                // in queue

            }
        }
        return true;
    });
    //
    TrendMicro.TB.console.info('elems=' + elems.length);
    return elems;
};

TrendMicro.TB.ClearResultedNode = function () {
    var reduceResultedNodes = function (list) {
        for (var i = 1, j = 0; j = list[i]; ++i) {
            if (j.resulted) {
                delete list[i];
            }
        }
    };
    reduceResultedNodes(g_oEnv.Parser.rgobjSearchResult);
    var reduceNodes = function () {
        var objs = g_oEnv.Parser.rgobjSearchResult;
        for (var i = objs.length - 1; i >= 0; i--) {

            if (objs[i] === undefined) {
                objs.length--;
            } else {
                break;
            }

        }
        g_oEnv.Parser.iResultNumber = objs.length <= 0 ? 0 : objs.length - 1;
    };
    reduceNodes();
};

/*!
 @brief
 @param urlPathPattern :
 @param selector :
 @param options {isRated:function(node){}  return true if node is rated
 ,}
 */
TrendMicro.TB.PagePattern = function (urlPathPattern, selector, options) {
    var options_ = {
        isRated: function (node) {
            var _isRated = false;
            if (node && node.parentNode) {
                if (node.parentNode.childNodes && node.parentNode.childNodes.length >= 2) {
                    var spanE = node.previousSibling;
                    if (spanE && spanE.tagName === 'SPAN' && spanE.className === 'TSRSpan') {

                        _isRated = true;
                    }
                }
            }
        }
    };
    if (options) {
        TrendMicro.TB.extend(options_, options);
    }
    this.urlPathPattern = urlPathPattern;
    this.selector = selector;
    this.options = options_;

};

TrendMicro.TB.TBSet = function () {
    //contain all the TSRLocatedNodes
    this.Nodes = [];

};

TrendMicro.TB.TBSet.prototype.getNodesCount = function () {
    return this.Nodes.length;
};

TrendMicro.TB.TBSet.prototype.isNodeExist = function (node) {
    var exist = false;
    for (var i = 0; i < this.Nodes.length; i++) {
        if (this.Nodes[i] === node) {
            exist = true;
            break;
        }
    }

    return exist;
};

TrendMicro.TB.TBSet.prototype.addNode = function (node) {
    var isExist = this.isNodeExist(node);

    if (!isExist) {
        this.Nodes.push(node);
    }
};

TrendMicro.TB.TBSet.prototype.createResultNodes = function (fnAdjustStyle, noFilterImg) {
    for (var i = 0; i < this.Nodes.length; i++) {
        CreateTSRResultObject(this.Nodes[i], this.Nodes[i].href, null, null, fnAdjustStyle, noFilterImg);
    }
};

TrendMicro.TB.TBSet.prototype.filterByHref = function (pattern) {
    if (!pattern) {
        return;
    }

    var ptn;
    var finalNodes = [];
    for (var i = 0; i < this.Nodes.length; i++) {
        if (!this.Nodes[i].href) {
            continue;
        }

        var match = false;
        for (var j = 0; j < pattern.length; j++) {
            ptn = new RegExp(pattern[j], '');
            if (ptn.test(this.Nodes[i].href)) {
                match = true;
                break;
            }
        }

        if (match) {
            continue;
        }
        finalNodes.push(this.Nodes[i]);
    }

    this.Nodes = finalNodes.slice(0);
};

TrendMicro.TB.TBSet.prototype.filterByContent = function (pattern) {
    if (!pattern) {
        return;
    }

    var ptn;
    var finalNodes = [];
    var content;
    for (var i = 0; i < this.Nodes.length; i++) {
        content = this.Nodes[i].innerHTML;
        if (!content) {
            continue;
        }

        var match = false;
        for (var j = 0; j < pattern.length; j++) {
            ptn = new RegExp(pattern[j], 'i');
            if (ptn.test(content)) {
                match = true;
                break;
            }
        }

        if (match) {
            continue;
        }
        finalNodes.push(this.Nodes[i]);
    }

    this.Nodes = finalNodes.slice(0);
};

TrendMicro.TB.isDocumentEditable = function (pattern) {
    var bodys = document.getElementsByTagName('body');
    var contenteditable = 'false';
    if (bodys.length > 0) {
        contenteditable = bodys[0].getAttribute('contenteditable');
    }
    var editable = (document.designMode === 'on') || contenteditable === '' || contenteditable === 'true';

    var enableEditBody = editable;
    return enableEditBody;
};

TrendMicro.TB.IsIE = function () {
    var isIE = false;
    try {
        isIE = (typeof (ActiveXObject) != 'undefined') || (typeof (new ActiveXObject("Microsoft.XMLHTTP")) != 'undefined');
    } catch (e) {
    }
    return isIE;
};

TrendMicro.TB.DOMIdExist = function (id) {
    if (document.getElementById(id)) {
        return true;
    }

    return false;
};

TrendMicro.TB.GetIEObject = function (useActiveX) {
    if (!TrendMicro.TB.IsIE()) {
        return false;
    }

    var _GetActiveXObject = function () {
        if (!window.g_oTMIEObject) {
            try {
                window.g_oTMIEObject = new ActiveXObject('ProToolbarIMRatingActiveX.ToolbarCB');
            } catch (e) {
                window.g_oTMIEObject = null;
            }
        }

        if (window.g_oTMIEObject &&
            typeof (window.g_oTMIEObject.ToolbarInvoke) != 'undefined' &&
            window.g_oTMIEObject.ToolbarInvoke({'test_key': 'test_value'}) != false) {
            return window.g_oTMIEObject;
        }

        return null;
    };

    var _GetExternalObject = function () {
        if (typeof (window.external.ToolbarInvoke) != 'undefined') {
            return window.external;
        }
        return null;
    };
    return useActiveX ? _GetActiveXObject() : _GetExternalObject();
};

/*
    Safe Searching (Image block)
*/
TrendMicro.TB.SAFESEARCHING = (function () {
    var ID_IMAGE_BLOCK_POPUP = "ID_TSRImageBlockPopup";
    var FADE_IN_TIME_INTEVAL = 200;

    var constructImageBlockPopup = function () {
        var strContent =

            '<div id="' + ID_IMAGE_BLOCK_POPUP + '" class="TSRImageBlock_Root">' +
            '<div class="TSRImageBlock_Wrapper">' +
            '<div class="TSRImageBlock_body">' +
            '<div class="TSRImageBlock_body_title">' +
            g_oSafeSearchingString["warnUserTitle"] +
            '</div>' +
            '<div class="TSRImageBlock_body_desc">' +
            g_oSafeSearchingString["reallyNeedToSeeUntilRestart"] +
            '</div>' +
            '</div>' +
            '<div class="TSRImageBlock_footer">' +
            '<div class="TSRImageBlock_footer_logo" style="background-image: url(' + TSREscapeURL("/images/PC_Icon_Guide_16.png") + ')">' +
            '</div>' +
            '<div class="TSRImageBlock_footer_productName">' +
            g_oSafeSearchingString["productName"] +
            '</div>' +
            '</div>' +
            '</div>' +
            '</div>';

        return TMExt_$(strContent);
    };

    var checkImageBlockPopupExist = function () {
        if (TMExt_$('#' + ID_IMAGE_BLOCK_POPUP).length === 0) {
            var popup = constructImageBlockPopup();
            popup.bind('mouseleave', function () {
                // console.log("mouseleave")
                TMExt_$(this).hide();
            });
            popup.find(".provide_password").bind('click', function () {
                if (typeof (SetTempImageSafeSearchStatus) !== 'undefined') {
                    SetTempImageSafeSearchStatus(function () {
                        location.reload();
                    });
                } else if (TrendMicro.TB.IsIE()) {
                    var params = {};
                    params["HTMLDocument"] = document;
                    params["Action"] = 18;
                    var oIEObject = TrendMicro.TB.GetIEObject(true);
                    if (!oIEObject) {
                        oIEObject = TrendMicro.TB.GetIEObject(false);
                    }
                    if (oIEObject) {
                        oIEObject.ToolbarInvoke(params);
                    }
                }
            });
            TMExt_$('body').append(popup);
        }
    };

    var reserve_distance = 5;

    var bindMouseEnterEvent = function ($obj) {
        $obj.bind('mouseenter', function () {
            // console.log("mouseenter")
            var TMExt_$popup = TMExt_$('#' + ID_IMAGE_BLOCK_POPUP);

            // reset style of this popup before show it to user
            TMExt_$popup.css("width", "auto");
            TMExt_$popup.css("height", "auto");

            // TMExt_$popup.show();
            TMExt_$popup.fadeIn(FADE_IN_TIME_INTEVAL, function () {

            });

            // set position
            var a_offset = TMExt_$(this).offset();
            var width_sub = (TMExt_$(this).width() - TMExt_$popup.width());
            var height_sub = (TMExt_$(this).height() - TMExt_$popup.height());

            var result_left = 0;
            var result_top = 0;
            /*
                set margin if necessary. In Yahoo image search, sometimes
                original image will be bigger than our popup. In this case, we need to set margin
                so that our popup can cover all original image
            */
            if (width_sub >= 0) {
                // original image is bigger than our popup on width
                TMExt_$popup.css("width", TMExt_$(this).width());

                // left
                result_left = a_offset.left;
            } else {
                TMExt_$popup.css("width", "auto");

                // left
                result_left = a_offset.left + width_sub / 2;
            }

            if (height_sub >= 0) {
                // original image is bigger than our popup on height
                TMExt_$popup.css("height", TMExt_$(this).height());

                // top
                result_top = a_offset.top;
            } else {
                // top
                result_top = a_offset.top + height_sub / 2;
            }

            // exceed left
            if (result_left < 0) {
                result_left = 0 + reserve_distance;
            }

            // exceed top
            if (result_top < 0) {
                result_top = 0 + reserve_distance;
            }

            // exceed right
            if ((result_left + TMExt_$popup.width()) > TMExt_$(document).width()) {
                var exceed_right = result_left + TMExt_$popup.width() - TMExt_$(document).width();
                result_left = result_left - exceed_right - reserve_distance;
            }

            TMExt_$popup.css("left", result_left);
            TMExt_$popup.css("top", result_top);
        })
    };

    var isNeedToBlock = function (level) {
        var block = 7, pcblock = 8;
        return level === block || level === pcblock;
    };

    var getParamFromURL = function (sourceURL, key) {
        try {
            var a = document.createElement('a');
            a.href = sourceURL;

            var paramsString = a.search;
            if (typeof (paramsString) == "string" && paramsString.length > 0) {
                paramsString = paramsString.substring(1);
                var paramsList = paramsString.split('&');
                for (var i = 0; i < paramsList.length; i++) {
                    var keyAndValue = paramsList[i].split('=');
                    if (keyAndValue[0] == key) {
                        return keyAndValue[1]
                    }
                }
            }
            return null;
        } catch (e) {
            return null;
        }
    };

    var assert = function (condition, message) {
        if (!condition && console && console.error) {
            console.error(message);
        }
    };

    /*
        110 < x            : use 110
        60 < x <= 110    : use 60
        16 < x <= 60    : use 16
        other            : use 16
    */
    var ImageBlockImgDefine = {
        defaultImg: "img_image_block_16_16.png",
        imgList: [
            {
                imgSize: 110,
                src: "img_image_block_110_110.png"
            }, {
                imgSize: 100,
                src: "img_image_block_100_100.png"
            }, {
                imgSize: 90,
                src: "img_image_block_90_90.png"
            }, {
                imgSize: 80,
                src: "img_image_block_80_80.png"
            }, {
                imgSize: 70,
                src: "img_image_block_70_70.png"
            }, {
                imgSize: 60,
                src: "img_image_block_60_60.png"
            }, {
                imgSize: 50,
                src: "img_image_block_50_50.png"
            }, {
                imgSize: 40,
                src: "img_image_block_40_40.png"
            }, {
                imgSize: 30,
                src: "img_image_block_30_30.png"
            }, {
                imgSize: 20,
                src: "img_image_block_20_20.png"
            }, {
                imgSize: 16,
                src: "img_image_block_16_16.png"
            }
        ]
    };

    var setBlockImage = function ($_obj) {
        var origin_min_width_height = $_obj.width() < $_obj.height() ? $_obj.width() : $_obj.height();

        var imageSrc = ImageBlockImgDefine.defaultImg;
        TMExt_$.each(ImageBlockImgDefine.imgList, function (index, item) {
            if (origin_min_width_height > item.imgSize) {
                imageSrc = item.src;
                return false;
            }
        });

        $_obj.css("background-image", 'url(' + TSREscapeURL(imageSrc) + ')');
        $_obj.css("background-repeat", "no-repeat");
        $_obj.css("background-position", "center center");
    };

    var TIME_OUT_REFRESH_BLOCK_IMAGE = 500;

    var refreshBlockImages = function (callback_first) {
        setTimeout(function () {
            _refreshBlockImages(function (item) {
                if (callback_first) {
                    callback_first(item);
                }
                setBlockImage(item);
            });
        }, TIME_OUT_REFRESH_BLOCK_IMAGE);
    };

    var _refreshBlockImages = function (callback) {
        // find elements with attr "link_level" and link_level needs to block
        var LINK_LEVEL = "link_level";

        var itemListWithLinkLevel = TMExt_$("[" + LINK_LEVEL + "]");
        for (var i = 0, len = itemListWithLinkLevel.length; i < len; i++) {
            var item = itemListWithLinkLevel.eq(i);

            var link_level = item.attr(LINK_LEVEL);
            if (isNeedToBlock(parseInt(link_level))) {
                callback(item);
            }
        }
    };

    return {
        ID_IMAGE_BLOCK_POPUP: ID_IMAGE_BLOCK_POPUP,
        constructImageBlockPopup: constructImageBlockPopup,
        checkImageBlockPopupExist: checkImageBlockPopupExist,
        bindMouseEnterEvent: bindMouseEnterEvent,
        isNeedToBlock: isNeedToBlock,
        getParamFromURL: getParamFromURL,
        assert: assert,
        setBlockImage: setBlockImage,
        refreshBlockImages: refreshBlockImages
    }
})();


exports.TrendMicro = TrendMicro;


///End   Import [import/PrivacyCommonComponent/CommonEngine/CheckRating/CREngine/TISProToolbarLib.js]
///End   Import [src/lib/TISProToolbarLib.js]

window.initTooltip = TSRInitToolTip;

///End   Import [src/lib/content_lib.js]
// });
