var g_manual_rating = {
//[data]
    gOnRatingTimer: null,
    gMouseLeaveFlag: 1,
    gCurrentEvent: null,
    gCurrentTarget: null,
    gCurrentNode: null,
    gUrlMap: [],
    gDoc: null,
    gToolTip: null,
    gLinkNum: -1,
    gLastLink: null,
    gIntervalThread: null,
    gTooltipTimeout: 0,
    gDocGuid: null,
//[data function]
//gCurrentTarget
    getCurrentTarget: function() {
        return this.gCurrentTarget;
    },
    setCurrentTarget: function(t) {
        this.gCurrentTarget = t;
    },
    isEditable: function() {
        //When body is editable, manual rating will not
        //work, as its inserted div will impact user normal function
        var contenteditable = TMExt_$('body').attr('contenteditable');
        var editable =
        (document.designMode == 'on') ||
        contenteditable == '' ||
        contenteditable == 'true';

        var punymce = TMExt_$('body#punymce').length != 0;
        var tinymce = TMExt_$('body#tinymce').length != 0;
        var enableEditBody =
        (editable) ||
        (punymce && punymce == true) ||
        (tinymce && tinymce == true);
        return enableEditBody;
    },
//gCurrentNode
    getCurrentNode: function() {
        return this.gCurrentNode;
    },
    setCurrentNode: function(n) {
        this.gCurrentNode = n;
    },
//gUrlMap
    getUrlMapLenth: function() {
        return this.gUrlMap.length;
    },
    getUrlMapValueByKey: function(url) {
        return this.gUrlMap[url];
    },
    getUrlMapValueByIndex: function(i) {
        return this.gUrlMap[i];
    },
    setUrlMapValue: function(url, retLevel) {
        this.gUrlMap[url] = retLevel;
    },
    pushUrlMapValue: function(url) {
        this.gUrlMap.push(url);
    },
//gDoc
    getDocument: function() {
        return this.gDoc;
    },
    setDocument: function(d) {
        this.gDoc = d;
    },
//gToolTip
    getToolTip: function() {
        return this.gToolTip;
    },
    setToolTip: function(t) {
        this.gToolTip = t;
    },
//gLinkNum
    canHookLink: function(link_len, alink) {
        if (link_len == this.gLinkNum && alink == this.gLastLink) {
            return false;
        }
        this.gLinkNum = link_len;
        this.gLastLink = alink;
        return true;
    },

//[functional function]
    callbackFromDoc: function(retLevel, url) {
        console.log('==> callbackFromDoc, url=' + url + ', retLevel=' + retLevel);

        if (!this.isEditable()) {
            UMSInsertResultICON(this, retLevel, url);
        }else {
            console.log('this page is editable, so is not rated.');
        }
    },

    isValidUrl: function(url) {
        var url_match_regex =
        /^(https?|ftps?):\/\/([\w%-]+\.)+[\w%-]+(\/[\w- .\/?%&=]*)?/i;
        var url_to_test = encodeURI(url);
        if (!url_to_test.match(url_match_regex)) {
            console.log(url_to_test + ' is invalid url');
            return false;
        }
        return true;
    },

    isUrlRated: function(url) {
        for (var i = 0; i < this.getUrlMapLenth(); ++i) {
            if (url == this.getUrlMapValueByIndex(i)) {
                return true;
            }
        }
        console.log(url + ' has not be rated.');
        this.pushUrlMapValue(url);
        return false;
    },

    getLocalUrlRule: function() {
        var rule = '^https?://(.*)';
        var s = document.location.hostname.split('.');
        var i = s.length < 5 ? (s.length == 2 ? 2 : s.length - 1) : 3;
        for (; i > 0; --i) {
            rule += '\\.' + s[s.length - i];
        }

        return rule;
    },

    isRated: function(target) {
        var ret = false;
        if (target.prev().attr('class') == 'TSRSpan' ||
            target.parent().prev().attr('class') == 'TSRSpan') {
            ret = true;
        }

        if (ret != true) {
            var children = target.children();
            for (var i = 0; i < children.length; ++i) {
                var child = TMExt_$(children[i]);
                if (child.attr('class') == 'TSRSpan') {
                    ret = true;
                    break;
                }
            }
        }

        if (ret == true) {
            console.log('It is a Rated link');
        }

        return ret;
    }
};

var Communicator = {
    UMS_SEND_DATA_EVENT: 'UMSSendDataEvent',
    UMS_EVENT_ID: 'UMSSendDataEventElement',
    UMS_TAG_NAME: 'UMSDataElement',
    UMS_BHOActiveX: null,
    D_TOOLBAR_CALLBACK_ACTIVEX_PROG_ID: 'ProToolbarIMRatingActiveX.ToolbarCB',

    init: function() {
        var element = Communicator.createElement();
    },

    createElement: function() {
        if ('createEvent' in document && !(document.all)) {
            if (!document.getElementById(Communicator.UMS_EVENT_ID)) {
                var element = document.createElement(Communicator.UMS_TAG_NAME);
                element.setAttribute('id', Communicator.UMS_EVENT_ID);
                document.documentElement.appendChild(element);
                return element;
            } else {
                return document.getElementById(Communicator.UMS_EVENT_ID);
            }
        } else {
            if (!Communicator.UMS_BHOActiveX) {
                Communicator.UMS_BHOActiveX =
                new ActiveXObject(Communicator.
                                  D_TOOLBAR_CALLBACK_ACTIVEX_PROG_ID);
            }
            return null;
        }
    },

    call: function(data) {
        // create or get our element
        var element = Communicator.createElement();
        if (element) {
            element.setAttribute('data', data);
            element.setAttribute('docguid', g_manual_rating.gDocGuid);
            // create and fire custom Event to notify extension
            var ev = document.createEvent('Event');
            ev.initEvent(Communicator.UMS_SEND_DATA_EVENT, true, false);
            element.dispatchEvent(ev);
        }else {
            console.log('start ToolbarInvoke url=' + data);
            Communicator.
            UMS_BHOActiveX.
            ToolbarInvoke({Action: 5, URL: data, HTMLDocument: document});
        }
    }
};

function TMExt_Hook_Link() {
    Communicator.init();
    UMSCreateTooltip();

    var on_rating_timer = null;
    TMExt_$('a').each(function() {
        if (TMExt_$(this)[0].UMSMouseEnterEventHandler &&
            TMExt_$(this)[0].UMSMouseEnterEventHandler == true) {
            return;
        }

        TMExt_$(this)[0].UMSMouseEnterEventHandler = true;
        TMExt_$(this).mouseenter(function(event) {
            try {
                var cur_target = TMExt_$(this);
                if (g_manual_rating.isRated(cur_target)) {
                    return;
                }
                var cur_node = null;
                try {
                    cur_node = decodeURI(cur_target[0].href || '');
                }catch (e) {
                    try {
                        cur_node = encodeURI(cur_target[0].href || '');
                    }catch (e) {
                        try {
                            cur_node = cur_target[0].href;
                        }catch (e) {
                            cur_node = null;
                        }
                    }
                }
                if (!cur_node) {
                    console.log('just return: href is null');
                    return;
                }
                console.log('mouseenter href=' + cur_node);

                //trim space
                cur_node = TSTrim(cur_node);

                /*  filter local url
                 *  var curUrlRuleStr = g_manual_rating.getLocalUrlRule();
                 *  var rule = new RegExp(curUrlRuleStr, "i");
                 *  if (rule.test(cur_node)){
                 *      console.log("[local link]");
                 *      return;
                 *  }
                 */

                if (!g_manual_rating.isValidUrl(cur_node)) {
                    console.log('just return: href is invalid:' +
                                          cur_node);
                    g_manual_rating.setCurrentNode(null);
                    return;
                }

                g_manual_rating.setCurrentTarget(cur_target);

                g_manual_rating.setDocument(document);
                g_manual_rating.setCurrentNode(cur_node);
                g_manual_rating.gMouseLeaveFlag = 1;

                var umsTooltipTimeout = 2000;
                g_manual_rating.gOnRatingTimer = setTimeout(function() {
                    console.log('timeout start rating');
                    g_manual_rating.gOnRatingTimer = 0;
                    g_manual_rating.gCurrentEvent = cur_target[0];
                    Communicator.call(cur_node);
                }, umsTooltipTimeout);

                if (TMExt_$(this)[0].UMSMouseLeaveEventHandler &&
                    TMExt_$(this)[0].UMSMouseLeaveEventHandler == true) {
                    return;
                }

                TMExt_$(this)[0].UMSMouseLeaveEventHandler = true;
                TMExt_$(this).mouseleave(function(event) {
                if (g_manual_rating.gOnRatingTimer) {
                    console.log('clear rating time out');
                    clearTimeout(g_manual_rating.gOnRatingTimer);
                    g_manual_rating.gOnRatingTimer = 0;
                    }else {
                        UMSSetToolTipHideTimer();
                        g_manual_rating.gMouseLeaveFlag = 0;
                        g_manual_rating.setCurrentNode(null);
                    }
                });
            }catch (e) {
                if (e.number && e.description) {
                    //IE
                    var err_msg = 'catch err:[\n';
                    err_msg += 'Facility Code: ' +
                        (e.number >> 16 & 0x1FFF) +
                        '\n';
                    err_msg += 'Number: ' + (e.number & 0xFFFF) + '\n';
                    err_msg += 'Description: ' + e.description + '\n';
                    console.log(err_msg);
                }else {
                    //chrome & FireFox
                    console.log(e);
                }
            }
        });
    });
}

function tmb_onRatingSingleURL(aData, url, retLevel, bPhishing) {
    console.log('tmb_onRatingSingleURL url=' +
                          url +
                          'ret=[ ' +
                          retLevel + ' ]');
    g_manual_rating.callbackFromDoc(retLevel, url);
}

function TMExt_UMS_Start() {
    try {
        TMExt_Hook_Link();

        if (g_manual_rating.gMouseLeaveFlag == 0) {
            UMSSetToolTipHideTimer();
        }
    }catch (e) {
        if (e.number && e.description) {
            //IE
            var err_msg = 'catch err:[\n';
            err_msg += 'Facility Code: ' + (e.number >> 16 & 0x1FFF) + '\n';
            err_msg += 'Number: ' + (e.number & 0xFFFF) + '\n';
            err_msg += 'Description: ' + e.description + '\n';
            console.log(err_msg);
        }else {
            //chrome & FireFox
            console.log(e);
        }
    }

    setTimeout(TMExt_UMS_Start, 2000);
}

function TMExt_UMS_CallbackForIE()
{
    try {
        if (typeof(g_oUMS_BHOActiveX) == 'undefined') {
            g_oUMS_BHOActiveX =
                new ActiveXObject(D_TOOLBAR_CALLBACK_ACTIVEX_PROG_ID);
        }
    }catch (e) {
        return undefined;
    }
    return g_oUMS_BHOActiveX;
}

TMExt_$(document).ready(function() {
    if (!g_manual_rating.isEditable()) {
        console.log('manual rating document.ready TMExt_UMS_Start');
        TMExt_UMS_Start();

        //For IE10 Callback
        var callback = TMExt_UMS_CallbackForIE();
        if (callback) {
            callback.ToolbarInvoke({Action: 12, HTMLDocument: document});
        }
    }else {
        console.log('this page is editable, so is not rated.');
    }
});


Communicator.call = function(data) {
    //data is url for rated.
    var url = {
        id: -1,
        url: data
    };

    var message = {
        cmd: 'rateItems',
        params: {
            urls: [url],
            type: 'ManualScanner'
        }
    };

    browser.runtime.sendMessage(message, function(response) {
	    console.log('loadPagePattern', '<== sendMessage, response=' + JSON.stringify(response));
        var results = response.results;
        console.log(results);
        if (results.length != 1) {
            Debug.logError('manualscan', 'the length of results' + ' must be equal to 1');
        } else {
            g_manual_rating.callbackFromDoc(results[0].level, data);
        }
    });
};

console.log("[all frame] inject manualscan.js done.");

