var TAG = "popup";
var setting = browser.extension.getBackgroundPage().window.setting;
var server = browser.extension.getBackgroundPage().window.server;
var Debug = browser.extension.getBackgroundPage().window.log;

var g_fb_email = "";
var g_fb_setting = {};

function init(setting) {

	// localize popup
	$('#automaticscan, #manualscanner, #fraud_buster,#setting, #help, #privacyscanner')
		.each(function (i, htmlItem) {
			var item = $(htmlItem);
			item.attr('title', setting.popupWordings[item.attr('title')]);
			var menuText = item.find('span');
			menuText.text(setting.popupWordings[menuText.text()]);
		});

	// sync setting with server
	var syncSetting = function () {
		if (setting.EnableAutomaticScan) {
			$('#automaticscan').addClass('checked');
		} else {
			$('#automaticscan').removeClass('checked');
		}

		if (setting.EnableManualScanner) {
			$('#manualscanner').addClass('checked');
		} else {
			$('#manualscanner').removeClass('checked');
		}

		//for fraud buster start
		//$('#fraud_buster').attr("class","itemDisable");
		//popupShow($('#fraud_buster'));
		//for fraud buster end

		var items = '#automaticscan,#manualscanner,#fraud_buster,#setting,#help,#privacyscanner'.split(',');
		if (setting._disableIcon) {
			$.each(items, function (i, item) {
				$(item).addClass('disabled');
			});
		} else {
			$.each(items, function (i, item) {
				$(item).removeClass('disabled');
			});
		}
	};

	syncSetting();

	var getOnClickFunction = function (data) {
		return function () {
			if (!setting._disableIcon) {
				browser.runtime.sendMessage(data);
			}
			closePopup();
		};
	};

	$('#automaticscan').off('click').on('click', getOnClickFunction({
		event: 'popupItemClick',
		item: 'automaticscan'
	}));
	$('#manualscanner').off('click').on('click', getOnClickFunction({
		event: 'popupItemClick',
		item: 'manualscanner'
	}));
	$('#privacyscanner').off('click').on('click', getOnClickFunction({
		event: 'popupItemClick',
		item: 'privacyscanner'
	}));
	$('#setting').off('click').on('click', getOnClickFunction({
		event: 'popupItemClick',
		item: 'setting'
	}));
	$('#help').off('click').on('click', getOnClickFunction({
		event: 'popupItemClick',
		item: 'help'
	}));
	$('#fraud_buster').off('click').on('click',function(){
		if($('#fraud_buster').hasClass('disabled') ||
    		$('#fraud_buster').hasClass('itemDisable')){
    		return ;
    	}
    	//popupOnClick();
	});

	$('#menu').css('display', 'inline');
	$('#prompt').css('display', 'none');
}

function closePopup() {
	window.close();
}

server._loadSetting(function (setting) {
	Debug.logDebug(TAG, 'setting=' + JSON.stringify(setting));
	setting = browser.extension.getBackgroundPage().window.setting;
}, function () {
	Debug.logError(TAG, 'load setting failed, use default setting and disable settings');
	setting = browser.extension.getBackgroundPage().window.setting;
	setting._disableIcon = true;
});

init(setting);