var exports = window;
exports.log = (function() {
    var logLevel = {debug: 0, info: 1, warning: 2, error: 3};
    var buildLogFunction = function(levelKey, logLevel) {
        if (logLevel[levelKey] >= logLevel.current) {
            return function(tag, message) {
                var sMsg = levelKey + ', ';

                if (message === undefined) {
                    sMsg += message;    // output message without tags
                } else {
                    sMsg += '[' + tag + '], ' + message; 
                }
                console.log(sMsg);
            };
        } else {
            return function() {};
        }
    };

    var log = {};
    var setLogLevel = function(level) {
        logLevel.current = (typeof level === 'number') ? level : logLevel.warning;
        log.logInfo = buildLogFunction('info', logLevel);
        log.logDebug = buildLogFunction('debug', logLevel);
        log.logWarning = buildLogFunction('warning', logLevel);
        log.logError = buildLogFunction('error', logLevel);
    };
    setLogLevel(logLevel.logInfo);
    
    return log;
}());
