/*global exports: true, require: true*/
var exports = window;
var TMExt_$ = window.TMExt_$;

var DefaultSetting = {
    tooltip: {timeout: 1000},
    lastModifyTime: 0,
    EnableManualScanner: false,
    EnableAutomaticScan: true,
    Promotion: {
        ShowFaceBookPromotion: true,
        ShowTwitterPromotion: true,
        ShowLinkedInPromotion: true
    },
    serverStopped: false,
    LicenseExpired: false,
    ToolbarEnableStatus: true,
    supportedLocale: ['en', 'ja', 'fr', 'de', 'zh_TW', 'es', 'zh_CN']
};

DefaultSetting.supportedLocale = ['de', 'en', 'es', 'fr', 'ja', 'zh_CN', 'zh_TW'];

var Setting = function() {
    TMExt_$.extend(this, DefaultSetting);
};

// Setting.prototype.load = function() {
// Debug.logDebug('begin load setting');
// TMExt.server._loadSetting();
// };

Setting.prototype.update = function(newSetting) {
    // TMExt_$.extend(true, this, newSetting);
    for (var property in newSetting) {
        this[property] = newSetting[property];
    }
    if (this.onSettingChanged) {
        this.onSettingChanged();
    }
};

Setting.prototype.getLastModifyTime = function() {
    return this.lastModifyTime;
};

Setting.prototype.onSettingChanged = function() {
    var disableIcon = this.LicenseExpired || !this.ToolbarEnableStatus ||
        this.serverStopped;
    this._disableIcon = disableIcon;
};

Setting.getDefault = function() {
    var defaultSetting = {};

    return TMExt_$.extend(defaultSetting, DefaultSetting);
};

Setting.getSupportedLocales = function() {
    return DefaultSetting.supportedLocale;
};

exports.Setting = Setting;
